#!/bin/bash

# Version 02/07/2012
# $Revision: 1.5 $
# UDA'Software 2010

# Questo script serve per inviare un testo sul sito PasteBin,
# ricavarne l'url ed inviarlo alla sessione corrente.

################################################################################
#_______________________________________________________________________________
echo "${0} ${*}" >&2

# ____________________________________________________________________
# Funzioni per la gestione del file di configurazione
# ____________________________________________________________________
function get_var() {
    get_var=""
    
    if [ -f ${config_file} ]; then
	get_var=$(grep -F "${1}" "${config_file}" | tail -n1 | awk '{print $2}')
    fi
    
    if [ "${get_var}" == "" ]; then
	get_var="${2}"
    fi
    
    export ${1}="${get_var}"
}

# ____________________________________________________________________
function set_var() {
    printf '%s %s\n' "${1}" "${2}" >> "${config_file}"
}

# ____________________________________________________________________
function load_config() {
    get_var PASTEBIN_FORMAT text
    get_var PASTEBIN_RETAIN 1D
    
    rm -f "${config_file}"

    set_var PASTEBIN_FORMAT "${PASTEBIN_FORMAT}"
    set_var PASTEBIN_RETAIN "${PASTEBIN_RETAIN}"
}

################################################################################
#_______________________________________________________________________________

# Check-up step
check_step=5

# Check-up timeout
check_timeout=300

# URL dove inviare i dati
nopaste_URL="http://pastebin.com/api/api_post.php"

# Development Key
api_dev_key="548aec8fbff11276bc48753fcbca1a3e"

# Encoding dell'END OF LINE
EncodeEOL=no

# Durate disponibili
api_paste_expire_date="N	Illimitata
10M	10 Minuti
1H	1 Ora
1D	1 Giorno
1M	1 Mese"

# Formati disponibili
api_paste_format="abap	ABAP
actionscript	ActionScript
actionscript3	ActionScript 3
ada	Ada
apache	Apache Log
applescript	AppleScript
apt_sources	APT Sources
asm	ASM (NASM)
asp	ASP
autoit	AutoIt
avisynth	Avisynth
bash	Bash
basic4gl	Basic4GL
bibtex	BibTeX
blitzbasic	Blitz Basic
bnf	BNF
boo	BOO
bf	BrainFuck
c	C
c_mac	C for Macs
cill	C Intermediate Language
csharp	C#
cpp	C++
caddcl	CAD DCL
cadlisp	CAD Lisp
cfdg	CFDG
klonec	Clone C
klonecpp	Clone C++
cmake	CMake
cobol	COBOL
cfm	ColdFusion
css	CSS
d	D
dcs	DCS
delphi	Delphi
dff	Diff
div	DIV
dos	DOS
dot	DOT
eiffel	Eiffel
email	Email
erlang	Erlang
fo	FO Language
fortran	Fortran
freebasic	FreeBasic
gml	Game Maker
genero	Genero
gettext	GetText
groovy	Groovy
haskell	Haskell
hq9plus	HQ9 Plus
html4strict	HTML
idl	IDL
ini	INI file
inno	Inno Script
intercal	INTERCAL
io	IO
java	Java
java5	Java 5
javascript	JavaScript
kixtart	KiXtart
latex	Latex
lsl2	Linden Scripting
lisp	Lisp
locobasic	Loco Basic
lolcode	LOL Code
lotusformulas	Lotus Formulas
lotusscript	Lotus Script
lscript	LScript
lua	Lua
m68k	M68000 Assembler
make	Make
matlab	MatLab
matlab	MatLab
mirc	mIRC
modula3	Modula 3
mpasm	MPASM
mxml	MXML
mysql	MySQL
nsis	NullSoft Installer
oberon2	Oberon 2
objc	Objective C
ocaml-brief	OCalm Brief
ocaml	OCaml
glsl	OpenGL Shading
oobas	Openoffice BASIC
oracle11	Oracle 11
oracle8	Oracle 8
pascal	Pascal
pawn	PAWN
per	Per
perl	Perl
php	PHP
php-brief	PHP Brief
pic16	Pic 16
pixelbender	Pixel Bender
plsql	PL/SQL
povray	POV-Ray
powershell	Power Shell
progress	Progress
prolog	Prolog
properties	Properties
providex	ProvideX
python	Python
qbasic	QBasic
rails	Rails
rebol	REBOL
reg	REG
robots	Robots
ruby	Ruby
gnuplot	Ruby Gnuplot
sas	SAS
scala	Scala
scheme	Scheme
scilab	Scilab
sdlbasic	SdlBasic
smalltalk	Smalltalk
smarty	Smarty
sql	SQL
tsql	T-SQL
tcl	TCL
tcl	TCL
teraterm	Tera Term
text	Testo
thinbasic	thinBasic
typoscript	TypoScript
unreal	unrealScript
vbnet	VB.NET
verilog	VeriLog
vhdl	VHDL
vim	VIM
visualprolog	Visual Pro Log
vb	VisualBasic
visualfoxpro	VisualFoxPro
whitespace	WhiteSpace
whois	WHOIS
winbatch	Win Batch
xml	XML
xorg_conf	Xorg Config
xpp	XPP
z80	Z80 Assembler"

################################################################################
# Calcola il percorso dello script ed altre variabili __________________________
script_path=$(echo ${0} | sed 's@/buduscript_script__pastebin.sh@@')
user_home=$(echo "${HOME}" | tr [:punct:] '_')
pastebin_output=/tmp/budus_PASTEBIN_${user_home}.out

# ____________________________________________________________________
# Carica la configurazione.
# ____________________________________________________________________
config_file="${HOME}/.xchat2/buduscript/pastebin.config"
load_config

################################################################################
# Verifica se deve creare il menu di PasteBin __________________________________
if [ "${1}" == "MENU" ]; then
    cat<<EOF
/MENU ADD "BuDuScRiPt/PasteBin System - Incolla un testo su PasteBin e mostra LINK/Invia un PASTE di tipo Default" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__pastebin.sh NEWPASTE"
/MENU ADD "BuDuScRiPt/PasteBin System - Incolla un testo su PasteBin e mostra LINK/-"
/MENU ADD "BuDuScRiPt/PasteBin System - Incolla un testo su PasteBin e mostra LINK/Invia un PASTE di tipo Testo" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__pastebin.sh NEWPASTE text"
/MENU ADD "BuDuScRiPt/PasteBin System - Incolla un testo su PasteBin e mostra LINK/Invia un PASTE di tipo Bash" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__pastebin.sh NEWPASTE bash"
/MENU ADD "BuDuScRiPt/PasteBin System - Incolla un testo su PasteBin e mostra LINK/Invia un PASTE di tipo C" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__pastebin.sh NEWPASTE c"
/MENU ADD "BuDuScRiPt/PasteBin System - Incolla un testo su PasteBin e mostra LINK/Invia un PASTE di tipo HTML" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__pastebin.sh NEWPASTE html4strict"
/MENU ADD "BuDuScRiPt/PasteBin System - Incolla un testo su PasteBin e mostra LINK/Invia un PASTE di tipo Java" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__pastebin.sh NEWPASTE java"
/MENU ADD "BuDuScRiPt/PasteBin System - Incolla un testo su PasteBin e mostra LINK/Invia un PASTE di tipo PERL" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__pastebin.sh NEWPASTE perl"
/MENU ADD "BuDuScRiPt/PasteBin System - Incolla un testo su PasteBin e mostra LINK/Invia un PASTE di tipo Python" "budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__pastebin.sh NEWPASTE python"
/MENU ADD "BuDuScRiPt/PasteBin System - Incolla un testo su PasteBin e mostra LINK/-"
/MENU ADD "BuDuScRiPt/PasteBin System - Incolla un testo su PasteBin e mostra LINK/Configura Durata di Default"
/MENU ADD "BuDuScRiPt/PasteBin System - Incolla un testo su PasteBin e mostra LINK/Configura Tipologia di Default"
EOF

    xchat_pastebin_menu=""
    
    IFS_OLD=${IFS}
    IFS=$'\n'

    pastebin_menu_retain=$(
	for retain in ${api_paste_expire_date}; do
	    retain_ID=$(echo "${retain}" | awk -F'\t' '{print $1}')
	    retain_value=$(echo "${retain}" | awk -F'\t' '{print $2}' | sed 's@[^a-zA-Z0-9 ]@ @g')
	    if test ${retain_ID} == ${PASTEBIN_RETAIN} ; then
		retain_flag=1
		radio_button_name="${retain_value}"
	    else
		retain_flag=0
		radio_button_name="_BUDUSCRIPT_PASTEBIN_RADIO_BUTTON_NAME_"
	    fi
	    
	    printf '/MENU -r%d,"%s" ADD "BuDuScRiPt/PasteBin System - Incolla un testo su PasteBin e mostra LINK/Configura Durata di Default/%s" "budus pipe_script_silent echo '\''PASTEBIN_RETAIN %s'\'' >> ${HOME}/.xchat2/buduscript/pastebin.config"\n' "${retain_flag}" "${radio_button_name}" "${retain_value}" "${retain_ID}"
	done
    )
    
    echo "${pastebin_menu_retain}" | grep -F -- ' -r1,'
    radio_button_name=$(echo "${pastebin_menu_retain}" | grep -F -- ' -r1,' | awk -F'"' '{print $2}')
    printf '/MENU ADD "BuDuScRiPt/PasteBin System - Incolla un testo su PasteBin e mostra LINK/Configura Durata di Default/-\n'
    echo "${pastebin_menu_retain}" | grep -F -- ' -r0,' | sed "s@_BUDUSCRIPT_PASTEBIN_RADIO_BUTTON_NAME_@${radio_button_name}@g"
    
    pastebin_menu_format=$(
	for format in ${api_paste_format}; do
	    format_ID=$(echo "${format}" | awk -F'\t' '{print $1}')
	    format_value=$(echo "${format}" | awk -F'\t' '{print $2}' | sed 's@[^a-zA-Z0-9 ]@ @g')
	    if test ${format_ID} == ${PASTEBIN_FORMAT} ; then
		format_flag=1
		radio_button_name="${format_value}"
	    else
		format_flag=0
		radio_button_name="_BUDUSCRIPT_PASTEBIN_RADIO_BUTTON_NAME_"
	    fi
	    
	    printf '/MENU -r%d,"%s" ADD "BuDuScRiPt/PasteBin System - Incolla un testo su PasteBin e mostra LINK/Configura Tipologia di Default/%s" "budus pipe_script_silent echo '\''PASTEBIN_FORMAT %s'\'' >> ${HOME}/.xchat2/buduscript/pastebin.config"\n' "${format_flag}" "${radio_button_name}" "${format_value}" "${format_ID}"
	done
    )
    
    echo "${pastebin_menu_format}" | grep -F -- ' -r1,'
    radio_button_name=$(echo "${pastebin_menu_format}" | grep -F -- ' -r1,' | awk -F'"' '{print $2}')
    printf '/MENU ADD "BuDuScRiPt/PasteBin System - Incolla un testo su PasteBin e mostra LINK/Configura Tipologia di Default/-\n'
    echo "${pastebin_menu_format}" | grep -F -- ' -r0,' | sed "s@_BUDUSCRIPT_PASTEBIN_RADIO_BUTTON_NAME_@${radio_button_name}@g"
    
    IFS=${IFS_OLD}
    
    exit 0;
fi

################################################################################
# Verifica la presenza di udanopaste ___________________________________________
if [ ! -f "${script_path}/udapaste" ]; then
    printf '/ECHO %%C4,1%%B[PASTEBIN]\t ERRORE FATALE:%%O Programma %%Budapaste%%O non trovato in %%B%s%%O .\n' "${script_path}"
    
    exit 1;
fi

################################################################################
# Verifica la presenza di curl _________________________________________________
curl_version=$(curl --version 2> /dev/null)
if [ "${curl_version}" == "" ]; then
    printf '/ECHO %%C4,1%%B[PASTEBIN]\t ERRORE FATALE:%%O Programma %%Bcurl%%O non trovato;  necessario installarlo per usare PASTEBIN.\n'
    
    exit 1;
fi

################################################################################
# Verifica la presenza di xterm ________________________________________________
if [ ! $(which xterm 2> /dev/null) ]; then
    printf '/ECHO %%C4,1%%B[PASTEBIN]\t ERRORE FATALE:%%O Programma %%Bxterm%%O non trovato;  necessario installarlo per usare PASTEBIN.\n'
    
    exit 1;
fi

################################################################################
# Se e' stato specificato un secondo parametro, lo usa come tipologia ________
if [ "${2}" != "" ]; then
    PASTEBIN_FORMAT="${2}"
fi

if [ "${1}" == "NEWPASTE" ]; then
    current_format=$(echo "${api_paste_format}" | grep "^${PASTEBIN_FORMAT}	" | awk -F'\t' '{print $2}' | sed 's@[^a-zA-Z0-9 ]@ @g')
    current_retain=$(echo "${api_paste_expire_date}" | grep "^${PASTEBIN_RETAIN}	" | awk -F'\t' '{print $2}')
    
    printf '/ECHO %%C3,1%%B[PASTEBIN]\t Generazione di un PasteBin di tipologia %%B%s%%O con scadenza %%B%s%%O.\n' "${current_format}"  "${current_retain}"
    
    echo "/EXEC xterm -e ${0} FORK_PROCESS ${PASTEBIN_FORMAT}"
    echo "/TIMER ${check_step} budus pipe_script_silent ${0} FORK_CHECK ${check_step}"
    
    exit 0;
fi

if [ "${1}" == "FORK_CHECK" ]; then
    if [ -f "${pastebin_output}" ]; then
	cat "${pastebin_output}"
	rm -f "${pastebin_output}"
    else
	fork_check_timer=$((${2} + ${check_step}))
	if [ ${check_timeout} -le ${fork_check_timer} ]; then
	    printf '/ECHO %%C4,1%%B[PASTEBIN]\t ERRORE:%%O Il tempo di timeout (%d minuti)  scaduto; non risulta nessun nuovo PasteBin.\n' $((${check_timeout} / 60))
	else
	    if [ -f "${pastebin_output}.tmp" ]; then
		printf '/ECHO %%C6,1%%B[PASTEBIN]\t CHECK:%%O tra %%B%d%%O secondi scade il timeout per il PasteBin.\n' $((${check_timeout} - ${fork_check_timer}))
	    else
		[ $((${fork_check_timer} % 50)) ] && printf '/ECHO %%C3,1%%B[PASTEBIN]\t CHECK:%%O tra %%B%d%%O secondi scade il timeout per il PasteBin.\n' $((${check_timeout} - ${fork_check_timer}))
	    fi
	    echo "/TIMER ${check_step} budus pipe_script_silent ${0} FORK_CHECK ${fork_check_timer}"
	fi
    fi
    
    exit 0;
fi

if [ "${1}" == "FORK_PROCESS" ]; then
    clear
    printf '* NON CHIUDERE QUESTA FINESTRA *\n'
    
    ${script_path}/udapaste T
    exit_error=$?
    if [ ${exit_error} != 0 ]; then
	printf 'ATTENZIONE, ERRORE GRAVE: udapaste e'\'' uscito con il codice di errore %d\n' ${exit_error}
	printf 'Segnalare il problema a UDA'\''Software, riportando codice di errore ed eventuale messaggio (vedi sopra).\n'
	printf 'Premi INVIO per continuare.\n'
	read
	
	rm -vf "${pastebin_output}.tmp"
	printf '/ECHO %%C7,1%%B[PASTEBIN]\t ATTENZIONE:%%O Problema con UDAPASTE.\n' > "${pastebin_output}"
	
	exit 1;
    fi
    printf 'Incollare il testo nella finestra grafica e premere il pulsante PASTE.\n'
    
    [ -f "${pastebin_output}" ] && rm -f "${pastebin_output}"
    
    nopaste_data=$("${script_path}/udapaste" | awk '
    BEGIN {
	# We assume an awk implementation that is just plain dumb.
	# We will convert an character to its ASCII value with the
	# table ord[], and produce two-digit hexadecimal output
	# without the printf("%02X") feature.

	EOL = "%0A"		# "end of line" string (encoded)
	split ("1 2 3 4 5 6 7 8 9 A B C D E F", hextab, " ")
	hextab [0] = 0
	for ( i=1; i<=255; ++i ) ord [ sprintf ("%c", i) "" ] = i + 0
	if ("'"$EncodeEOL"'" == "yes") EncodeEOL = 1; else EncodeEOL = 0
    }
    {
	encoded = ""
	for ( i=1; i<=length ($0); ++i ) {
	    c = substr ($0, i, 1)
	    if ( c ~ /[a-zA-Z0-9.-]/ ) {
		encoded = encoded c		# safe character
	    } else if ( c == " " ) {
		encoded = encoded "+"	# special handling
	    } else {
		# unsafe character, encode it as a two-digit hex-number
		lo = ord [c] % 16
		hi = int (ord [c] / 16);
		encoded = encoded "%" hextab [hi] hextab [lo]
	    }
	}
	if ( EncodeEOL ) {
	    printf ("%s", encoded EOL)
	} else {
	    print encoded
	}
    }
    END {
    	#if ( EncodeEOL ) print ""
    }
'
    )
    
    printf 'OK, intercettato il nuovo PASTE, lo pubblico su PasteBin...'
    
    {
	if [ "${nopaste_data}" != "" ]; then
	    pastebin_url=$(curl -i -d api_paste_private="0" -d api_dev_key="${api_dev_key}" -d api_user_key="" -d api_user_key="${USERNAME}" -d api_paste_name="BuDuScRiPt PasteBin System [${RANDOM}]" -d api_paste_expire_date="${PASTEBIN_RETAIN}" -d api_paste_format="${PASTEBIN_FORMAT}" -d api_paste_code="${nopaste_data}" -d api_option="paste" -s "${nopaste_URL}" | tail -n1)
	    
	    printf '/SAY %s\n' "${pastebin_url}"
	else
	    printf '/ECHO %%C7,1%%B[PASTEBIN]\t ATTENZIONE:%%O Non  stato inserito nulla.\n'
	fi
    } > "${pastebin_output}.tmp"
    
    printf 'FATTO !\n'
    mv -vf "${pastebin_output}.tmp" "${pastebin_output}"
fi

################################################################################
#_______________________________________________________________________________
