#!/bin/bash

# Version 14/11/2012
# $Revision: 1.147 $
# By UDA'Software 2010

# Questo script ha lo scopo di facilitare la ricerca ed il download
# via XDCC.

#####################################################################
#____________________________________________________________________
# Gestione dei Parametri.
database="${1}"
dcc_database="${2}"
server="${3}"
command="${4}"
RANDOM_NUMBER="${5}"
CURRENT_TIMEOUT="${6}"

SUB_COMMAND="${5}"
PARAMETER_1="${6}"
PARAMETER_2="${7}"
PARAMETER_3="${8}"
PARAMETER_4="${9}"
PARAMETER_5="${10}"
PARAMETER_6="${11}"

#####################################################################
#____________________________________________________________________
XChat_PID=$(echo "${database}" | grep -o '[0-9]*')
RANDOM_CODE=$(echo "${XChat_PID}${RANDOM}${RANDOM}${RANDOM}${RANDOM}${RANDOM}${RANDOM}${RANDOM}${RANDOM}${RANDOM}" | cut -b-10)

#####################################################################
#____________________________________________________________________
# Dichiarazione ed inizializzazione delle variabili globali.
standard_version="1.0"

parameters=$(echo "${*}" | cut -f5- -d' ')

user_home=$(echo "${HOME}" | tr [:punct:] '_')
script_path=$(dirname "${0}")

config_file="${script_path}/budus_xdcc.config"
xdcc_network_alias_db="${script_path}/budus_xdcc_alias.db"

db_default_path="$HOME/.xchat2/buduscript/tmp/budus_XDCC_"
plugin_default_path="/tmp/budus_XDCC_"
db_saved_path="$HOME/.xchat2/buduscript/budus_XDCC_"

#####################################################################
#____________________________________________________________________
xdcc_log_file="${db_default_path}DATA.log"
#xdcc_log_file="&2"

#####################################################################
#____________________________________________________________________
search_engine_db="${db_default_path}${XChat_PID}.dat"
search_query="${db_default_path}${XChat_PID}.query"
search_string_tempfile="${db_default_path}${XChat_PID}.string"

resolving_cache="${db_default_path}resolving.cache"

#####################################################################
#____________________________________________________________________
permanent_reflex_list="${script_path}/budus_xdcc.reflex"
temp_reflex_list="/tmp/buduscript_xdcc_reflex_${user_home}_${XChat_PID}.dat"
temp_input_utente_file="/tmp/buduscript_script__multicommand_${user_home}.dat"

temp_network_failed_db="/tmp/buduscript_xdcc_network_failed_db_${user_home}.dat"

temp_stat_db="/tmp/buduscript_xdcc_temp_stat_db_${user_home}_${XChat_PID}.dat"

md5sum_db="${db_default_path}md5sum.dat"
cache_md5sum_db="/tmp/buduscript_xdcc_md5sum_db_${user_home}.dat"
temp_md5sum_output="/tmp/buduscript_xdcc_md5sum_output_${user_home}_${XChat_PID}.dat"

temp_lock_file="/tmp/buduscript_xdcc_temp_lock_file_${user_home}_${XChat_PID}.dat"

#####################################################################
#____________________________________________________________________
sleep_before_request_time=16
dcc_get_timer_sec=30

#####################################################################
#____________________________________________________________________
flag_skip_lock_db=0
flag_static_find_item_in_db=0
flag_static_join_code_to_item=0

#####################################################################
#____________________________________________________________________
download_queue_db="${db_default_path}download_queue_${XChat_PID}.dat"
waiting_db="${db_default_path}waiting_${XChat_PID}.dat"
request_db="${db_default_path}request_${XChat_PID}.dat"
transfer_db="${db_default_path}transfer_${XChat_PID}.dat"
repeat_db="${db_default_path}repeat.dat"
failed_db="${db_default_path}failed.dat"
lock_db="${db_default_path}repeat_${XChat_PID}.lock"

connect_server_db="${db_default_path}connect_server_${XChat_PID}.dat"

search_pattern_db="${db_default_path}search_pattern.dat"

flag_make_db_permanent="${db_default_path}flag_make_db_permanent.$(date +%Y%m%d)"

#####################################################################
#____________________________________________________________________
{
    find /tmp/ -maxdepth 1 -cmin +1440 -iname 'budus_XDCC_*.log' -exec rm -fv {} \;
} > /dev/null 2> /dev/null
printf '********************************************************************************\n' >> "${xdcc_log_file}"
printf '********************************************************************************\n' >> "${xdcc_log_file}"
echo "$(date): ${0} ${*}" >> "${xdcc_log_file}"

#####################################################################
#____________________________________________________________________
if [ ! -f ${database} ] && \
    [ ${database:-X} != CHECK ] && \
    [ ${database:-X} != LIBRARY ] && \
    [ ${database:-X} != NULL ]; then
    echo "/ECHO %C4,1ERRORE GRAVE: Database non trovato (${database})."
    exit 1;
fi

#####################################################################
#____________________________________________________________________
flag_debug_mode_space=0
function debug_print() {
    [ "${XDCC_DEBUG_MODE}" != "Y" ] && return 1
    
    if [ "${1}" == ">" ]; then
	flag_debug_mode_space=$((${flag_debug_mode_space:-0} + 2))
	
	printf "%${flag_debug_mode_space:-1}s%s\n" ' ' "START: ${2}" >> "${xdcc_log_file}"
	
	flag_debug_mode_space=$((${flag_debug_mode_space:-0} + 2))
    elif [ "${1}" == "<" ]; then
	if [ ${flag_debug_mode_space:-0} -lt 2 ]; then
	    flag_debug_mode_space=2
	fi
	
	flag_debug_mode_space=$((${flag_debug_mode_space:-3} - 2))
	
	printf "%${flag_debug_mode_space:-1}s%s\n" ' ' "END  : ${2}" >> "${xdcc_log_file}"
	
	flag_debug_mode_space=$((${flag_debug_mode_space:-3} - 2))
	[ ${flag_debug_mode_space} -lt 0 ] && flag_debug_mode_space=0
    elif [ "${1}" == "x" ]; then
	printf '********************************************************************************\n' >> "${xdcc_log_file}"
	printf "%${flag_debug_mode_space:-1}s%s\n" ' ' "START: ${2}" >> "${xdcc_log_file}"
	
	flag_debug_mode_space=1
    else
	printf "%${flag_debug_mode_space:-1}s%s\n" ' ' "  *  : ${2}" >> "${xdcc_log_file}"
    fi
    
    if [ ${flag_debug_mode_space:-0} -lt 0 ]; then
	flag_debug_mode_space=0
    fi
    
    return 1
}

#####################################################################
#____________________________________________________________________
# Funzioni di accesso alla configurazione.
function get_var() {
    get_var=""
    
    if [ -f "${config_file}" ]; then
	get_var=$(grep -F $1 ${config_file} | tail -n1 | awk '{print $2}')
    fi
    
    if [ "${get_var}" == "" ]; then
	get_var=${2}
    fi
}

function load_config() {
    get_var TIMEOUT_RICERCA 600
    TIMEOUT_RICERCA=${get_var}
    if [ ${TIMEOUT_RICERCA:-0} -lt 32 ]; then
	TIMEOUT_RICERCA=32
	echo "/ECHO %C4,1%BATTENZIONE:%O%C4,1 Il tempo di TIMEOUT non puo' essere inferiore a 32 secondi, lo forzo."
    fi
    
    get_var NUMERO_MASSIMO_DI_RISULTATI 100
    NUMERO_MASSIMO_DI_RISULTATI=${get_var}
    
    get_var RIMUOVI_RISULTATI_INCOMPLETI N
    RIMUOVI_RISULTATI_INCOMPLETI=${get_var}
    
    get_var ELENCA_RISULTATI_SENZA_FORMATTAZIONE N
    ELENCA_RISULTATI_SENZA_FORMATTAZIONE=${get_var}
    
    get_var MANTIENI_SOLO_I_RISULTATI_CHE_RISPETTANO_TUTTE_LE_CHIAVI_DI_RICERCA N
    MANTIENI_SOLO_I_RISULTATI_CHE_RISPETTANO_TUTTE_LE_CHIAVI_DI_RICERCA=${get_var}
    
    get_var TOGLI_CHIAVI_SUPERFLUE_NELLA_RICERCA Y
    TOGLI_CHIAVI_SUPERFLUE_NELLA_RICERCA=${get_var}
    
    get_var ELIMINA_RISULTATI_RICERCA_WEB_SOVRAPPOSTI_XBSPSE_LIST Y
    ELIMINA_RISULTATI_RICERCA_WEB_SOVRAPPOSTI_XBSPSE_LIST=${get_var}
    
    get_var USA_CODA_DEI_DOWNLOAD Y
    USA_CODA_DEI_DOWNLOAD=${get_var}
    
    get_var ESEGUI_XBSPSE_CONTEMPORANEAMENTE Y
    ESEGUI_XBSPSE_CONTEMPORANEAMENTE=${get_var}
    
    get_var CONSENTI_XBSPSE_CHE_RICHIEDONO_PASSWORD Y
    CONSENTI_XBSPSE_CHE_RICHIEDONO_PASSWORD=${get_var}
    
    get_var ESEGUI_VERIFICA_MD5SUM_SUI_FILE_SCARICATI Y
    ESEGUI_VERIFICA_MD5SUM_SUI_FILE_SCARICATI=${get_var}
    
    get_var EVITA_DOWNLOAD_DEL_MEDESIMO_FILE Y
    EVITA_DOWNLOAD_DEL_MEDESIMO_FILE=${get_var}
    
    get_var CONSENTI_RIPRESA_DOWNLOAD_AUTOMATICA Y
    CONSENTI_RIPRESA_DOWNLOAD_AUTOMATICA=${get_var}
    
    get_var CONSENTI_RIPRESA_DOWNLOAD_MANUALE N
    CONSENTI_RIPRESA_DOWNLOAD_MANUALE=${get_var}
    
    if [ "${CONSENTI_RIPRESA_DOWNLOAD_AUTOMATICA:-N}" == "N" ] && \
	[ "${CONSENTI_RIPRESA_DOWNLOAD_MANUALE:-N}" == "Y" ]; then
	echo "/ECHO %C4,1%BATTENZIONE:%O%C4,1 Non ha senso abilitare la %BRipresa Download Manuale%O%C4,1 se non e' attiva anche la %BRipresa Download Automatica%O%C4,1; entrambe le opzioni saranno disabilitate."
	
	CONSENTI_RIPRESA_DOWNLOAD_MANUALE="N"
    fi

    get_var ABILITA_NUOVO_TENTATIVO_AUTOMATICO_SU_FALLIMENTO Y
    ABILITA_NUOVO_TENTATIVO_AUTOMATICO_SU_FALLIMENTO=${get_var}

    get_var MANTIENI_DOWNLOAD_IN_CODA_ANCHE_DOPO_TIMEOUT N
    MANTIENI_DOWNLOAD_IN_CODA_ANCHE_DOPO_TIMEOUT=${get_var}

    get_var FORZA_PERIODICAMENTE_DOWNLOAD_IN_STATO_DI_TIMEOUT N
    FORZA_PERIODICAMENTE_DOWNLOAD_IN_STATO_DI_TIMEOUT=${get_var}

    get_var ACCETTA_TRASFERIMENTI_AMBIGUI N
    ACCETTA_TRASFERIMENTI_AMBIGUI=${get_var}

    get_var DISABILITA_PRIVATE_KILLER_SYSTEM_AUTOMATICAMENTE N
    DISABILITA_PRIVATE_KILLER_SYSTEM_AUTOMATICAMENTE=${get_var}

    get_var MESSAGGI_BOTSERV_SOLO_NELLA_FINESTRA_RELATIVA N
    MESSAGGI_BOTSERV_SOLO_NELLA_FINESTRA_RELATIVA=${get_var}

    get_var CREA_DATABASE_PERMANENTI_AUTOMATICAMENTE_QUANDO_SONO_AWAY N
    CREA_DATABASE_PERMANENTI_AUTOMATICAMENTE_QUANDO_SONO_AWAY=${get_var}

    get_var AGGIORNA_AUTOMATICAMENTE_DATABASE_PERMANENTI_OBSOLETI Y
    AGGIORNA_AUTOMATICAMENTE_DATABASE_PERMANENTI_OBSOLETI=${get_var}
    
    get_var EMETTI_AVVISI_ACUSTICI_DI_AVVISO N
    EMETTI_AVVISI_ACUSTICI_DI_AVVISO=${get_var}
    
    get_var VISUALIZZA_DATABASE_PERMANENTI_IN_FORMATO_FILE_ELENCO N
    VISUALIZZA_DATABASE_PERMANENTI_IN_FORMATO_FILE_ELENCO=${get_var}

    get_var UTILIZZA_UDA_DATA_COPY_COME_VISUALIZZATORE_ESTERNO N
    UTILIZZA_UDA_DATA_COPY_COME_VISUALIZZATORE_ESTERNO=${get_var}

    get_var XDCC_DEBUG_MODE N
    XDCC_DEBUG_MODE=${get_var}

    printf '%s %s\n' TIMEOUT_RICERCA ${TIMEOUT_RICERCA} > "${config_file}"
    printf '%s %s\n' NUMERO_MASSIMO_DI_RISULTATI ${NUMERO_MASSIMO_DI_RISULTATI} >> "${config_file}"
    printf '%s %s\n' RIMUOVI_RISULTATI_INCOMPLETI ${RIMUOVI_RISULTATI_INCOMPLETI} >> "${config_file}"
    printf '%s %s\n' ELENCA_RISULTATI_SENZA_FORMATTAZIONE ${ELENCA_RISULTATI_SENZA_FORMATTAZIONE} >> "${config_file}"
    printf '%s %s\n' MANTIENI_SOLO_I_RISULTATI_CHE_RISPETTANO_TUTTE_LE_CHIAVI_DI_RICERCA ${MANTIENI_SOLO_I_RISULTATI_CHE_RISPETTANO_TUTTE_LE_CHIAVI_DI_RICERCA} >> "${config_file}"
    printf '%s %s\n' TOGLI_CHIAVI_SUPERFLUE_NELLA_RICERCA ${TOGLI_CHIAVI_SUPERFLUE_NELLA_RICERCA} >> "${config_file}"
    printf '%s %s\n' ELIMINA_RISULTATI_RICERCA_WEB_SOVRAPPOSTI_XBSPSE_LIST ${ELIMINA_RISULTATI_RICERCA_WEB_SOVRAPPOSTI_XBSPSE_LIST} >> "${config_file}"
    printf '%s %s\n' USA_CODA_DEI_DOWNLOAD ${USA_CODA_DEI_DOWNLOAD} >> "${config_file}"
    printf '%s %s\n' ESEGUI_XBSPSE_CONTEMPORANEAMENTE ${ESEGUI_XBSPSE_CONTEMPORANEAMENTE} >> "${config_file}"
    printf '%s %s\n' CONSENTI_XBSPSE_CHE_RICHIEDONO_PASSWORD ${CONSENTI_XBSPSE_CHE_RICHIEDONO_PASSWORD} >> "${config_file}"
    printf '%s %s\n' ESEGUI_VERIFICA_MD5SUM_SUI_FILE_SCARICATI ${ESEGUI_VERIFICA_MD5SUM_SUI_FILE_SCARICATI} >> "${config_file}"
    printf '%s %s\n' EVITA_DOWNLOAD_DEL_MEDESIMO_FILE ${EVITA_DOWNLOAD_DEL_MEDESIMO_FILE} >> "${config_file}"
    printf '%s %s\n' CONSENTI_RIPRESA_DOWNLOAD_AUTOMATICA ${CONSENTI_RIPRESA_DOWNLOAD_AUTOMATICA} >> "${config_file}"
    printf '%s %s\n' CONSENTI_RIPRESA_DOWNLOAD_MANUALE ${CONSENTI_RIPRESA_DOWNLOAD_MANUALE} >> "${config_file}"
    printf '%s %s\n' ABILITA_NUOVO_TENTATIVO_AUTOMATICO_SU_FALLIMENTO ${ABILITA_NUOVO_TENTATIVO_AUTOMATICO_SU_FALLIMENTO} >> "${config_file}"
    printf '%s %s\n' MANTIENI_DOWNLOAD_IN_CODA_ANCHE_DOPO_TIMEOUT ${MANTIENI_DOWNLOAD_IN_CODA_ANCHE_DOPO_TIMEOUT} >> "${config_file}"
    printf '%s %s\n' FORZA_PERIODICAMENTE_DOWNLOAD_IN_STATO_DI_TIMEOUT ${FORZA_PERIODICAMENTE_DOWNLOAD_IN_STATO_DI_TIMEOUT} >> "${config_file}"
    printf '%s %s\n' ACCETTA_TRASFERIMENTI_AMBIGUI ${ACCETTA_TRASFERIMENTI_AMBIGUI} >> "${config_file}"
    printf '%s %s\n' DISABILITA_PRIVATE_KILLER_SYSTEM_AUTOMATICAMENTE ${DISABILITA_PRIVATE_KILLER_SYSTEM_AUTOMATICAMENTE} >> "${config_file}"
    printf '%s %s\n' MESSAGGI_BOTSERV_SOLO_NELLA_FINESTRA_RELATIVA ${MESSAGGI_BOTSERV_SOLO_NELLA_FINESTRA_RELATIVA} >> "${config_file}"
    printf '%s %s\n' CREA_DATABASE_PERMANENTI_AUTOMATICAMENTE_QUANDO_SONO_AWAY ${CREA_DATABASE_PERMANENTI_AUTOMATICAMENTE_QUANDO_SONO_AWAY} >> "${config_file}"
    printf '%s %s\n' AGGIORNA_AUTOMATICAMENTE_DATABASE_PERMANENTI_OBSOLETI ${AGGIORNA_AUTOMATICAMENTE_DATABASE_PERMANENTI_OBSOLETI} >> "${config_file}"
    printf '%s %s\n' EMETTI_AVVISI_ACUSTICI_DI_AVVISO ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO} >> "${config_file}"
    printf '%s %s\n' VISUALIZZA_DATABASE_PERMANENTI_IN_FORMATO_FILE_ELENCO ${VISUALIZZA_DATABASE_PERMANENTI_IN_FORMATO_FILE_ELENCO} >> "${config_file}"
    printf '%s %s\n' UTILIZZA_UDA_DATA_COPY_COME_VISUALIZZATORE_ESTERNO ${UTILIZZA_UDA_DATA_COPY_COME_VISUALIZZATORE_ESTERNO} >> "${config_file}"

    printf '%s %s\n' XDCC_DEBUG_MODE ${XDCC_DEBUG_MODE} >> "${config_file}"
}

#####################################################################
#____________________________________________________________________
# Funzione per la verifica della compatibilita' del plugin.
function check_plugin() {
    if [ "$(grep -F "# STANDARD ${standard_version}" ${plugin})" != "" ] && [ -x ${plugin} ]; then
	flag_plugin_standard_conformed=1
    else
	flag_plugin_standard_conformed=0
    fi
    
    if [ -f ${plugin%.sh} ]; then
	flag_plugin_enabled=1
    else
	flag_plugin_enabled=0
    fi

    if [ ${flag_plugin_standard_conformed} == 1 ] && [ ${flag_plugin_enabled} == 1 ]; then
	flag_check_plugin=1
    else
	flag_check_plugin=0
    fi
    
    if [ "${1}" != "SKIP_TYPE" ]; then
	plugin_type="$(grep -F "# PLUGIN TYPE:" ${plugin} | cut -f2- -d':')"
	if [ "${plugin_type}" != "" ]; then
	    case ${check_plugin_type} in
		WEB)
		    if [ "${plugin_type}" != "WEB" ]; then
			flag_check_plugin=0
		    fi
		    ;;
		LIST)
		    if [ "${plugin_type}" == "WEB" ]; then
			flag_check_plugin=0
		    fi
		    if [ "${plugin_type}" == "PASSWORD" ] && [ ${CONSENTI_XBSPSE_CHE_RICHIEDONO_PASSWORD:-Y} == "N" ]; then
			flag_check_plugin=0
		    fi
		    ;;
	    esac
	fi
    fi
}

#####################################################################
#____________________________________________________________________
function trap_cb() {
    printf 'PLUGIN USCITO CON ERRORE.\n' >&2

    printf '/ECHO [XDCC MANAGER]\t %%C4,1%%BERRORE FATALE:%%O%%C4,1 UNO O PIU'\'' XBSPSE HANNO ABORTITO L'\''ELABORAZIONE.\n' >> "${search_query}"
    printf '/ECHO [XDCC MANAGER]\t %%C9,1Sono costretto ad abortire l'\''elaborazione. E'\'' consigliato disabilitare tutti i plugin che hanno manifestato problemi.\n' >> "${search_query}"

    for plugin in ${active_plugin_list}; do
	check_plugin
	if [ ${flag_check_plugin} == 1 ] && [ -f ${plugin%.sh} ]; then
	    plugin_name=$(echo "${plugin}" | sed 's@.*budus_xdcc_plugin_@@' | cut -f1 -d'.')
	    plugin_tempfile="${plugin_default_path}${plugin_name}_${user_home}_${RANDOM_NUMBER}"
	    
	    if [ ! -f ${plugin_tempfile}.database ]; then
		[ -f ${plugin_tempfile} ] && rm -f ${plugin_tempfile}
		
		printf '/ECHO [XDCC MANAGER]\t %%C4,1Il plugin%%B %s%%O%%C4,1 risulta attivo ma non sembra aver elaborato nulla.\n/ECHO Se i problemi persistono, si consiglia di disabilitarlo e segnalare l'\''anomalia a UDA'\''Software.\n' "${plugin_name}" >> "${search_query}"
	    fi
	fi
    done
    
    printf '/ECHO [XDCC MANAGER]\t %%C8,1Si consiglia inoltre, per evitare ulteriori malfunzionamenti, di pulire la cache del Motore di Ricerca XDCC (%%BXDCC > Configurazione > Cancella la Cache del Search Engine%%O%%C8,1).\n' >> "${search_query}"
    if [ ${ESEGUI_XBSPSE_CONTEMPORANEAMENTE:-Y} == "Y" ]; then
	printf '/ECHO [XDCC MANAGER]\t %%C6,1Puo'\'' essere anche opportuno disabilitare l'\''esecuzione simultanea dei plugin (XBSPSE), in modo da identificare piu'\'' facilmente la causa dei problemi (%%BXDCC > Configurazione > Esegui Plugin di Ricerca (XBSPSE) in parallelo%%O%%C6,1).\n' >> "${search_query}"
    fi
    
    . "${script_path}/budus_XBSPSE_Crawler.sh"
    queue_connection_manager 'RELEASE_PLUGIN' "${plugin_name}"
    
    mv -f ${search_query} ${search_query}.exit
}

#####################################################################
#____________________________________________________________________
# Funzione che elimina gli xbspse con link a file inesistente.
function delete_xbspse_unlinked() {
    link_plugin_list=$(find "${script_path}" -maxdepth 1 -type l -iname 'budus_xdcc_plugin_*')
    for plugin in ${link_plugin_list}; do
	if [ ! -e "${plugin}" ]; then
	    plugin_name=$(echo "${plugin}" | sed 's@.*budus_xdcc_plugin_@@' | cut -f1 -d'.')
	    
	    rm -f "${plugin}" && \
		printf '/ECHO [XDCC MANAGER]\t %%C4,1Il plugin%%B %s%%O%%C4,1 era un link ad un file spostato/cancellato; rimosso in automatico.\n' "${plugin_name}" || \
		printf '/ECHO [XDCC MANAGER]\t %%C4,1Il plugin%%B %s%%O%%C4,1 risulta un link ad un file spostato/cancellato; errore nel tentativo di rimuoverlo, verificare manualmente.\n' "${plugin_name}"
	fi
    done
}

#####################################################################
#____________________________________________________________________
# Funzione che lancia la chiamata ai vari plugin abilitati alla
# ricerca.
function filtering_search_forked() {
    search_string_default=$([ -f "${search_string_tempfile}" ] && \
	cat "${search_string_tempfile}")
    
    if [ "${check_plugin_type}" == "WEB" ]; then
	search_string=$([ -f "${search_string_tempfile}" ] && \
	    cat "${search_string_tempfile}")
    else
	[ ${TOGLI_CHIAVI_SUPERFLUE_NELLA_RICERCA:-Y} == "Y" ] && \
	    search_string=$([ -f "${search_string_tempfile}" ] && \
	    cat "${search_string_tempfile}" \
	    | tr ' ' '\n' \
	    | awk '{print length($1)" "$1}' \
	    | sort -nr \
	    | awk '{print $2}' \
	    | grep '.\{4,\}' \
	    | tr '\n' ' ' \
	    | sed 's@ $@\n@')
	
	if [ "${search_string}" == "" ] || [ $(echo "${search_string}" | wc -w) -le 1 ]; then
	    [ ${TOGLI_CHIAVI_SUPERFLUE_NELLA_RICERCA:-Y} == "Y" ] && \
		[ $(echo "${search_string}" | wc -w) -gt 1 ] && \
		printf '/ECHO [XDCC MANAGER]\t %%C7,1Lasciare solo le chiavi di ricerca maggiori di 3 caratteri risulta impossibile; lascio le chiavi inalterate, ma questo comporta tempi di elaborazione maggiori e risultati imprecisi.\n'
	    
	    search_string=$([ -f "${search_string_tempfile}" ] && \
		cat "${search_string_tempfile}" \
		| tr ' ' '\n' \
		| awk '{print length($1)" "$1}' \
		| sort -nr \
		| awk '{print $2}' \
		| tr '\n' ' ' \
		| sed 's@ $@\n@')
	fi
    fi
    
    # Cerca gli XBSPSE che sono solo un link, ed elimina quelli "broken".
    delete_xbspse_unlinked
    
    active_plugin_list=$(find "${script_path}" -maxdepth 1 -iname 'budus_xdcc_plugin_*' | grep -v '\.old$')
    
    IFS_OLD=${IFS}
    IFS=$'\n'
    
    # Carica la configurazione
    load_config
    
    # Setta il timer
    start_time=$(date +%s)
    
    # Filtraggio Step 1
    plugin_active_counter=0
    date_code=$(date +%Y%m%d)
    for plugin in ${active_plugin_list}; do
	[ ${database:-X} == CHECK ] && echo "* CHECK: Controllo del plugin ${plugin} ."
	check_plugin

	[ "${check_plugin_type}" == "${plugin_type}" ] && \
	    [ ${flag_plugin_enabled:-0} == 1 ] && \
	    plugin_active_counter=$((${plugin_active_counter} + 1))
	
	if [ "${check_plugin_type}" != "WEB" ]; then
	    plugin_name=$(echo "${plugin}" | sed 's@.*budus_xdcc_plugin_@@' | cut -f1 -d'.')
	    if [ -f "${plugin_default_path}db_${plugin_name}.${date_code}" ]; then
		permanent_plugin_data_file_size=$(stat -c%s "${plugin_default_path}db_${plugin_name}.${date_code}")
		
		[ ${database:-X} == CHECK ] && echo "* CHECK: File dati permanenti di ${plugin_name}: ${permanent_plugin_data_file_size}b"
		
		if [ ${permanent_plugin_data_file_size:-0} == 0 ]; then
		    printf '/ECHO [XDCC MANAGER]\t %%C4,1Il plugin%%B %s%%O%%C4,1 possiede un database permanente nullo.\n/ECHO Lo elimino affinch venga rigenerato; tuttavia, se persistono problemi, pu essere opportuno disabilitarlo e segnalarne l'\''anomalia a UDA'\''Software.\n' "${plugin_name}"
		    rm -f "${plugin_default_path}db_${plugin_name}.${date_code}"
		fi
	    fi
	fi

	if [ ${flag_check_plugin} == 1 ] && [ -f ${plugin%.sh} ]; then
	    printf 'EXEC PLUGIN %s TYPE %s\n' "${plugin%.sh}" "${plugin_type}" >&2
	    
	    plugin_name=$(echo "${plugin}" | sed 's@.*budus_xdcc_plugin_@@' | cut -f1 -d'.')
	    plugin_tempfile="${plugin_default_path}${plugin_name}_${user_home}_${RANDOM_NUMBER}"
	    touch ${plugin_tempfile}
	    [ ${database:-X} == CHECK ] && echo "* CHECK: Esecuzione della ricerca (${script_path}/budus_xdcc_plugin_${plugin_name}.sh \"${RANDOM_NUMBER}\" \"$((${TIMEOUT_RICERCA} - 16))\" \"${search_string}\")."
	    if [ ${ESEGUI_XBSPSE_CONTEMPORANEAMENTE:-Y} == "Y" ]; then
		${script_path}/budus_xdcc_plugin_${plugin_name}.sh "${RANDOM_NUMBER}" "$((${TIMEOUT_RICERCA} - 16))" "${search_string}" &
	    else
		if [ ${TIMEOUT_RICERCA} -ge 16 ]; then
		    printf 'PLUGIN MULTITHREAD DISABILITATO. PLUGIN TIMEOUT IMPOSTATO A %d SECONDI.\n' ${TIMEOUT_RICERCA} >&2
		    ${script_path}/budus_xdcc_plugin_${plugin_name}.sh "${RANDOM_NUMBER}" "$((${TIMEOUT_RICERCA} - 16))" "${search_string}"
		    current_time=$(date +%s)
		    elaboration_time=$((${current_time} - ${start_time}))
		    TIMEOUT_RICERCA=$((${TIMEOUT_RICERCA} - ${elaboration_time}))
		fi
	    fi
	fi
    done
    
    iterator=0
    for plugin in ${active_plugin_list}; do
	check_plugin
	if [ ${flag_check_plugin} == 1 ] && [ -f ${plugin%.sh} ]; then
	    plugin_name=$(echo "${plugin}" | sed 's@.*budus_xdcc_plugin_@@' | cut -f1 -d'.')
	    plugin_tempfile="${plugin_default_path}${plugin_name}_${user_home}_${RANDOM_NUMBER}"
	    echo -e "ATTESA DI ${plugin_name} ..." >&2
	    while [ -f "${plugin_tempfile}" ]; do
		sleep 1
		iterator=$((${iterator} + 1))
		
		if [ ${iterator} -gt $((${TIMEOUT_RICERCA} - 8)) ]; then
		    echo "TIMEOUT raggiunto per il plugin ${plugin_name}" >&2
		    echo "/ECHO %C8,1%BATTENZIONE:%O%C8,1 Timeout raggiunto per il plugin%B ${plugin_name}"
		    
		    . "${script_path}/budus_XBSPSE_Crawler.sh"
		    queue_connection_manager 'RELEASE_PLUGIN' "${plugin_name}"
		    
		    rm -f ${plugin_tempfile}
		fi
	    done
	fi
    done
    
    tempfile="${db_default_path}${RANDOM_NUMBER}.database"
    for plugin in ${active_plugin_list}; do
	check_plugin
	if [ ${flag_check_plugin} == 1 ] && [ -f ${plugin%.sh} ]; then
	    plugin_name=$(echo "${plugin}" | sed 's@.*budus_xdcc_plugin_@@' | cut -f1 -d'.')
	    plugin_tempfile="${plugin_default_path}${plugin_name}_${user_home}_${RANDOM_NUMBER}"
	    
	    if [ ! -f ${plugin_tempfile} ] && [ -f ${plugin_tempfile}.database ]; then
		[ ${database:-X} == CHECK ] && echo "* CHECK: Caricamento nel database dei dati ricevuti da ${plugin_name} ."
		plugin_items_found=$(cat ${plugin_tempfile}.database | grep -v '^$' | wc -l | cut -f1 -d' ')
		plugin_elaboration_time=$(($(stat -c %X ${plugin_tempfile}.database) - ${start_time}))
		
		[ ${plugin_items_found:-0} -le 0 ] && plugin_items_found=0
		echo "${plugin_items_found} risultati per il plugin ${plugin_name}" >&2
		printf '%%B%4d%%O risultati in %%B%4d%%O secondi per il plugin %%B%s%%O.\n' "${plugin_items_found}" "${plugin_elaboration_time}" "${plugin_name}" >> "${temp_stat_db}"
		cat ${plugin_tempfile}.database >> "${tempfile}"
		[ ${database:-X} != CHECK ] && rm -f ${plugin_tempfile}.database
		
		if [ ${plugin_items_found:-0} == 0 ] && [ ${plugin_elaboration_time:-0} == 0 ]; then
		    echo "/ECHO %C4,1Il plugin %B${plugin_name}%O%C4,1 non ha prodotto risultati e non sembra aver elaborato dati."
		    echo "/ECHO %C8,1E' possibile che effettivamente la risorsa cercata non sia presente sulla relativa fonte o che abbia un malfunzionamento temporaneo ma, se la situazione persiste, si consiglia di segnalarlo ad UDA'Software."
		    [ ${flag_check_stat_message:-0} == 0 ] && flag_check_stat_message=1 && echo "/ECHO %C6,1Si consiglia di verificare le statistiche degli XBSPSE tramite il menu:%C5,1%B XDCC -> Configurazione -> Elenca Statistica degli XBSPSE sull'Ultima Ricerca"
		fi
	    else
		echo "Nessun risultato per il plugin ${plugin_name} o TIMEOUT raggiunto." >&2
	    fi
	fi
    done
    
    sleep 2
    IFS=${IFS_OLD}
    
    if [ -f ${tempfile} ]; then total_result=$([ -f "${tempfile}" ] && cat "${tempfile}" | grep -v '^$' | wc -l | cut -f1 -d' ') ; fi
    
    if [ ${total_result:-0} == 0 ]; then
	if [ ${plugin_active_counter} -gt 0 ]; then
	    if [ "{check_plugin_type}" = "WEB" ]; then
		echo "/ECHO %C8,1La ricerca di tipo %B${check_plugin_type}%O%C8,1 di %B${search_string}%O%C4,1 non ha prodotto risultati."
	    else
		echo "/ECHO %C4,1La ricerca di tipo %B${check_plugin_type}%O%C4,1 di %B${search_string}%O%C4,1 non ha prodotto risultati."
	    fi
	fi
	
	[ -f "${tempfile}" ] && rm -f "${tempfile}"
    else
	if [ ${flag_dont_reset_item_number:-0} == 0 ]; then
	    if [ -f ${search_engine_db} ]; then rm -f ${search_engine_db}; fi
	    item_number=0
	fi
	flag_last_item_error=1
	last_item_network_name=""
	last_item_network=""
	
	if [ ${MANTIENI_SOLO_I_RISULTATI_CHE_RISPETTANO_TUTTE_LE_CHIAVI_DI_RICERCA:-N} == Y ]; then
	    echo "/ECHO %C8,1%BFiltro Avanzato attivo:%O%C9,1 Mantengo solo i risultati che soddisfano tutti i pattern di ricerca (${total_result:-0})."
	    search_result=$([ -f "${tempfile}" ] && cat "${tempfile}")
	    
	    for pattern in ${search_string}; do
		search_result=$(echo "${search_result}" | grep -i ".*	.*	.*	.*	.*	.*${pattern}.*	")
	    done
	    
	    echo "${search_result}" > "${tempfile}"
	    total_result=$([ -f "${tempfile}" ] && cat "${tempfile}" | grep -v '^$' | wc -l | cut -f1 -d' ')
	    
	    if [ ${total_result:-0} -le 0 ] && [ ${plugin_active_counter} -gt 0 ]; then
		echo "/ECHO %C4,1%BATTENZIONE:%C4,1 Mantenere solo i risultati che soddisfano tutte le chiavi di ricerca, porta ad un risultato nullo.%C8,1 Cambia la configurazione se vuoi elencare tutti i risultati possibili."
	    fi
	fi
	
	active_plugin_list=$(find "${script_path}" -maxdepth 1 -iname 'budus_xdcc_plugin_*' \
	    | grep -v '\.\(old\|sh\)$' \
	    | sed 's@$@.sh@')
	
	if [ "${check_plugin_type}" == "WEB" ] && \
	    [ "${active_plugin_list}" != "" ] && \
	    [ ${total_result:-0} -gt 0 ] && \
	    [ ${ELIMINA_RISULTATI_RICERCA_WEB_SOVRAPPOSTI_XBSPSE_LIST:-Y} == Y ]; then
	    echo "/ECHO %C8,1%BFiltro Avanzato attivo:%O%C9,1 Elimino i risultati della ricerca WEB sovrapposti a quelli dei XBSPSE attivi (${total_result:-0})."
	    search_result=$([ -f "${tempfile}" ] && cat "${tempfile}")
	    filter_string_list=$(for plugin in ${active_plugin_list}; do cat ${plugin} \
		| grep -F "# PLUGIN LIST:" \
		| cut -f2- -d':' \
		| awk -F' ' '{print "\t"$1"\t"$2"\t"}'; done && \
		for plugin in ${active_plugin_list}; do cat ${plugin} \
		| grep -F "# PLUGIN LIST:" \
		| cut -f2- -d':' \
		| awk -F' ' '{print $1"\t\t"$2"\t"}' \
		| sed 's@^[a-zA-Z0-9]\{1,3\}\.@@' \
		| sed 's@\.[a-zA-Z0-9]\{1,3\}		@		@'; done)
	    
	    IFS=$'\n'
	    for pattern in ${filter_string_list}; do
		search_result=$(echo "${search_result}" | grep -Fvi "${pattern}")
	    done
	    IFS=${IFS_OLD}
	    
	    echo "${search_result}" > "${tempfile}"
	    total_result=$([ -f "${tempfile}" ] && cat "${tempfile}" | grep -v '^$' | wc -l | cut -f1 -d' ')
	    
	    if [ ${total_result:-0} -le 0 ]; then
		echo "/ECHO %C4,1%BATTENZIONE:%C4,1 Eliminare i risultati sovrapposti tra la ricerca WEB e quella LIST, porta ad un risultato nullo.%C8,1 Cambia la configurazione se vuoi elencare tutti i risultati possibili."
	    fi
	fi
	
	# Filtraggio Step 2
	IFS_OLD=${IFS}
	IFS=$'\n'
	
	if [ ${plugin_active_counter} -gt 0 ]; then
	    if [ ${total_result:-0} -le 0 ]; then
		if [ "${check_plugin_type}" == "WEB" ]; then
		    echo "/ECHO %C8,1La ricerca di tipo ${check_plugin_type} non ha prodotto risultati, oppure, si e' verificato un errore; verifica che sopra non siano presenti risultati appartenenti ad altre tipologie di ricerca, oppure, potrebbe essere opportuno ripeterla."
		else
		    echo "/ECHO %C4,1La ricerca di tipo ${check_plugin_type} non ha prodotto risultati, oppure, si e' verificato un errore; potrebbe essere opportuno ripeterla."
		fi
	    else
		echo "/ECHO %C8,1Trovati ${total_result} risultati per \"${search_string_default}\", li elenco:"
		printf "/ECHO %%C3,1%%B %4s%%C4,1 %16s%%C5,1 %16s%%C6,1 %16s%%C7,1 %6s%%C8,1 %s\n" "ID" "NETWORK" "CHANNEL" "BOT" "SIZE" "FILENAME"
	    fi
	else
	    [ ${plugin_active_counter} -gt 0 ] && [ -f "${tempfile}" ] && rm -f "${tempfile}"
	    echo "/ECHO %C8,1La ricerca di tipo ${check_plugin_type} non puo' generare risultati perche' tutti i plugin di questa tipologia sono disabilitati."
	fi
	
	[ -f "${temp_network_failed_db}" ] && rm -f "${temp_network_failed_db}"
	if [ "${check_plugin_type}" == "WEB" ] && \
	    [ ${plugin_active_counter} -gt 0 ] && \
	    [ -f "${tempfile}" ]; then
	    printf 'AVVIO DELLA RISOLUZIONE DEI NETWORK:\n' >&2
	    
	    for item in $(cat "${tempfile}" | sort); do
		item_number=$((${item_number} + 1))
		
		item_network=$(echo "${item}" | awk -F'\t' '{print $2}' | tr '[:upper:]' '[:lower:]')
		if [ "${item_network}" == "" ]; then
		    item_network_name=$(echo "${item}" | awk -F'\t' '{print $1}' | tr '[:upper:]' '[:lower:]' | sed 's@[^a-zA-Z0-9_.-]*@@')
		    [ ${database:-X} == CHECK ] && echo "* CHECK: Network Host NULLO ; Provo con il Server Name: ${item_network_name}" >&2
		    
		    # Verifica se il network e' gia' stato risolto controllando nella cache.
		    [ -f "${resolving_cache}" ] && \
			item_network_cached=$(grep -iF "	${item_network_name}	" "${resolving_cache}" | tail -n1 | awk -F'\t' '{print $3}')
		    
		    # Controlla se il network possiede un ALIAS; se lo trova, invalida l'informazione ottenuta dalla cache.
		    if [ -f "${xdcc_network_alias_db}" ] && \
			[ "$(grep -iF " ${item_network_name}  " "${xdcc_network_alias_db}" | awk '{print $2}')" != "" ]; then
			item_network=$(grep -iF " ${item_network_name}  " "${xdcc_network_alias_db}" | awk '{print $2}')
			item_network_name=$(grep -iF " ${item_network_name}  " "${xdcc_network_alias_db}" | awk '{print $2}')
			flag_skip_caching=1
			echo "* ALIAS TROVATO PER: ${item_network_name}" >&2
		    fi
		    
		    # Configura le variabili se deve utilizzare i valori della cache.
		    if [ ${flag_skip_caching:-0} == 0 ] && [ ${item_network_cached}NULL != NULL ]; then
			[ ${database:-X} == CHECK ] && echo "* CHECK: Server ${item_network_name} ottimizzato: ${item_network_cached}" >&2
			if [ "${item_network_cached}" != "/FAILED/" ]; then
			    item_network=${item_network_cached}
			    item_network_name=${item_network_cached}
			    last_item_network=${item_network_cached}
			    last_item_network_name=${item_network_cached}
			else
			    last_item_network=${item_network}
			    last_item_network_name=${item_network}
			fi
		    fi
		    
		    [ ${database:-X} == CHECK ] && echo "* CHECK: RICERCA DI ${item_network_name} [${last_item_network_name:-${last_item_network:-/FAILED/}}]" >&2
		    
		    if [ "${server_checked_db}" != "" ]; then
			find_server_checked=$(echo "${server_checked_db}" | grep -iF "${item_network_name}")
			
			[ ${database:-X} == CHECK ] && [ "${find_server_checked}" != "" ] && echo "* CHECK: ${item_network_name} GIA' CONTROLLATO" >&2
		    fi
		    
		    # Verifica se il network e' corretto; se non lo e', prova a risolverlo.
		    resolving_flag=1
		    if [ "${item_network_name}" != "${last_item_network_name:-${last_item_network:-/FAILED/}}" ] && \
			[ "${find_server_checked}" == "" ]; then
			echo "* RISOLUZIONE DI: irc.${item_network_name/irc./}" >&2
			wget --spider --timeout=2 --tries=1 irc.${item_network_name}:6667 > /dev/null 2> /dev/null
			if [ $? != 0 ]; then
			    echo " * RISOLUZIONE DI: ${item_network_name}" >&2
			    wget --spider --timeout=2 --tries=1 ${item_network_name}:6667 > /dev/null 2> /dev/null
			    if [ $? != 0 ]; then
				echo "  * RISOLUZIONE DI: irc.${item_network_name/.[Oo][Rr][Gg]/}.org" >&2
				wget --spider --timeout=2 --tries=1 irc.${item_network_name}.org:6667 > /dev/null 2> /dev/null
				if [ $? != 0 ]; then
				    echo "   * RISOLUZIONE DI: irc.${item_network_name/.[Nn][Ee][Tt]/}.net" >&2
				    wget --spider --timeout=2 --tries=1 irc.${item_network_name}.net:6667 > /dev/null 2> /dev/null
				    if [ $? != 0 ]; then
					echo "    * RISOLUZIONE DI: irc.${item_network_name/.[Cc][Oo][Mm]/}.com" >&2
					wget --spider --timeout=2 --tries=1 irc.${item_network_name}.com:6667 > /dev/null 2> /dev/null
					if [ $? != 0 ]; then
					    echo "     * RISOLUZIONE DI: irc.${item_network_name/.[Ii][Tt]/}.it" >&2
					    wget --spider --timeout=2 --tries=1 irc.${item_network_name}.it:6667 > /dev/null 2> /dev/null
					    if [ $? != 0 ]; then
						echo "      * RISOLUZIONE DI: irc.${item_network_name/.[Ee][Uu]/}.eu" >&2
						wget --spider --timeout=2 --tries=1 irc.${item_network_name}.eu:6667 > /dev/null 2> /dev/null
						if [ $? != 0 ]; then
						    echo "       * RISOLUZIONE FALLITA !" >&2
						    echo "       * CONSIGLIO DI AGGIUNGERE UN ALIAS PER IL NETWORK ${item_network_name}" >&2
						    printf '\t%s\t%s\n' "${item_network_name}" "/FAILED/" >> "${resolving_cache}"
						    printf '%s\n' "${item_network_name}" >> "${temp_network_failed_db}"
						    
						    resolving_flag=0
						else
						    item_network="irc.${item_network_name/irc./}.eu"
						    echo "       * NETWORK RISOLTO IN: ${item_network}" >&2
						fi
					    else
						item_network="irc.${item_network_name/irc./}.it"
						echo "      * NETWORK RISOLTO IN: ${item_network}" >&2
					    fi
					else
					    item_network="irc.${item_network_name/irc./}.com"
					    echo "     * NETWORK RISOLTO IN: ${item_network}" >&2
					fi
				    else
					item_network="irc.${item_network_name/irc./}.net"
					echo "    * NETWORK RISOLTO IN: ${item_network}" >&2
				    fi
				else
				    item_network="irc.${item_network_name/irc./}.org"
				    echo "   * NETWORK RISOLTO IN: ${item_network}" >&2
				fi
			    else
				item_network="${item_network_name}"
				echo "  * NETWORK RISOLTO IN: ${item_network}" >&2
			    fi
			else
			    item_network="irc.${item_network_name/irc./}"
			    echo " * NETWORK RISOLTO IN: ${item_network}" >&2
			fi
			
			last_item_network=${item_network:-${item_network_name:-NULL}}
			last_item_network_name=${item_network_name:-NULL}
			
			server_checked_db="${server_checked_db} ${item_network_name}"
			
			[ ${resolving_flag:-0} == 1 ] && printf '\t%s\t%s\n' "${item_network_name}" "${item_network}" >> "${resolving_cache}"
		    else
			[ ${database:-X} == CHECK ] && echo "* CHECK: Network ${item_network:-NULL} saltato; ottimizzato: ${last_item_network:-UNKNOWN}" >&2
			item_network=${last_item_network}
		    fi
		fi
		
		# Controlla se il network possiede un ALIAS; se lo trova, invalida l'informazione ottenuta dalla cache.
		if [ -f "${xdcc_network_alias_db}" ] && \
		    [ "$(grep -iF " ${item_network}  " "${xdcc_network_alias_db}" | awk '{print $2}')" != "" ]; then
		    
		    network_alias=$(grep -iF " ${item_network}  " "${xdcc_network_alias_db}" | awk '{print $2}')
		    [ ${last_network_alias:-NULL} != ${network_alias} ] && echo "* ALIAS TROVATO PER ${item_network}: ${network_alias}" >&2
		    
		    last_network_alias=${network_alias}
		    item_network=${network_alias}
		    item_network_name=${network_alias}
		fi
		
		item_network_cut=$(echo "${item_network}" | cut -b-16)
		item_channel=$(echo "${item}" | awk -F'\t' '{print $3}')
		item_channel_cut=$(echo "${item_channel}" | cut -b-16)
		item_botname=$(echo "${item}" | awk -F'\t' '{print $4}')
		item_botname_cut=$(echo "${item_botname}" | cut -b-16)
		item_filename=$(echo "${item}" | awk -F'\t' '{print $6}')
		item_size=$(echo "${item}" | awk -F'\t' '{print $7}')
		item_ID=$(echo "${item}" | awk -F'\t' '{print $5}')
		item_command=$(echo "${item}" | awk -F'\t' '{print $8}')
		if [ "${item_command}" == "UNKNOWN" ] || [ "${item_command}" == "" ]; then
		    item_command="/msg ${item_botname} xdcc send #${item_ID}"
		fi
		
		[ ${database:-X} == CHECK ] && echo "* CHECK: [${item_network:-INVALID}] : [${item_channel:-INVALID}] : [${item_botname:-INVALID}] : [${item_command:-INVALID}]" >&2
		
		if [ "${item_network}" != "" ] && \
		    [ "${item_channel}" != "" ] && \
		    [ "${item_botname}" != "" ]; then
		    
		    if [ ${flag_skip_other_result:-0} == 0 ]; then
			if [ "${ELENCA_RISULTATI_SENZA_FORMATTAZIONE}" == "N" ]; then
			    printf "/ECHO [%%B %s%%O ]\t%%C3,1%%B%3d) %%C4,1 %16s%%C5,1 %16s%%C6,1 %16s%%C7,1 %6s%%C8,1 %s%%O\n"  "http://xdcc_${item_number}" ${item_number} "${item_network_cut}" "${item_channel_cut}" "${item_botname_cut}" "${item_size}" "${item_filename}"
			else
			    printf "/ECHO [%%B %s%%O ]\t%%C3,1%%B%3d) %%C4,1 %16s%%C5,1 %16s%%C6,1 %16s%%C7,1 %6s%%C8,1 %s%%O\n"  "http://xdcc_${item_number}" ${item_number} "${item_network}" "${item_channel}" "${item_botname}" "${item_size}" "${item_filename}"
			fi
		    fi
		    printf "%d\t%s\t%s\t%s\t%s\t%s\t%s\n" ${item_number} "${item_network}" "${item_channel}" "${item_botname}" "${item_filename}" "${item_size}" "${item_command}" >> "${search_engine_db}"
		    flag_last_item_error=0
		else
		    flag_last_item_error=1
		    
		    if [ "${RIMUOVI_RISULTATI_INCOMPLETI}" == "N" ]; then
			[ ${database:-X} == CHECK ] && echo "* CHECK: ITEM: ${item}" >&2
			
			printf "/ECHO %%C4,1%%BERRORE:\t%%C7,1 La risorsa (%d) %%C9,1 %s%%C7,1 (%%C9,1 %s%%C7,1 ) [%%C8,1 %s:%s:%s%%C7,1 ] non contiene sufficienti dati per l'auto-download e non ne hai configurato il Network Alias.\n" ${item_number} "${item_filename:-?}" "${item_size:-?}" "${item_network:-%C4,1UNKNOWN%C8,1}" "${item_channel:-%C4,1UNKNOWN%C8,1}" "${item_botname:-%C4,1UNKNOWN%C8,1}"
			printf "/ECHO %%BSUGGERIMENTO:\t%%C9,1 Puoi collegarti al network%%C5,1 %s%%C9,1, nel canale%%C5,1 %s%%C9,1 e lanciare il comando%%C0,1 %s%%C9,1 .\n" "${item_network_name}" "${item_channel}" "${item_command}"
		    else
			item_number=$((${item_number} - 1))
		    fi
		fi
		
		if [ ${item_number} == ${NUMERO_MASSIMO_DI_RISULTATI} ]; then
		    echo "/ECHO %C4,1ATTENZIONE: Numero massimo di risultati (${NUMERO_MASSIMO_DI_RISULTATI}/${total_result}) visualizzabili raggiunto."
		    flag_skip_other_result=1
		fi
	    done
	    
	    printf 'FINE DELLA RISOLUZIONE DEI NETWORK.\n' >&2
	else
	    printf 'AVVIO GENERAZIONE RISULTATO RICERCA:\n' >&2
	    flag_last_item_error=0
	    
	    # ${item_number} "${item_network}" "${item_channel}" "${item_botname}" "${item_filename}" "${item_size}" "${item_command}"
	    # ID[1] NetworkName[2] NetworkServer[3] Channel[4] Botserv[5] PackID[6] Filename[7] Dimension[8] Command[9]
	    [ -f "${tempfile}" ] && \
		cat "${tempfile}" \
		| sort \
		| cat -n \
		| sed 's@^ *@@' \
		| awk -F'\t' '{print $1"\t"$3"\t"$4"\t"$5"\t"$7"\t"$8"\t"$9}' \
		>> "${search_engine_db}"

	    total_result=$(cat "${search_engine_db}" | wc -l)
	    printf 'INDIVIDUATI %d RECORDS.\n' "${total_result}" >&2
	    
	    if [ "${ELENCA_RISULTATI_SENZA_FORMATTAZIONE}" == "N" ]; then
		head -n ${NUMERO_MASSIMO_DI_RISULTATI} "${tempfile}" \
		    | sort \
		    | grep -v ^$ \
		    | cat -n \
		    | sed 's@^ *@@' \
		    | awk -F'\t' '{printf "/ECHO [%%B http://xdcc_%s%%O ]\t%%C3,1%%B%3d) %%C4,1 %16s%%C5,1 %16s%%C6,1 %16s%%C7,1 %6s%%C8,1 %s%%O\n", $1, $1, substr($3, 1, 16), substr($4, 1, 16), substr($5, 1, 16), $8, $7}'
	    else
		head -n ${NUMERO_MASSIMO_DI_RISULTATI} "${tempfile}" \
		    | sort \
		    | grep -v ^$ \
		    | cat -n \
		    | sed 's@^ *@@' \
		    | awk -F'\t' '{printf "/ECHO [%%B http://xdcc_%s%%O ]\t%%C3,1%%B%3d) %%C4,1 %16s%%C5,1 %16s%%C6,1 %16s%%C7,1 %6s%%C8,1 %s%%O\n", $1, $1, $3, $4, $5, $8, $7}'
	    fi
	    
	    if [ ${total_result} -ge ${NUMERO_MASSIMO_DI_RISULTATI} ]; then
		echo "/ECHO %C4,1ATTENZIONE: Numero massimo di risultati (${NUMERO_MASSIMO_DI_RISULTATI}/${total_result}) visualizzabili raggiunto."
	    fi
	    
	    printf 'FINE GENERAZIONE RISULTATO RICERCA.\n' >&2
	fi

	if [ ${flag_last_item_error} == 0 ]; then
	    if [ "${check_plugin_type}" != "WEB" ]; then
		item_number=$(tail -n 1 "${tempfile}" | cat -n | sed 's@^ *@@' | awk -F'\t' '{print $1}')
		item_filename=$(tail -n 1 "${tempfile}" | cat -n | sed 's@^ *@@' | awk -F'\t' '{print $5}')
		item_size=$(tail -n 1 "${tempfile}" | cat -n | sed 's@^ *@@' | awk -F'\t' '{print $6}')
	    fi
	    
	    echo "/ECHO Esempio: %C9,1/budus macro xdcc d ${item_number}"
	    echo "/ECHO          %C8,1Scarica il file%C3,1 ${item_filename}%C8,1 da%C3,1 ${item_size}"
	fi
	
	[ -f "${tempfile}" ] && cp -f "${tempfile}" "${db_default_path}last_result.dat"
	[ -f "${tempfile}" ] && rm -f "${tempfile}"
	
	IFS=${IFS_OLD}
    fi
}

#####################################################################
#____________________________________________________________________
# Stampa la guida dello script.
function print_help() {
    debug_print ">" 'print_help'
    
    echo "/ECHO %C3,1%B /budus macro xdcc s keyword"
    echo "/ECHO %C8,1      Cerca la stringa <keyword> e mostra i risultati (SEARCH)."
    echo "/ECHO %C3,1%B /budus macro xdcc d num"
    echo "/ECHO %C8,1      Dai risultati ottenuti dal SEARCH, si ottiene l'ID (da non condondere con i numeri di PACK) relativo al file che si desidera scaricare. Tramite la sintassi %B/budus macro xdcc d %UID%O%C8,1 vengono lanciati i comandi necessari per scaricare il file."
    echo "/ECHO %C3,1%B /budus macro xdcc p <filename>"
    echo "/ECHO %C8,1      Viene caricato il file <filename> di testo contenente la lista dei download da effettuare \"manualmente\"; la lista deve comprendere, per ogni riga e con le colonne separate da tabulazione, rispettivamente: network, canale, nickname, PACK ID e nome del file"
    echo "/ECHO %C3,1%B /budus macro xdcc p <nickname> <PACK_ID> <nome_del_file>"
    echo "/ECHO %C8,1      Viene inserito un download \"manualmente\" (cioe' fornendo i dati necessari a mano); network e canale di esecuzione saranno quelli della finestra corrente. Se <nome_del_file> contiene spazi, usare \" ."
    echo "/ECHO %C3,1%B /budus macro xdcc p <network> <canale> <nickname> <PACK_ID> <nome_del_file>"
    echo "/ECHO %C8,1      Viene inserito un download \"manualmente\" (cioe' fornendo tutti i dati necessari a mano). Se <nome_del_file> contiene spazi, usare \" ."
    echo "/ECHO %C3,1%B /budus macro xdcc f ID"
    echo "/ECHO %C8,1      Viene forzato il download relativo all'ID specificato."
    echo "/ECHO %C3,1%B /budus macro xdcc c ID"
    echo "/ECHO %C8,1      Viene annullato il download relativo all'ID specificato."
    echo "/ECHO %C3,1%B /budus macro xdcc l"
    echo "/ECHO %C8,1      Elenca lo stato della Coda dei Download."
    echo "/ECHO %C3,1%B /budus macro xdcc a"
    echo "/ECHO %C8,1      Elenca i Download abortiti."
    echo "/ECHO %C3,1%B /budus macro xdcc menu"
    echo "/ECHO %C8,1      Carica il menu di comando per XChat dedicato alla gestione dei trasferimenti XDCC."
    echo "/ECHO %C3,1%B /budus macro xdcc umenu"
    echo "/ECHO %C8,1      Elimina il menu di comando per XChat dedicato alla gestione dei trasferimenti XDCC."
    echo "/ECHO %C3,1 "
    echo "/ECHO %C5,1 Esempi:"
    echo "/ECHO %C7,1 /budus macro xdcc s buduscript"
    echo "/ECHO %C7,1 /budus macro xdcc d 3"
    echo "/ECHO %C3,1 "
    echo "/ECHO %C9,1 Se e' stato aggiunto il menu, c'e' la possibilita' di effettuare il download automatico semplicemente facendo click con il tasto destro del mouse sui link (%B http://xdcc_...%O%C9,1) che trovi a sinistra di ogni risultato."
    
    debug_print "<" 'print_help'
}

#####################################################################
#____________________________________________________________________
# Ricarica il menu dei XBSPSE.
# ATTENZIONE: In caso di modifica, ricordarsi di aggiornare il file
# "buduscript_script__first.sh".
function load_menu_XBSPSE() {
    debug_print ">" 'load_menu_XBSPSE'
    
    cat<<EOF
/MENU ADD "XDCC/Gestione Motori di Ricerca"
/MENU ADD "XDCC/Gestione Motori di Ricerca/Ricarica la lista dei XBSPSE disponibili." "budus macro xdcc MENU_RELOAD_XBSPSE"
/MENU ADD "XDCC/Gestione Motori di Ricerca/-"
/MENU -i.xchat2/buduscript/Icons/add_16.png ADD "XDCC/Gestione Motori di Ricerca/Attiva tutti gli XBSPSE disponibili." "budus macro xdcc MENU_RELOAD_XBSPSE ACTIVATE"
/MENU -i.xchat2/buduscript/Icons/del_16.png ADD "XDCC/Gestione Motori di Ricerca/Disattiva tutti gli XBSPSE disponibili." "budus macro xdcc MENU_RELOAD_XBSPSE DEACTIVATE"
/MENU ADD "XDCC/Gestione Motori di Ricerca/-"
/MENU ADD "XDCC/Gestione Motori di Ricerca/Collegamento Automatico al Network"
/MENU ADD "XDCC/Gestione Motori di Ricerca/-"
/MENU ADD "XDCC/Gestione Motori di Ricerca/Verifica tutti gli XBSPSE installati" "budus cmd /budus macro xdcc MAKE_DB_ENABLED_XBSPSE_LIST_PASSWORD 1 \$iPidOfProcess FORCE"
/MENU ADD "XDCC/Gestione Motori di Ricerca/Visualizza ultimo LOG di controllo generato" "EXEC [ -f ${script_path}/tmp/buduscript_script__test_xbspse.log ] && xterm -e less ${script_path}/tmp/buduscript_script__test_xbspse.log || echo 'ERRORE: LOG non presente; generarne uno utilizzando il comando di Verifica.'"
/MENU ADD "XDCC/Gestione Motori di Ricerca/-"
/MENU ADD "XDCC/Gestione Motori di Ricerca/Installa XBSPSE creati e gestiti da terzi" "budus macro xdcc INSTALL_EXTERNAL_XBSPSE START"
/MENU ADD "XDCC/Gestione Motori di Ricerca/Rimuovi XBSPSE creati e gestiti da terzi"
/MENU ADD "XDCC/Gestione Motori di Ricerca/-"
EOF
    
    plugin_list=$(find "${script_path}" -maxdepth 1 -iname 'budus_xdcc_plugin_*.sh' | sort)
    for plugin in ${plugin_list}; do
	check_plugin SKIP_TYPE
	
	plugin_name=$(echo "${plugin}" | sed 's@.*budus_xdcc_plugin_@@' | cut -f1 -d'.')
	enable_plugin_command="EXEC touch ${plugin%.sh} && echo 'XDCC Search Engine Plugin%B ${plugin_name/_/ }%O%C3 enabled.'"
	disable_plugin_command="EXEC rm -f ${plugin%.sh} && echo 'XDCC Search Engine Plugin%B ${plugin_name/_/ }%O%C4 disabled.'"
	
	connection_data=$([ -f "${plugin}" ] && grep '^# PLUGIN LIST:' "${plugin}" | cut -f2- -d':' || echo "/ECHO ERRORE: XBSPSE ${plugin} non trovato.")
	if [ "${connection_data}" != "" ]; then
	    printf '/MENU ADD "XDCC/Gestione Motori di Ricerca/Collegamento Automatico al Network/%s" "%s"\n' "${plugin_name/_/ }" "budus macro connect ${connection_data}"
	fi
	
	printf '/MENU -e%d -t%d ADD "XDCC/Gestione Motori di Ricerca/%s" "%s" "%s"\n' "${flag_plugin_standard_conformed}" "${flag_plugin_enabled}" "${plugin_name/_/ }" "${enable_plugin_command}" "${disable_plugin_command}"
    done
    
    external_xbspse_package=$(find "${script_path}" -maxdepth 2 -iname '*_init.sh' | sed 's@\(.*/\|_init.sh\)@@g' | sort)
    for xbspse_package in ${external_xbspse_package}; do
	if [ "${xbspse_package}" != "buduscript" ]; then
	    printf '/MENU ADD "XDCC/Gestione Motori di Ricerca/Rimuovi XBSPSE creati e gestiti da terzi/RIMUOVI: %s" "budus pipe_script echo \(/ECHO Rimozione di %s\) && rm -r \(%s/%s\) && echo \(/budus macro xdcc MENU_RELOAD_XBSPSE\) || echo \(/ECHO ERRORE DURANTE LA RIMOZIONE\)"\n' "${xbspse_package//_/ }" "${xbspse_package}" "${script_path}" "${xbspse_package}"
	fi
    done

    debug_print "<" 'load_menu_XBSPSE'
}

#####################################################################
#____________________________________________________________________
# Crea una voce di menu per l'eliminazione di un REFLEX.
function add_menu_item_reflex() {
    debug_print ">" 'add_menu_item_reflex'
    
    is_reflex_active=$(grep -iF " ${1} ${2} ${3} " "${temp_reflex_list}")
    if [ "${is_reflex_active}" == "" ]; then
	reflex_code=${RANDOM}
	reflex_menu_item=$(printf 'REFLEX ID %d: %s [%s:%s]->%s [%s:%s]\n' "${reflex_code}" "${1}" "${2}" "${3}" "${4}" "${5}" "${6}" | sed 's,[^a-zA-Z0-9\\[\\] >-],-,g' | tr '_' '-')
	printf '%d %s %s %s %s %s %s \n' "${reflex_code}" "${1}" "${2}" "${3}" "${4}" "${5}" "${6}" >> "${temp_reflex_list}"
	
	cat<<EOF
/MENU -i.xchat2/buduscript/Icons/del_16.png ADD "XDCC/XDCC Reflex - Redirezione Download/Cancella ${reflex_menu_item}" "budus macro xdcc DEL_REFLEX_USER ${reflex_code}"
EOF
	
	printf '/ECHO %%B%%C3,1[XDCC REFLEX]\t%%O Tutti i file XDCC provenienti da %%B%s%%O [%%B%s%%O:%%B%s%%O] saranno deviati a %%B%s%%O [%%B%s%%O:%%B%s%%O].\n' "${reflex_source_user_name}" "${reflex_source_network_name}" "${reflex_source_channel_name}" "${reflex_destination_user_name}" "${reflex_destination_network_name}" "${reflex_destination_channel_name}"
	printf '/budus cmd /event addh 0 text "escape( %d:BUDUS_XDCC_REFLEX:%s ):$nickescape( :%s ):[Dd][Cc][Cc] [Ss][Ee][Nn][Dd] .* [0-9]* [0-9]* [0-9]*$='\''%d:BUDUS_XDCC_REFLEX:$hostname:$channel:$ru:$data'\''" /budus sendsess %s/%s /PRIVMSG %s :$data_BUDUS_SEPARATOR_/budus cmd /ECHO %%C3,1%%B[XDCC MANAGER]\t%%C7,1%%OFile %%Btoken( 3, ,$data )%%O rediretto a %%B%s%%O [%%B%s%%O:%%B%s%%O]"\n' "${reflex_code}" "${reflex_source_network_name}" "${reflex_source_user_name}" "${reflex_code}" "${reflex_destination_network_name}" "${reflex_destination_channel_name}" "${reflex_destination_user_name}" "${reflex_destination_user_name}" "${reflex_destination_network_name}" "${reflex_destination_channel_name}"
    else
	is_reflex_active=$(grep -iF " ${1} ${2} ${3} ${4} ${5} ${6} " "${temp_reflex_list}")
	if [ "${is_reflex_active}" == "" ]; then
	    printf '/ECHO %%B%%C4,1[XDCC REFLEX]\t%%O Tutti i file XDCC provenienti da %%B%s%%O [%%B%s%%O:%%B%s%%O] %%Urisultano gia'\'' deviati%%O.\n' "${reflex_source_user_name}" "${reflex_source_network_name}" "${reflex_source_channel_name}"
	else
	    printf '/ECHO %%B%%C4,1[XDCC REFLEX]\t%%O Tutti i file XDCC provenienti da %%B%s%%O [%%B%s%%O:%%B%s%%O] %%Urisultano gia'\'' deviati%%O a %%B%s%%O [%%B%s%%O:%%B%s%%O].\n' "${reflex_source_user_name}" "${reflex_source_network_name}" "${reflex_source_channel_name}" "${reflex_destination_user_name}" "${reflex_destination_network_name}" "${reflex_destination_channel_name}"
	fi
    fi
    
    debug_print "<" 'add_menu_item_reflex'
}

#####################################################################
#____________________________________________________________________
# Estrapola i dati da un record.
function get_data_from_reflex_item() {
    debug_print ">" 'get_data_from_reflex_item'
    
    reflex_code=$(echo "${reflex_item}" | awk -F' ' '{print $1}')
    reflex_source_user_name=$(echo "${reflex_item}" | awk -F' ' '{print $2}')
    reflex_source_network_name=$(echo "${reflex_item}" | awk -F' ' '{print $3}')
    reflex_source_channel_name=$(echo "${reflex_item}" | awk -F' ' '{print $4}')
    reflex_destination_user_name=$(echo "${reflex_item}" | awk -F' ' '{print $5}')
    reflex_destination_network_name=$(echo "${reflex_item}" | awk -F' ' '{print $6}')
    reflex_destination_channel_name=$(echo "${reflex_item}" | awk -F' ' '{print $7}')
    
    debug_print "<" 'get_data_from_reflex_item'
}

#####################################################################
#____________________________________________________________________
# Elimina una voce di menu di un REFLEX.
function del_menu_item_reflex() {
    debug_print ">" 'del_menu_item_reflex'
    
    if [ -f "${temp_reflex_list}" ]; then
	reflex_item=$(cat "${temp_reflex_list}" | grep "^${reflex_code} ")
	
	mv -f "${temp_reflex_list}" "${temp_reflex_list}.tmp"
	cat "${temp_reflex_list}.tmp" | grep -v "^${reflex_code} " > "${temp_reflex_list}"
	rm -f "${temp_reflex_list}.tmp"
	
	get_data_from_reflex_item
	reflex_menu_item=$(printf 'REFLEX ID %d: %s [%s:%s]->%s [%s:%s]\n' "${reflex_code}" "${reflex_source_user_name}" "${reflex_source_network_name}" "${reflex_source_channel_name}" "${reflex_destination_user_name}" "${reflex_destination_network_name}" "${reflex_destination_channel_name}" | sed 's,[^a-zA-Z0-9\\[\\] >-],-,g' | tr '_' '-')
	
	cat<<EOF
/MENU DEL "XDCC/XDCC Reflex - Redirezione Download/Cancella ${reflex_menu_item}"
EOF
	printf '/event listh %d:BUDUS_XDCC_REFLEX -\n' "${reflex_code}"
	
	printf '/ECHO %%B%%C8,1[XDCC REFLEX]\t%%O Tutti i file XDCC provenienti da %%B%s%%O [%%B%s%%O:%%B%s%%O] %%Unon saranno%%O piu'\'' deviati a %%B%s%%O [%%B%s%%O:%%B%s%%O].\n' "${reflex_source_user_name}" "${reflex_source_network_name}" "${reflex_source_channel_name}" "${reflex_destination_user_name}" "${reflex_destination_network_name}" "${reflex_destination_channel_name}"
    else
	printf '/ECHO %%B%%C4,1ERRORE:\t%%O%%C4,1 Si e'\'' verificato un problema interno nella gestione dei REFLEX. Segnalare il problema, se persiste. (del_menu_item_reflex)\n'
	[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
    fi
    
    debug_print "<" 'del_menu_item_reflex'
}

#####################################################################
#____________________________________________________________________
function lock_db() {
    debug_print ">" 'lock_db'
    
    [ ${flag_skip_lock_db:-0} == 1 ] && return 1
    
    db_path="${1}"
    
    while [ -f "${lock_db}" ]; do
	sleep 0.5
	iterator=$((${iterator:-0} + 1))
	
	[ ${iterator:-16} -ge 16 ] && rm -f "${lock_db}"
    done
    
    random_code=${RANDOM}
    echo "${random_code}" > "${lock_db}"
    sleep 0.5
    
    if [ -f "${lock_db}" ] && [ "$(grep "^${random_code}$" "${lock_db}")" == "${random_code}" ]; then
	debug_print "<" 'lock_db :: 1'
	
	return 1
    else
	printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE FATALE:%%O Impossibile fare il LOCK del Database [%%B %s%%O ].\n' "${db_path:-INTERNAL_ERROR}"
	[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
    fi
    
    debug_print "<" 'lock_db'
    
    exit 1;
}

#####################################################################
#____________________________________________________________________
function unlock_db() {
    debug_print ">" 'unlock_db'
    
    [ ${flag_skip_lock_db:-0} == 0 ] && [ -f "${lock_db}" ] && rm -f "${lock_db}"

    debug_print "<" 'unlock_db'
}

#####################################################################
#____________________________________________________________________
# Cerca all'interno del database specificato un ITEM.
function find_item_in_db() {
    debug_print ">" "find_item_in_db(${1:-NONE}, ${2:-NONE})"
    
    db_path="${1}"
    item_to_find="${2}"
    
    if [ -f "${db_path:-INTERNAL_ERROR}" ]; then
	lock_db "${db_path}"
	
	find_item_in_db_result=$(cat "${db_path}" | grep -iF "${item_to_find:-INTERNAL_ERROR}" | head -n1)
	
	unlock_db
	
	debug_print "*" "find_item_in_db - find_item_in_db_result = ${find_item_in_db_result}"
	
	[ "${find_item_in_db_result}" != "" ] && flag_static_find_item_in_db=1 && return 1
    elif [ "${3}" != "NO_ERROR" ]; then
	printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O Database [%%B %s%%O ] non trovato.\n' "${db_path:-INTERNAL_ERROR}"
	[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
    fi
    
    debug_print "<" 'find_item_in_db'

    return 0
}

#####################################################################
#____________________________________________________________________
# Cerca all'interno del database specificato un ITEM in base al solo
# codice.
function find_item_in_db_by_code() {
    debug_print ">" "find_item_in_db_by_code(${1:-NONE}, ${2:-NONE})"
    
    db_path="${1}"
    item_to_find="${2}"
    
    if [ -f "${db_path:-INTERNAL_ERROR}" ]; then
	lock_db "${db_path}"
	
	find_item_in_db_result=$(cat "${db_path}" | grep -i "^	${item_to_find:-INTERNAL_ERROR}" | head -n1)
	
	unlock_db
	
	debug_print "*" "find_item_in_db_by_code - find_item_in_db_result = ${find_item_in_db_result}"
	
	[ "${find_item_in_db_result}" != "" ] && flag_static_find_item_in_db=1 && return 1
    elif [ "${3}" != "NO_ERROR" ]; then
	debug_print "*" "DB ${db_path} MISSING"
	
	printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O Database [%%B %s%%O ] non trovato.\n' "${db_path:-INTERNAL_ERROR}"
	[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
    fi
    
    debug_print "<" 'find_item_in_db_by_code'

    return 0
}

#####################################################################
#____________________________________________________________________
function add_item_to_db() {
    debug_print ">" "add_item_to_db(${1:-NONE}, ${2:-NONE})"

    db_path="${1}"
    item_to_add="${2}"
    
    lock_db "${db_path}"
    
    printf '%s\n' "${item_to_add}" >> "${db_path}"
    
    unlock_db

    debug_print "<" 'add_item_to_db'
}

#####################################################################
#____________________________________________________________________
function remove_item_from_db() {
    debug_print ">" "remove_item_from_db(${1:-NONE}, ${2:-NONE})"

    db_path="${1}"
    item_to_remove="${2}"
    
    lock_db "${db_path}"
    
    debug_print "*" "remove_item_from_db - item_to_remove=$(cat "${db_path}" | grep -F "${item_to_remove}")"

    if [ -f "${db_path:-INTERNAL_ERROR}" ]; then
	temp_db=$(cat "${db_path}" | grep -vF "${item_to_remove}" | grep -v '^$')
	if [ "${temp_db}" != "" ]; then
	    echo "${temp_db}" > "${db_path}"
	else
	    rm -f "${db_path}"
	fi
    fi
    
    unlock_db

    debug_print "<" 'remove_item_from_db'
}

#####################################################################
#____________________________________________________________________
function get_data_from_item() {
    debug_print ">" 'get_data_from_item'

    [ "${ITEM}" == "" ] && \
	printf '/budus sendsess $focus_tab /ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O Gestione del Database fallita; se il problema persiste, contattare UDA'\''Software.\n' && \
	debug_print "*" "ITEM = NULL *** INTERNAL ERROR ***" && \
	exit 1;
    
    debug_print "*" "ITEM = ${ITEM}"
    
    item_code=$(echo "${ITEM}" | awk -F'\t' '{print $2}')
    item_ID=$(echo "${ITEM}" | awk -F'\t' '{print $3}')
    item_network=$(echo "${ITEM}" | awk -F'\t' '{print $4}')
    item_channel=$(echo "${ITEM}" | awk -F'\t' '{print $5}')
    item_botserv=$(echo "${ITEM}" | awk -F'\t' '{print $6}')
    item_filename=$(echo "${ITEM}" | awk -F'\t' '{print $7}')
    item_size=$(echo "${ITEM}" | awk -F'\t' '{print $8}')
    item_command=$(echo "${ITEM}" | awk -F'\t' '{print $9}')

    debug_print "*" "item_code = ${item_code} / item_ID = ${item_ID} / ${item_network} / item_channel = ${item_channel} / item_botserv = ${item_botserv} / item_filename = ${item_filename} / item_size = ${item_size} / item_command = ${item_command}"
    
    debug_print "<" 'get_data_from_item'
}

#####################################################################
#____________________________________________________________________
function db_recover() {
    debug_print ">" "db_recover(${1:-NONE}, ${2:-NONE})"
    
    debug_print "*" "${1} == $([ -f "${1}" ] && cat "${1}" | wc -l || echo "NULL")"
    
    if [ -f "${1}" ] && [ $(cat "${1}" | wc -l) -gt 0 ]; then
	IFS=$'\n'
	for db_recovered in ${1}; do
	    flag_db_recovered=1
	    
	    for ITEM in $(cat "${db_recovered}"); do
		get_data_from_item
		ITEM=$(echo "${ITEM}" | sed 's@^	T@	X@')
		
		check_ITEM=$(echo "${ITEM}" \
		    | grep -i '^	[XT][0-9]\{10\}	[0-9]*	[a-zA-Z0-9._-]*	#.*	[^ ]*	.*	\([0-9\.]*\)\?[a-zA-Z]*	/.*$')
		
		if [ "${check_ITEM}" != "" ]; then
		    check_ITEM=1
		    
		    add_item_to_db "${download_queue_db}" "${ITEM}"
		    add_item_to_menu "QUEUE"
		else
		    check_ITEM=0
		    
		    printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t ATTENZIONE:%%O Non posso recuperare il download%%B %s%%O; risulta malformato (ID = %s / Network = %s / Channel = %s / Botserv = %s / File Name = %s / Size = %s / Command = %s).\n' "${item_code}" "${item_ID}" "${item_network}" "${item_channel}" "${item_botserv}" "${item_filename}" "${item_size}" "${item_command}"
		    
		    printf '/budus sendsess $focus_tab /ECHO %%B%%C4,1[XDCC MANAGER]\t SOLUZIONE :%%O Tentare il ripristino manuale con il seguente comando:%%B /budus macro xdcc p \"%s\" \"%s\" \"%s\" \"%s\" \"%s\"\n' "${item_network}" "${item_channel}" "${item_botserv}" "${item_command}" "${item_filename}"
		fi
		
		debug_print "*" "check_ITEM = ${check_ITEM} : ITEM = ${ITEM}"
	    done
	    
	    [ "${2}" != "do_not_remove_db" ] && rm -f "${db_recovered}"
	done
    fi
    
    debug_print "<" 'db_recover'
}

#####################################################################
#____________________________________________________________________
function purge_db() {
    debug_print ">" "purge_db(${1:-NONE}, ${2:-NONE})"

    db_path="${1}"
    max_items="${2}"
    
    lock_db "${db_path}"
    
    temp_db=$(cat "${db_path}" | grep -v '^$' | tail -n${max_items:-1})
    if [ "${temp_db}" != "" ]; then
	echo "${temp_db}" > "${db_path}"
    else
	rm -f "${db_path}"
    fi
    
    unlock_db

    debug_print "<" 'purge_db'
}

#####################################################################
#____________________________________________________________________
function read_db() {
    debug_print ">" "read_db(${1:-NONE}, ${2:-NONE})"
    
    db_path="${1}"
    db_name="${2}"
    
    lock_db "${db_path}"
    
    db_semi_path=$(echo "${db_path}" | grep "s@${db_default_path}@@")
    db_to_recover="${db_saved_path}${db_semi_path}"
    if [ -f "${db_path}" ] && [ $(cat ${db_path} | wc -l) -gt 0 ]; then
	printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t ATTENZIONE:%%O Non posso recuperare il download%%B %s%%O; risulta usato in questa sessione di XChat.\n' "${db_name}"
	[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' w
    else
	printf '/budus sendsess $focus_tab /ECHO %%B%%C3,1[XDCC MANAGER]\t RECUPERO DOWNLOAD:%%O %%B %s%%O.\n' "${db_name}"
	
	case "${db_name}" in
	    "CODA")
		db_recover "${db_to_recover}"
		;;
	    "ELABORAZIONE")
		db_recover "${db_to_recover}"
		;;
	    "RICHIESTA")
		db_recover "${db_to_recover}"
		;;
	    "TRASFERIMENTO")
		db_recover "${db_to_recover}"
		;;
	    "CRONOLOGIA")
		for ITEM in $(cat "${db_to_recover}"); do
		    get_data_from_item
		    add_item_to_db "${repeat_db}" "${ITEM}"
		    add_item_to_menu "REPEAT"
		done
		rm -f "${db_to_recover}"
		;;
	    "FALLIMENTI")
		for ITEM in $(cat "${db_to_recover}"); do
		    get_data_from_item
		    add_item_to_db "${failed_db}" "${ITEM}"
		done
		purge_db "${failed_db}" 20
		rm -f "${db_to_recover}"
		;;
	    "RICERCHE")
		for parameters in $(cat "${db_to_recover}"); do
		    get_data_from_item
		    add_item_to_db "${search_pattern_db}" "${parameters}"
		    cat<<EOF
/MENU ADD "XDCC/Ripeti Ricerca/${parameters}" "budus macro xdcc s ${parameters}"
EOF
		done
		rm -f "${db_to_recover}"
		;;
	    *)
		printf '/budus sendsess $focus_tab /ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O Si e'\'' verificata una situazione non prevista nel recupero del download %s\n' "${db_path:-NULL}" "${db_name:-NULL}"
		[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
		;;
	esac
    fi
    
    unlock_db
    
    debug_print "<" 'read_db'
}

#####################################################################
#____________________________________________________________________
function save_db() {
    debug_print ">" "save_db(${1:-NONE}, ${2:-NONE})"
    
    db_path="${1}"
    db_name="${2}"
    
    lock_db "${db_path}"
    
    db_semi_path=$(echo "${db_path}" | grep "s@${db_default_path}@@")
    if [ -f "${db_path}" ]; then
	printf '/budus sendsess $focus_tab /ECHO %%B%%C3,1[XDCC MANAGER]\t SALVATAGGIO DOWNLOAD:%%O %%B %s%%O.\n' "${db_name}"
	
	cp -f "${db_path}" "${db_saved_path}${db_semi_path}"
    else
	printf '/budus sendsess $focus_tab /ECHO %%B%%C3,1[XDCC MANAGER]\t PULIZIA DOWNLOAD    :%%O %%B %s%%O.\n' "${db_name}"
	
	rm -f "${db_saved_path}${db_semi_path}"
    fi
    
    unlock_db
    
    debug_print "<" 'save_db'
}

#####################################################################
#____________________________________________________________________
function add_item_to_menu() {
    debug_print ">" "add_item_to_menu(${1:-NONE})"
    
    menu_type="${1}"
    
    get_data_from_item
    
    menu_item=$(printf '%s : %s [%s:%s:%s]-[%s]\n' "${item_code}" "${item_filename}" "${item_network}" "${item_channel}" "${item_botserv}" "${item_size}" | sed 's@[^][a-zA-Z0-9 :. -{}()]@ @g')
    
    case "${menu_type}" in
	"QUEUE")
	    printf '/MENU ADD "XDCC/Download in Coda/FORZA/%s" "budus macro xdcc f %s"\n' "${menu_item}" "${item_code}"
	    printf '/MENU ADD "XDCC/Download in Coda/CANCELLA/%s" "budus macro xdcc c %s"\n' "${menu_item}" "${item_code}"
	    ;;
	"WAITING")
	    printf '/MENU ADD "XDCC/Download in Elaborazione/%s" "budus macro xdcc c %s"\n' "${menu_item}" "${item_code}"
	    ;;
	"REQUEST")
	    printf '/MENU ADD "XDCC/Download in Elaborazione/%s" "budus macro xdcc c %s"\n' "${menu_item}" "${item_code}"
	    ;;
	"TRANSFER")
	    printf '/MENU ADD "XDCC/Download in Trasferimento/%s" "budus macro xdcc c %s"\n' "${menu_item}" "${item_code}"
	    ;;
	"REPEAT")
	    printf '/MENU ADD "XDCC/Cronologia Download/%s" "budus macro xdcc d %s"\n' "${menu_item}" "${item_code}"
	    ;;
	*)
	    debug_print "*" 'add_item_to_menu: INTERNAL ERROR'
	    ;;
    esac
    
    debug_print "<" 'add_item_to_menu'
}

#####################################################################
#____________________________________________________________________
function remove_item_from_menu() {
    debug_print ">" "remove_item_from_menu(${1:-NONE}, ${2:-NONE})"
    
    menu_type="${1}"
    
    get_data_from_item
    
    menu_item=$(printf '%s : %s [%s:%s:%s]-[%s]\n' "${item_code}" "${item_filename}" "${item_network}" "${item_channel}" "${item_botserv}" "${item_size}" | sed 's@[^][a-zA-Z0-9 :. -{}()]@ @g')
    
    case "${menu_type}" in
	"QUEUE")
	    printf '/MENU DEL "XDCC/Download in Coda/FORZA/%s" "budus macro xdcc f %s"\n' "${menu_item}" "${item_code}"
	    printf '/MENU DEL "XDCC/Download in Coda/CANCELLA/%s" "budus macro xdcc c %s"\n' "${menu_item}" "${item_code}"
	    ;;
	"WAITING")
	    printf '/MENU DEL "XDCC/Download in Elaborazione/%s" "budus macro xdcc c %s"\n' "${menu_item}" "${item_code}"
	    ;;
	"REQUEST")
	    printf '/MENU DEL "XDCC/Download in Elaborazione/%s" "budus macro xdcc c %s"\n' "${menu_item}" "${item_code}"
	    ;;
	"TRANSFER")
	    printf '/MENU DEL "XDCC/Download in Trasferimento/%s" "budus macro xdcc c %s"\n' "${menu_item}" "${item_code}"
	    ;;
	"REPEAT")
	    printf '/MENU DEL "XDCC/Cronologia Download/%s" "budus macro xdcc d %s"\n' "${menu_item}" "${item_code}"
	    ;;
	*)
	    debug_print "*" 'add_item_to_menu: INTERNAL ERROR'
	    ;;
    esac
    
    debug_print "<" 'remove_item_from_menu'
}

#####################################################################
#____________________________________________________________________
function get_first_item_from_db() {
    debug_print ">" "get_first_item_from_db(${1:-NONE})"

    db_path="${1}"
    
    if [ -f "${db_path:-INTERNAL_ERROR}" ]; then
	lock_db "${db_path}"
	
	get_first_item_from_db_result=$(head -n1 "${db_path}")
	mv -f "${db_path}" "${db_path}.swap"
	cat "${db_path}.swap" | grep -vF "${get_first_item_from_db_result}" > "${db_path}"
	rm -f "${db_path}.swap"
	printf '%s\n' "${get_first_item_from_db_result}"
	
	unlock_db
	
	debug_print "*" "get_first_item_from_db - find_item_in_db_result = ${find_item_in_db_result}"
	
	[ "${find_item_in_db_result}" != "" ] && return 1
    elif [ "${2}" != "NO_ERROR" ]; then
	printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O Database [%%B %s%%O ] non trovato.\n' "${db_path:-INTERNAL_ERROR}"
	[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
    fi
    
    debug_print "<" 'get_first_item_from_db'

    return 0
}

#####################################################################
#____________________________________________________________________
# Esegue le operazioni necessarie per lanciare il download.
function search_server_for_network_connection_in_db() {
    debug_print ">" "search_server_for_network_connection_in_db(${1:-NONE}, ${2:-NONE}, ${3:-NONE})"

    item_network_domain="${1}"
    db_to_search="${2:-${database}}"
    pattern_search="${3}"
    
    [ "${db_to_search}" != "${database}" ] && [ ! -f "${db_to_search}" ] && return 0
    
    default_item_network_domain=${item_network_domain}
    segment_num_item_network_domain=$(echo "${item_network_domain}" | sed 's@\..\{1,3\}$@@' | sed 's@[^\.]*@@g' | wc -c)
    
    for ((segment=1; ${segment} <= ${segment_num_item_network_domain:-0}; segment=${segment} + 1)); do
	segment_item_network_domain=$(echo "${item_network_domain}" | cut -f${segment:-0}- -d'.')
	
	if [ "${pattern_search}" == "" ]; then
	    max_item_network_domain=$(cat "${db_to_search}" \
		| awk -F'\t' '{print $1}' \
		| grep -iF "${segment_item_network_domain}" \
		| sort \
		| uniq \
		| tail -n1)
	elif [ "${pattern_search}" == "-" ]; then
	    max_item_network_domain=$(cat "${db_to_search}" \
		| awk -F'\t' '{print $4}' \
		| grep -iF "${segment_item_network_domain}" \
		| sort \
		| uniq \
		| tail -n1)
	else
	    max_item_network_domain=$(cat "${db_to_search}" \
		| grep -iF "${pattern_search}" \
		| awk -F'\t' '{print $1}' \
		| grep -iF "${segment_item_network_domain}" \
		| sort \
		| uniq \
		| tail -n1)
	fi
	
	debug_print "*" "search_server_for_network_connection_in_db - segment_item_network_domain = ${segment_item_network_domain} / max_item_network_domain=${max_item_network_domain}"
	
	if [ "${max_item_network_domain}" != "" ]; then
	    item_network_domain=${max_item_network_domain}
	    
	    debug_print "<" 'search_server_for_network_connection_in_db :: 1'
	    
	    printf '%s\n' "${item_network_domain}" && return 1
	fi
    done
    
    debug_print "*" 'FAILED FIRST RESOLUTION'
    
    item_network_domain=${default_item_network_domain}
    
    item_network_domain=$(echo "${item_network_domain}" \
	| sed 's@\.\([Oo][Rr][Gg]\|[Nn][Ee][Tt]\|[Cc][Oo][Mm]\|[Ii][Tt]\|[Ee][Uu]\)$@@' \
	| sed 's@^[Ii][Rr][Cc]\.@@')
    
    if [ "${pattern_search}" == "" ]; then
	max_item_network_domain=$(cat "${db_to_search}" \
	    | awk -F'\t' '{print $1}' \
	    | grep -iF "${item_network_domain}" \
	    | sort \
	    | uniq)
    elif [ "${pattern_search}" == "+" ]; then
	max_item_network_domain=$(cat "${db_to_search}" \
	    | awk -F'\t' '{print $4}' \
	    | grep -iF "${item_network_domain}" \
	    | sort \
	    | uniq)
    else
	max_item_network_domain=$(cat "${db_to_search}" \
	    | grep -iF "${pattern_search}" \
	    | awk -F'\t' '{print $1}' \
	    | grep -iF "${item_network_domain}" \
	    | sort \
	    | uniq)
    fi
    
    debug_print "*" "search_server_for_network_connection_in_db - segment_item_network_domain = ${segment_item_network_domain} / max_item_network_domain=${max_item_network_domain}"
    
    if [ "${max_item_network_domain}" != "" ] && 
	[ $(echo "${max_item_network_domain}" | wc -l) == 1 ]; then
	item_network_domain=${max_item_network_domain}
	
	debug_print "<" 'search_server_for_network_connection_in_db :: 1'
	
	printf '%s\n' "${item_network_domain}" && return 1
    fi
    
    item_network_domain=${default_item_network_domain}
    
    debug_print "<" 'search_server_for_network_connection_in_db'
    
    printf '%s\n' "${item_network_domain}" && return 0
}

#####################################################################
#____________________________________________________________________
function update_xbspse_database_for_network_channel() {
    debug_print ">" "update_xbspse_database_for_network_channel(${1:-NONE}, ${2:-NONE})"
    
    network_to_find="${1}"
    channel_to_find="${2}"
    
    if [ "${network_to_find}" != "" ] && [ "${channel_to_find}" != "" ]; then
	# Cerca gli XBSPSE che sono solo un link, ed elimina quelli "broken".
	delete_xbspse_unlinked
	
	active_plugin_list=$(find "${script_path}" -maxdepth 1 -iname 'budus_xdcc_plugin_*' | grep -v '\.old$')
	
	IFS_OLD=${IFS}
	IFS=$'\n'
	
	debug_print "*" "# PLUGIN LIST:${network_to_find} ${channel_to_find}"
	
	for plugin in ${active_plugin_list}; do
	    is_plugin_compatible=$(grep -iF "# PLUGIN LIST:${network_to_find} ${channel_to_find}" "${plugin}")
	    
	    if [ "${is_plugin_compatible}" != "" ]; then
		plugin_name=$(echo "${plugin}" | sed 's@.*budus_xdcc_plugin_@@' | cut -f1 -d'.')
		
		printf '/budus sendsess $focus_tab /ECHO [XDCC MANAGER]\t %%C4,1Il plugin%%B %s%%O%%C4,1 risulta funzionante ma, probabilmente, possiede un database semi-permanente obsoleto; lo elimino in modo che venga automaticamente aggiornato alla prossima ricerca.\n' "${plugin_name}"
		printf '/budus sendsess $focus_tab /ECHO [XDCC MANAGER]\t %%C3,1Se il problema persiste, si consiglia di disabilitare il plugin%%B %s%%O%%C3,1 e comunicare l'\''anomalia a UDA'\''Software.\n' "${plugin_name}"
		
		date_code=$(date +%Y%m%d)
		permanent_database_path="/tmp/budus_XDCC_db_${plugin_name}.${date_code}"
		
		if [ -f "${permanent_database_path}" ]; then
		    debug_print "*" "plugin = ${plugin} : ${permanent_database_path}"
		    
		    rm "${permanent_database_path}"
		fi
	    fi
	done
	
	IFS=${IFS_OLD}
    fi
    
    debug_print "<" 'update_xbspse_database_for_network_channel'
}

#####################################################################
#____________________________________________________________________
function connection_error_manager() {
    debug_print ">" "connection_error_manager(${1:-NONE})"

    error_type="${1}"
    
    case "${error_type}" in
	"SERVER_NOT_FOUND")
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C9,1[XDCC MANAGER]\t ATTENZIONE:%%O Non risulti collegato al Network [%%B %s%%O ]; mi collego in automatico.\n' "${2}"
	    
	    printf '/budus if $iPKIgnoreCTCPVersion = 0 /budus sendsess $focus_tab /ECHO [XDCC MANAGER]\t %%C8,1%%BATTENZIONE:%%O%%C8,1 Il Private Killer System risulta abilitato a filtrare i messaggi CTCP VERSION. Questo puo'\'' comportare malfunzionamenti - impossibilita'\'' a collegarsi - nel caso in cui il network o il canale non siano abilitati ai messaggi privati.\n'
	    
	    ;;
	"CHANNEL_NOT_FOUND")
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C9,1[XDCC MANAGER]\t ATTENZIONE:%%O Risulti collegato al Network [%%B %s%%O ] ma non dentro al Canale [%%B %s%%O ]; entro in automatico.\n' "${2}" "${3}"
	    
	    ;;
	"BOTSERV_NOT_FOUND")
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O Risulti collegato al Network [%%B %s%%O ] e dentro al Canale [%%B %s%%O ] ma il BOTSERV [%%B %s%%O ] non risulta presente; devo abortire.\n' "${2}" "${3}" "${4}"
	    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C3,1[XDCC MANAGER]\t SUGGERIMENTO:%%O I dati forniti dal Motore di Ricerca potrebbero essere obsoleti; alcuni consigli: ripetere la ricerca, selezionare una fonte diversa, abilitare un Plugin di Ricerca (XBSPSE) diverso (prediligi quelli dedicati ad uno specifico server/canale).\n' "${2}"
	    
	    remove_item_from_db "${connect_server_db}" "	${item_network}	"
	    remove_item_from_db "${waiting_db}" "${ITEM}"
	    remove_item_from_menu "WAITING" "${ITEM}"
	    
	    add_item_to_db "${failed_db}" "${ITEM}"
	    purge_db "${failed_db}" 20
	    
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C5,1[XDCC MANAGER]\t %%O Dati download fallito:\n'
	    printf '/budus sendsess $focus_tab /ECHO * CODE    :%%B %64s\n' "${item_code}"
	    printf '/budus sendsess $focus_tab /ECHO * Network :%%B %64s\n' "${item_network}"
	    printf '/budus sendsess $focus_tab /ECHO * Channel :%%B %64s\n' "${item_channel}"
	    printf '/budus sendsess $focus_tab /ECHO * BotServ :%%B %64s\n' "${item_botserv}"
	    printf '/budus sendsess $focus_tab /ECHO * Filename:%%B %64s\n' "${item_filename}"
	    printf '/budus sendsess $focus_tab /ECHO * Size    :%%B %64s\n' "${item_size}"
	    printf '/budus sendsess $focus_tab /ECHO * Command :%%B %64s\n' "${item_command}"
	    
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C9,1[XDCC MANAGER]\t Per ripetere la ricerca della risorsa fallita, usa questo link: http://xdcc_SEARCH_%s\n' "${item_code}"
	    
	    if [ ${AGGIORNA_AUTOMATICAMENTE_DATABASE_PERMANENTI_OBSOLETI:-Y} == "Y" ]; then
		update_xbspse_database_for_network_channel "${item_network}" "${item_channel}"
	    fi
	    ;;
	*)
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O Si e'\'' verificata una situazione non prevista ( connection_error_manager() ).\n' "${2}"
	    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
	    
	    exit 1
	    ;;
    esac
    
    debug_print "<" 'connection_error_manager'
}

#####################################################################
#____________________________________________________________________
function check_connection() {
    debug_print ">" 'check_connection'
    
    if [ "${DISABILITA_PRIVATE_KILLER_SYSTEM_AUTOMATICAMENTE:-N}" == "Y" ]; then
	printf '/TIMER -refnum 2255 16 budus if $iPrivateKillerAlert > 0 /budus sendsess $focus_tab /ECHO [XDCC MANAGER]\t %%C8,1%%BATTENZIONE:%%O Il %%BPrivate Killer System%%O e'\'' stato disabilitato in automatico, come da configurazione [XDCC MANAGER]; questo comporta che, se viene salvata la configurazione, lo stato viene reso permanente.\n'
	printf '/budus cmd /budus seth_internal buduscript_script__iPrivateKillerAlert $iPrivateKillerAlert\n'
	printf '/budus if $iPrivateKillerAlert > 0 /budus pktime 0\n'
	
	debug_print "*" 'PKS DISABLED'
    fi
    
    if [ -f "${database}" ]; then
	item_network_saved="${item_network}"
	item_network=$(search_server_for_network_connection_in_db "${item_network}")
	
	if [ $? == 1 ]; then
	    remove_item_from_db "${connect_server_db}" "	${item_network_saved}	"
	    remove_item_from_db "${connect_server_db}" "	${item_network}	"
	    
	    if [ "$(grep -iF "${item_network}	${item_channel}	" "${database}")" != "" ]; then
		if [ "$(grep -iF "${item_network}	${item_channel}	${item_botserv}	" "${database}")" != "" ]; then
		    debug_print "<" 'check_connection :: 1'
		    
		    return 1
		else
		    debug_print "*" 'BOT NOT FOUND'
		    
		    connection_error_manager "BOTSERV_NOT_FOUND" "${item_network}" "${item_channel}" "${item_botserv}"
		    
		    [ ${USA_CODA_DEI_DOWNLOAD:-N} == "Y" ] && \
			printf '/TIMER -refnum 2255 4 budus macro xdcc DOWNLOAD_MANAGER check_download_queue\n'
		fi
	    else
		debug_print "*" 'CHANNEL NOT FOUND'
		
		item_network=$(search_server_for_network_connection_in_db "${item_network}" "${database}" "	${item_channel}	")
		
		if [ $? == 1 ]; then
		    if [ "$(grep -iF "${item_network}	${item_channel}	${item_botserv}	" "${database}")" != "" ]; then
			debug_print "<" 'check_connection :: 1'
			
			return 1
		    else
			debug_print "*" 'BOT NOT FOUND'
			
			connection_error_manager "BOTSERV_NOT_FOUND" "${item_network}" "${item_channel}" "${item_botserv}"
			
			[ ${USA_CODA_DEI_DOWNLOAD:-N} == "Y" ] && \
			    printf '/TIMER -refnum 2255 4 budus macro xdcc DOWNLOAD_MANAGER check_download_queue\n'
		    fi
		else
		    connection_error_manager "CHANNEL_NOT_FOUND" "${item_network}" "${item_channel}"
		    printf '/budus cmd /budus if "connected( %s )" = 1 /budus sendsess %s/* /JOIN %s\;/budus else $buduscript_script__xdcc_session_manager NETWORK_NOT_CONNECTED %s\n' "${item_network}" "${item_network}" "${item_channel}" "${item_network}"
		    printf '/TIMER -refnum 2255 3 budus cmd /budus if "session( %s,%s )" = 1 /budus sendsess %s/%s /WHOIS %s\;/budus else $buduscript_script__xdcc_session_manager SESSION_MISSING_connected( %s ) %s %s\n' "${item_network}" "${item_channel}" "${item_network}" "${item_channel}" "${item_botserv}" "${item_network}" "${item_network}" "${item_channel}"
		    printf '/TIMER -refnum 2255 6 budus if "session( %s,%s )" = 1 /budus sendsess %s/%s /SAY Ciao a tutti\n' "${item_network}" "${item_channel}" "${item_network}" "${item_channel}"
		fi
	    fi
	else
	    debug_print "*" 'NETWORK NOT FOUND'
	    
	    flag_static_find_item_in_db=0
	    find_item_in_db "${connect_server_db}" "	${item_network}	" "NO_ERROR"
	    if [ ${flag_static_find_item_in_db:-0} == 0 ]; then
		debug_print "*" 'NETWORK CONNECTION'
		
		add_item_to_db "${connect_server_db}" "	${item_network}	"
		connection_error_manager "SERVER_NOT_FOUND" "${item_network}"
		printf '/NEWSERVER %s\n' "${item_network}"
	    else
		debug_print "*" 'NETWORK CONNECTION LOOP'
		
		printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t ATTENZIONE:%%O E'\'' stato intercettato il tentativo di eseguire connessioni multiple al medesimo Network IRC (%%B%s%%O).\n' "${item_network:-INTERNAL_ERROR}"
		printf '/budus sendsess $focus_tab /ECHO %%B%%C9,1[XDCC MANAGER]\t %%O Probabilmente il Network IRC al quale fa riferimento il download in elaborazione possiede dei Server IRC il cui nome non e'\'' facilmente associabile/riconoscibile (%%B%s%%O).\n' "${server}"
		
		remove_item_from_db "${connect_server_db}" "	${item_network}	"
		if [ "${server}" != "${item_network}" ]; then
		    debug_print "*" 'NETWORK SWAP'
		    
		    printf '/budus sendsess $focus_tab /ECHO %%B%%C6,1[XDCC MANAGER]\t %%O Provo a ri-associare gli ITEM in stato di elaborazione che fanno riferimento a %%B%s%%O al Network IRC corrente (%%B%s%%O).\n' "${item_network}" "${server}"
		    
		    lock_db "${waiting_db}"
		    flag_skip_lock_db=1
		    flag_static_find_item_in_db=0
		    old_item_network="${item_network}"
		    find_item_in_db "${waiting_db}" "	${old_item_network}	" "NO_ERROR"
		    iterator_loop_checker=0
		    while [ ${flag_static_find_item_in_db:-0} == 1 ]; do
			flag_network_rejoin=1
			ITEM="${find_item_in_db_result}"
			get_data_from_item
			
			debug_print "*" "flag_skip_check_waiting_db = $flag_skip_check_waiting_db"
			
			[ ${flag_skip_check_waiting_db:-0} == 0 ] && remove_item_from_db "${waiting_db}" "${ITEM}"
			[ ${flag_skip_check_waiting_db:-0} == 0 ] && remove_item_from_menu "WAITING" "${ITEM}"
			
			printf '/ECHO %%B%%C11,1[XDCC MANAGER]\t %13s:%%O %%C3%%B%s%%O => %%C7%%B%s%%O [%%C4%%B%s%%O:%%C5%%B%s%%O:%%C6%%B%s%%O].\n' "MODIFICATO" "${item_code}" "${item_filename}" "${old_item_network}%O=>%B${server}%O" "${item_channel}" "${item_botserv}"
			
			ITEM="	${item_code}	${item_ID}	${server}	${item_channel}	${item_botserv}	${item_filename}	${item_size}	${item_command}"
			
			flag_static_find_item_in_db=0
			find_item_in_db "${download_queue_db}" "${ITEM}" "NO_ERROR"
			
			if [ ${flag_static_find_item_in_db:-0} == 0 ]; then
			    add_item_to_db "${download_queue_db}" "${ITEM}"
			    add_item_to_menu "QUEUE"
			    
			    flag_static_find_item_in_db=0
			    [ ${flag_skip_check_waiting_db:-0} == 0 ] && find_item_in_db "${waiting_db}" "	${old_item_network}	" "NO_ERROR"
			    if [ ${flag_static_find_item_in_db:-0} == 0 ]; then
				flag_skip_check_waiting_db=1
				
				flag_static_find_item_in_db=0
				find_item_in_db "${download_queue_db}" "	${old_item_network}	" "NO_ERROR"
			    fi
			fi
			
			iterator_loop_checker=$((${iterator_loop_checker} + 1))
			[ ${iterator_loop_checker} -ge 64 ] && flag_static_find_item_in_db=0
		    done
		    
		    if [ ${flag_network_rejoin:-0} == 0 ]; then
			printf '/budus sendsess $focus_tab /ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O La ri-associazione di %%B%s%%O in  %%B%s%%O risulta fallita.\n' "${old_item_network:-INTERNAL_ERROR}" "${server:-INTERNAL_ERROR}"
			[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
			printf '/budus sendsess $focus_tab /ECHO %%B%%C3,1[XDCC MANAGER]\t SUGGERIMENTO:%%O Collegarsi al network %%B%s%%O manualmente (o attivare una finestra che gia'\'' lo sia), quindi forzare il download tramite il menu XDCC.\n'
			printf '/budus sendsess $focus_tab /ECHO %%B%%C3,1[XDCC MANAGER]\t %%O Se anche questo non funziona, non resta che effettuare il download manualmente.\n'
		    fi
		    
		    flag_skip_lock_db=0
		    unlock_db
		    
		    [ ${USA_CODA_DEI_DOWNLOAD:-N} == "Y" ] && \
			printf '/TIMER -refnum 2255 4 budus macro xdcc DOWNLOAD_MANAGER check_download_queue\n'
		else
		    printf '/budus sendsess $focus_tab /ECHO %%B%%C9,1[XDCC MANAGER]\t %%O Evito di intraprendere ulteriori azioni; si consiglia di collegarsi manualmente al Network IRC (%%B%s%%O).\n' "${item_network}"
		fi
	    fi
	fi
    else
	printf '/budus sendsess $focus_tab /ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O Database [%%B %s%%O ] non trovato.\n' "${database:-INTERNAL_ERROR}"
	[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
	printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Se il problema persiste, si consiglia di contattare UDA'\''Software.\n'
    fi
    
    debug_print "<" 'check_connection'

    exit 0
}

function make_download_buduscript_sentinel() {
    debug_print ">" "make_download_buduscript_sentinel(${1:-NONE}, ${2:-NONE})"

    current_item_code="${1:-${item_code}}"
    flag_exit_timeout="${2}"
    
    printf '%s\n' "/event addh ? spcl_dcc_send_offer \"'${current_item_code}:BUDUS_XDCC_DOWNLOAD:${item_botserv}='${current_item_code}:BUDUS_XDCC_DOWNLOAD:\$lu\" /budus cmd /budus macro xdcc DOWNLOAD_MANAGER spcl_dcc_send_offer \"${current_item_code}\" \"\$lu\" \"\$ru\" \"xchatvar( dcc_dir )\" xchatvar( dcc_completed_dir )"
    printf '%s\n' "/event addh ? spcl_dcc_offer \"'${current_item_code}:BUDUS_XDCC_DOWNLOAD:${item_botserv}='${current_item_code}:BUDUS_XDCC_DOWNLOAD:\$ru\" /budus cmd /budus macro xdcc DOWNLOAD_MANAGER spcl_dcc_offer \"${current_item_code}\" \"\$ru\" \"\$lu\" \"xchatvar( dcc_dir )\" xchatvar( dcc_completed_dir )"
    printf '%s\n' "/event addh ? spcl_dcc_recv_connect \"'${current_item_code}:BUDUS_XDCC_DOWNLOAD:${item_botserv}='${current_item_code}:BUDUS_XDCC_DOWNLOAD:\$lu\" /TIMER -refnum 2255 1 budus macro xdcc DOWNLOAD_MANAGER spcl_dcc_recv_connect \"${current_item_code}\" \"\$lu\" \"\$rhost\""
    printf '%s\n' "/event addh ? spcl_dcc_recv_complete \"'${current_item_code}:BUDUS_XDCC_DOWNLOAD:${item_botserv}='${current_item_code}:BUDUS_XDCC_DOWNLOAD:\$rhost\" /TIMER -refnum 2255 16 budus macro xdcc DOWNLOAD_MANAGER spcl_dcc_recv_complete \"${current_item_code}\" \"\$rhost\" \"\$ru\""
    printf '%s\n' "/event addh ? spcl_dcc_recv_failed \"'${current_item_code}:BUDUS_XDCC_DOWNLOAD:${item_botserv}='${current_item_code}:BUDUS_XDCC_DOWNLOAD:\$rhost\" /TIMER -refnum 2255 3 budus macro xdcc DOWNLOAD_MANAGER spcl_dcc_recv_failed \"${current_item_code}\" \"\$rhost\" \"\$ru\""
    printf '%s\n' "/event addh ? spcl_dcc_conection_failed \"'${current_item_code}:BUDUS_XDCC_DOWNLOAD:${item_botserv}='${current_item_code}:BUDUS_XDCC_DOWNLOAD:\$ru\" /TIMER -refnum 2255 3 budus macro xdcc DOWNLOAD_MANAGER spcl_dcc_conection_failed \"${current_item_code}\" \"\$ru\" \"\$lu\" \"\$rhost\""
    printf '%s\n' "/event addh ? spcl_dcc_recv_abort \"'${current_item_code}:BUDUS_XDCC_DOWNLOAD:${item_botserv}='${current_item_code}:BUDUS_XDCC_DOWNLOAD:\$lu\" /TIMER -refnum 2255 3 budus macro xdcc DOWNLOAD_MANAGER spcl_dcc_recv_abort \"${current_item_code}\" \"\$lu\" \"\$ru\""
    printf '%s\n' "/event addh ? spcl_dcc_stall \"'${current_item_code}:BUDUS_XDCC_DOWNLOAD:${item_botserv}='${current_item_code}:BUDUS_XDCC_DOWNLOAD:\$rhost\" /TIMER -refnum 2255 3 budus macro xdcc DOWNLOAD_MANAGER spcl_dcc_stall \"${current_item_code}\" \"\$rhost\" \"\$ru\""
    [ "${flag_exit_timeout}" != "" ] && return 1;
    
    printf '/budus cmd /budus if "session( %s,%s )" = 1 /budus sendsess %s/%s /TIMER -refnum 2255 %d budus macro xdcc DOWNLOAD_MANAGER TIMER_REQUEST %s\;/budus else $buduscript_script__xdcc_session_manager SESSION_MISSING %s %s\n' "${item_network}" "${item_channel}" "${item_network}" "${item_channel}" "${TIMEOUT_RICERCA:-600}" "${current_item_code}" "${item_network}" "${item_channel}"
    printf '/budus if "session( %s,%s )" = 1 /budus sendsess %s/%s /TIMER -refnum 2255 %d budus macro xdcc DOWNLOAD_MANAGER TIMER_DCC_GET %s\n' "${item_network}" "${item_channel}" "${item_network}" "${item_channel}" "${dcc_get_timer_sec:-600}" "${current_item_code}"
    
    printf '%s\n' "/event addh 0 text \"'${current_item_code}:BUDUS_XDCC_DOWNLOAD:${item_network}:\$nick:${item_botserv}'='${current_item_code}:BUDUS_XDCC_DOWNLOAD:\$hostname:\$channel:\$ru'\" /event event spcl_BUDUS_XDCC_${current_item_code} \$event_params"
    printf '/event addh 0 spcl_BUDUS_XDCC_%s ^[a-zA-Z0-9*]='\''$data'\'' /budus cmd /budus macro xdcc MESSAGE %s "xchatvar( dcc_completed_dir )" $ru $data\n' "${current_item_code}" "${current_item_code}"
    
    printf '/budus if "session( %s,%s )" = 1 /budus sendsess %s/%s /WHOIS %s\n' "${item_network}" "${item_channel}" "${item_network}" "${item_channel}" "${item_botserv}"
    printf '/budus if "session( %s,%s )" = 1 /budus sendsess %s/%s /budus add_killed_user() %s 1\n' "${item_network}" "${item_channel}" "${item_network}" "${item_channel}" "${item_botserv}"
    printf '/TIMER -refnum 2255 8 budus if "session( %s,%s )" = 1 /budus sendsess %s/%s %s\n' "${item_network}" "${item_channel}" "${item_network}" "${item_channel}" "${item_command}"
    
    debug_print "<" 'make_download_buduscript_sentinel'
}

#####################################################################
#____________________________________________________________________
function download_item() {
    debug_print ">" 'download_item'

    add_item_to_db "${waiting_db}" "${ITEM}"
    add_item_to_menu "WAITING"
    
    flag_skip_lock_db=0
    unlock_db
    
    debug_print "*" "item_network = $item_network / item_channel = $item_channel / TIMEOUT_RICERCA = $TIMEOUT_RICERCA / item_code = $item_code"
    
    printf '/TIMER -refnum 2255 %d budus macro xdcc DOWNLOAD_MANAGER TIMER_CONNECT %s\n' "${TIMEOUT_RICERCA:-600}" "${item_code}"
    
    get_data_from_item
    check_connection
    
    lock_db "${waiting_db}"
    flag_skip_lock_db=1
    remove_item_from_db "${connect_server_db}" "	${item_network}	"
    
    remove_item_from_db "${waiting_db}" "${ITEM}"
    remove_item_from_menu "WAITING" "${ITEM}"

    add_item_to_db "${request_db}" "${ITEM}"
    add_item_to_menu "REQUEST"
    
    printf '/budus sendsess $focus_tab /ECHO %%B%%C5,1[XDCC MANAGER]\t %%O DATI DEL DOWNLOAD IN ELABORAZIONE:\n'
    printf '/budus sendsess $focus_tab /ECHO * CODE    :%%B %64s\n' "${item_code}"
    printf '/budus sendsess $focus_tab /ECHO * Network :%%B %64s\n' "${item_network}"
    printf '/budus sendsess $focus_tab /ECHO * Channel :%%B %64s\n' "${item_channel}"
    printf '/budus sendsess $focus_tab /ECHO * BotServ :%%B %64s\n' "${item_botserv}"
    printf '/budus sendsess $focus_tab /ECHO * Filename:%%B %64s\n' "${item_filename}"
    printf '/budus sendsess $focus_tab /ECHO * Size    :%%B %64s\n' "${item_size}"
    printf '/budus sendsess $focus_tab /ECHO * Command :%%B %64s\n' "${item_command}"
    
    flag_skip_lock_db=0
    unlock_db
    
    make_download_buduscript_sentinel
    
    debug_print "<" 'download_item'
    
    exit 0
}

#####################################################################
#____________________________________________________________________
function check_md5sum_queue() {
    debug_print ">" 'check_md5sum_queue'
    
    [ "${ESEGUI_VERIFICA_MD5SUM_SUI_FILE_SCARICATI}" == "N" ] && return 0
    
    flag_static_find_item_in_db=0
    find_item_in_db_by_code "${md5sum_db}" "/.*	[0-9a-z]\{32\}	X" "NO_ERROR"
    if [ ${flag_static_find_item_in_db:-0} == 0 ]; then
	find_item_in_db_by_code "${md5sum_db}" "/.*	[0-9a-z]\{32\}	T" "NO_ERROR"
    fi
    if [ ${flag_static_find_item_in_db:-0} == 1 ]; then
	debug_print "*" 'check_md5sum_queue - FORK'
	
	echo "/EXEC xterm -e ${0} \"${database}\" \"${dcc_database}\" \"${server}\" FORK_CHECK_MD5SUM"
	echo "/TIMER -refnum 2255 16 budus pipe_script_silent ${0} \"${database}\" \"${dcc_database}\" \"${server}\" CHECK_MD5SUM"
    fi
    
    debug_print "<" 'check_md5sum_queue'
}

#####################################################################
#____________________________________________________________________
function check_download_queue() {
    debug_print ">" "check_download_queue(${1:-NONE})"
    
    flag_force_queue="${1:-0}"
    
    if [ -f ${script_path}/xdcc_queue_lock ]; then
	[ ${USA_CODA_DEI_DOWNLOAD:-N} == "Y" ] && \
	    printf '/TIMER -refnum 2255 60 budus macro xdcc DOWNLOAD_MANAGER check_download_queue\n'
	
	debug_print "*" "check_download_queue - QUEUE LOCKED (USA_CODA_DEI_DOWNLOAD = $USA_CODA_DEI_DOWNLOAD)"
	
	if [ $(wc -l ${script_path}/xdcc_queue_lock | cut -f1 -d' ') == 0 ]; then
	    echo "QUEUE LOCKED $(date)" >> ${script_path}/xdcc_queue_lock
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Coda dei Download bloccata.\n'
	fi
	
	debug_print "<" 'check_download_queue'
	
	exit 0;
    fi
    
    if [ -f "${download_queue_db}" ] && \
	[ $(stat -c %s "${download_queue_db}") -gt 0 ]; then
	lock_db "${download_queue_db}"
	flag_skip_lock_db=1
	
	flag_static_find_item_in_db=0
	find_item_in_db_by_code "${waiting_db}" "X" "NO_ERROR"
	[ ${flag_static_find_item_in_db} == 1 ] && [ ${flag_force_queue} == 1 ] && flag_force_queue=0
	find_item_in_db_by_code "${request_db}" "X" "NO_ERROR"
	[ ${flag_static_find_item_in_db} == 1 ] && [ ${flag_force_queue} == 1 ] && flag_static_find_item_in_db=0
	find_item_in_db_by_code "${transfer_db}" "X" "NO_ERROR"
	if [ ${flag_static_find_item_in_db} == 0 ]; then
	    find_item_in_db_by_code "${transfer_db}" "T" "NO_ERROR"
	    
	    debug_print "*" "check_download_queue - OBJECT ON TIMEOUT STATE IN QUEUE"
	fi
	
	debug_print "*" "check_download_queue - flag_static_find_item_in_db=${flag_static_find_item_in_db:-0} / USA_CODA_DEI_DOWNLOAD=${USA_CODA_DEI_DOWNLOAD:-N}"
	
	if [ ${USA_CODA_DEI_DOWNLOAD:-N} == "Y" ]; then
	    printf '/budus if "'\''xchatvar( dcc_completed_dir )'\''" = "'\'''\''" /budus sendsess $focus_tab /ECHO [XDCC MANAGER]\t %%C8,1%%BATTENZIONE:%%O Non risulta configurata una cartella predefinita dove collocare i files ricevuti via XDCC. Sarebbe opportuno configurarne una (Impostazioni -> Preferenze -> File Trasferiti -> File e cartelle -> Muovi file completi in:)\n'
	    
	    printf '/budus if "xchatvar( dcc_auto_send )" = 1 /budus sendsess $focus_tab /ECHO [XDCC MANAGER]\t %%C8,1%%BATTENZIONE:%%O XChat risulta configurato per accettare in automatico i file ricevuti via XDCC. Sarebbe opportuno configurarlo per non fare nulla (Impostazioni -> Preferenze -> File Trasferiti -> File e cartelle -> Accetta automaticamente i file offerti -> No)\n'
	    
	    printf '/budus if "xchatvar( dcc_auto_send )" = 2 /budus sendsess $focus_tab /ECHO [XDCC MANAGER]\t %%C8,1%%BATTENZIONE:%%O XChat risulta configurato per chiedere all'\''utente dove salvare i file ricevuti via XDCC; questo puo'\'' vanificare gli automatismi. Sarebbe opportuno configurarlo per non fare nulla (Impostazioni -> Preferenze -> File Trasferiti -> File e cartelle -> Accetta automaticamente i file offerti -> No)\n'
	fi

	if [ ${flag_static_find_item_in_db:-0} == 1 ] && \
	    [ ${USA_CODA_DEI_DOWNLOAD:-N} == "Y" ]; then
	    debug_print "*" "check_download_queue - item_code=${item_code:-NULL}"
	    
	    if [ "${item_code}" != "" ]; then
		printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Coda dei Download attiva; download simultanei non ammessi.\n'
		[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' w
		printf '/budus sendsess $focus_tab /ECHO %%B%%C9,1[XDCC MANAGER]\t %%O La richiesta (%%B%s%%O) viene messa in Coda dei Download per non saturare il trasferimento attivo (per cancellare usa: %%Bhttp://xdcc_CANCEL_%s%%O).\n' "${item_code}" "${item_code}"
	    fi
	    
	    flag_skip_lock_db=0
	    unlock_db
	    
	    debug_print "<" 'check_download_queue'
	    
	    exit 0
	fi
	
	ITEM=$(get_first_item_from_db "${download_queue_db}" "NO_ERROR")
	remove_item_from_menu "QUEUE" "${ITEM}"
	
	download_item
    fi
    
    flag_static_find_item_in_db=0
    find_item_in_db_by_code "${waiting_db}" "X" "NO_ERROR"
    find_item_in_db_by_code "${request_db}" "X" "NO_ERROR"
    find_item_in_db_by_code "${transfer_db}" "X" "NO_ERROR"
    if [ ${flag_static_find_item_in_db:-0} == 0 ] && \
	[ ${USA_CODA_DEI_DOWNLOAD:-N} == "Y" ]; then
	flag_static_find_item_in_db=0
	find_item_in_db_by_code "${request_db}" "T" "NO_ERROR"
	if [ ${flag_static_find_item_in_db:-0} == 0 ]; then
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Coda dei Download vuota.\n'
	    
	    if [ "${DISABILITA_PRIVATE_KILLER_SYSTEM_AUTOMATICAMENTE:-N}" == "Y" ]; then
		printf '/budus if $buduscript_script__iPrivateKillerAlert > 0 /budus pktime $buduscript_script__iPrivateKillerAlert\n'
		printf '/budus if $buduscript_script__iPrivateKillerAlert > 0 /budus sendsess $focus_tab /ECHO [XDCC MANAGER]\t %%C8,1%%BATTENZIONE:%%O Il %%BPrivate Killer System%%O e'\'' stato abilitato in automatico, come da configurazione [XDCC MANAGER].\n'
		
		debug_print "*" 'PKS ENABLED'
	    fi
	    
	    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' d
	else
	    flag_static_find_item_in_db=0
	    find_item_in_db_by_code "${transfer_db}" "T" "NO_ERROR"
	    if [ ${flag_static_find_item_in_db:-0} == 0 ]; then
		if [ "${FORZA_PERIODICAMENTE_DOWNLOAD_IN_STATO_DI_TIMEOUT}" == "Y" ]; then
		    printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Coda dei Download occupata solo da processi in stato di timeout; provo a forzare il primo.\n'
		    
		    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' d
		    
		    ITEM="${find_item_in_db_result}"
		    get_data_from_item
		    
		    if [ "${MESSAGGI_BOTSERV_SOLO_NELLA_FINESTRA_RELATIVA}" == "Y" ]; then
			printf '/budus if "session( %s,%s )" = 1 /budus sendsess $focus_tab /ECHO [XDCC MANAGER]\t %%C8,1Controlla in %s:%s se %s risulta operativo o ha fornito comunicazioni.\n' "${item_network}" "${item_channel}" "${item_network}" "${item_channel}" "${item_botserv}"
			printf '/budus if "session( %s,%s )" = 1 /budus sendsess $focus_tab /ECHO [XDCC MANAGER]\t Per annullare il download, usa il seguente link: %%Bhttp://xdcc_CANCEL_%s.\n' "${item_network}" "${item_channel}" "${item_code}"
		    fi
		    printf '/budus if "session( %s,%s )" = 1 /budus sendsess %s/%s /WHOIS %s\n' "${item_network}" "${item_channel}" "${item_network}" "${item_channel}" "${item_botserv}"
		    printf '/TIMER -refnum 2255 8 budus if "session( %s,%s )" = 1 /budus sendsess %s/%s %s\n' "${item_network}" "${item_channel}" "${item_network}" "${item_channel}" "${item_command}"
		    
		    printf '/budus if "session( %s,%s )" = 0 /budus macro xdcc c %s\n' "${item_network}" "${item_channel}" "${item_code}"
		    
		    printf '/TIMER -delete 2256\n'
		    printf '/TIMER -refnum 2256 %s budus macro xdcc DOWNLOAD_MANAGER check_download_queue\n' '1800'
		else
		    printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Coda dei Download occupata solo da processi in stato di timeout.\n'
		fi
	    fi
	fi
    fi
    
    check_md5sum_queue
    
    debug_print "<" 'check_download_queue'

    exit 0
}

#####################################################################
#____________________________________________________________________
function join_code_to_item() {
    debug_print ">" "join_code_to_item(${1:-NONE})"

    db_path="${1}"
    
    flag_static_find_item_in_db=0
    find_item_in_db_by_code "${db_path}" "${item_code}" "NO_ERROR"
    [ ${flag_static_find_item_in_db:-0} == 0 ] && return 0
    ITEM="${find_item_in_db_result}"
    get_data_from_item
    
    debug_print "*" "join_code_to_item - item_botserv=${item_botserv} / dcc_nickname=${dcc_nickname}"
    
    if [ "${item_botserv}" == "${dcc_nickname}" ]; then
	debug_print "*" "join_code_to_item - item_filename=${item_filename} / dcc_filename=${dcc_filename}"
	
	if [ "${item_filename}" == "${dcc_filename}" ]; then
	    flag_static_join_code_to_item=1
	elif [ "${dcc_filename}" != "" ]; then
	    [ "${2}" !=  "NO_ERROR" ] && \
		printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Il file in ricezione%%B %s%%O non combacia perfettamente con quello previsto (%%B%s%%O), relativamente al Download %%B%s%%O.\n' "${dcc_filename}" "${item_filename}" "${item_code}"
	    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' w
	    
	    file_keywords=$(echo "${dcc_filename}" | sed 's@[^0-9a-zA-Z ]@ @g')
	    lock_db "${db_path}"
	    
	    debug_print "*" "join_code_to_item - file_keywords=${file_keywords}"
	    
	    db_path_data=$(cat "${db_path}")
	    for keywords in ${file_keywords}; do
		db_path_data=$(echo "${db_path_data}" | grep -iF "${keywords}")
	    done
	    
	    unlock_db
	    
	    debug_print "*" "join_code_to_item - db_path_data=${db_path_data}"
	    
	    if [ "$(echo "${db_path_data}" | grep -iF "	${item_code}	")" != "" ]; then
		[ "${2}" !=  "NO_ERROR" ] && \
		    printf '/budus sendsess $focus_tab /ECHO %%B%%C9,1[XDCC MANAGER]\t %%OAssomiglia abbastanza (%%B%s%%O ~= %%B%s%%O) a quello previsto per il Download %%B%s%%O; lo associo in automatico.\n' "${dcc_filename}" "${item_filename}" "${item_code}"
		
		flag_static_join_code_to_item=1
	    elif [ "$(echo "${db_path_data}" | grep -iF "	${dcc_nickname}	" | tail -n1)" != "" ]; then
		ITEM=$(echo "${db_path_data}" | grep -iF "	${dcc_nickname}	" | tail -n1)
		get_data_from_item
		
		debug_print "*" "join_code_to_item - ITEM=${ITEM}"
		
		[ "${2}" !=  "NO_ERROR" ] && \
		    printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Il file%%B %s%%O combacia con un altro (%%B%s%%O) relativo al Download %%B%s%%O; lo associo in automatico.\n' "${dcc_filename}" "${item_filename}" "${item_code}"
	    else
		if [ ${ACCETTA_TRASFERIMENTI_AMBIGUI:-N} == N ]; then
		    [ "${2}" !=  "NO_ERROR" ] && \
			printf '/budus sendsess $focus_tab /ECHO %%B%%C9,1[XDCC MANAGER]\t %%OIl file in ricezione (%%B %s%%O ) non risulta associabile al codice %%B%s%%O; probabilmente il BOTSERV ha inviato il file sbagliato, devo rifiutarlo.\n' "${dcc_filename}" "${item_code}"
		    flag_static_join_code_to_item=2
		    
		    if [ ${AGGIORNA_AUTOMATICAMENTE_DATABASE_PERMANENTI_OBSOLETI:-Y} == "Y" ]; then
			update_xbspse_database_for_network_channel "${item_network}" "${item_channel}"
		    fi
		else
		    [ "${2}" !=  "NO_ERROR" ] && \
			printf '/budus sendsess $focus_tab /ECHO %%B%%C9,1[XDCC MANAGER]\t %%OIl file in ricezione (%%B %s%%O ) non risulta associabile al codice %%B%s%%O; probabilmente il BOTSERV ha inviato il file sbagliato, tuttavia, lo accetto ugualmente.\n' "${dcc_filename}" "${item_code}"
		    flag_static_join_code_to_item=1
		fi
	    fi
	fi
    fi
    
    debug_print "<" 'join_code_to_item'
}

#####################################################################
#____________________________________________________________________
function accept_dcc_transfer_manual() {
    printf '/budus sendsess $focus_tab /ECHO %%B%%C3,1[XDCC MANAGER]\t %%O In alternativa devi cancellare il Download (%%B%s%%O) tramite il menu XDCC ed eliminare il file temporaneo con questo comando:%%B /EXEC rm -vf "%s"\n' "${item_code}" "${dcc_temp_path}/${dcc_filename}"
    
    remove_item_from_db "${request_db}" "${ITEM}"
    remove_item_from_menu "REQUEST" "${ITEM}"
    
    add_item_to_db "${transfer_db}" "${ITEM}"
    add_item_to_menu "TRANSFER"
    
    debug_print "<" 'accept_dcc_transfer :: 0'
    
    return 0
}

#####################################################################
#____________________________________________________________________
function accept_dcc_transfer() {
    debug_print ">" 'accept_dcc_transfer'

    join_code_to_item "${request_db}"
    [ ${flag_static_join_code_to_item:-0} == 0 ] && return 0
    
    if [ ${flag_static_join_code_to_item:-0} == 2 ]; then
	# Deve rifiutare il trasferimento e abortire. Il BOTSERV sta
	# inviando il file sbagliato.
	debug_print "*" "accept_dcc_transfer:ABORT - dcc_nickname=$dcc_nickname / dcc_filename=$dcc_filename"
	
	printf '/TIMER -refnum 2255 8 DCC CLOSE GET %s %s\n' "${dcc_nickname:-ERROR}" "${dcc_filename:-ERROR}"
	printf '/TIMER -refnum 2255 8 MSG %s XDCC CANCEL\n' "${dcc_nickname}"
	printf '/TIMER -refnum 2255 8 MSG %s XDCC REMOVE\n' "${dcc_nickname}"
	
	remove_item_from_db "${request_db}" "${ITEM}"
	remove_item_from_menu "REQUEST" "${ITEM}"
	
	add_item_to_db "${repeat_db}" "${ITEM}"
	purge_db "${repeat_db}" 20
	add_item_to_menu "REPEAT"
	
	add_item_to_db "${failed_db}" "${ITEM}"
	purge_db "${failed_db}" 20
	
	printf '/event listh %s:BUDUS_XDCC_DOWNLOAD: -\n' "${item_code}"
	printf '/event listh %s:BUDUS_XDCC_START_CHECK_MD5SUM: -\n' "${item_code}"
	printf '/event listh spcl_BUDUS_XDCC_%s -\n' "${item_code}"
	
	ITEM=""
	
	printf '/TIMER -refnum 2255 16 budus macro xdcc DOWNLOAD_MANAGER check_download_queue\n'
	
	debug_print "<" 'accept_dcc_transfer :: 0'
	
	return 0;
    fi
    
    flag_static_join_code_to_item=0
    
    debug_print "*" "accept_dcc_transfer - dcc_temp_path/dcc_filename=${dcc_temp_path}/${dcc_filename} [$(if [ -f "${dcc_temp_path}/${dcc_filename}" ]; then echo 'FOUND'; else echo 'MISSING'; fi)]"
    
    if [ -f "${dcc_temp_path}/${dcc_filename}" ]; then
	debug_print "*" "accept_dcc_transfer - CONSENTI_RIPRESA_DOWNLOAD_AUTOMATICA=${CONSENTI_RIPRESA_DOWNLOAD_AUTOMATICA:-N}"
    
	if [ "${CONSENTI_RIPRESA_DOWNLOAD_AUTOMATICA:-N}" == "Y" ]; then
	    if [ "${CONSENTI_RIPRESA_DOWNLOAD_MANUALE:-N}" == "Y" ]; then
		printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Il file%%B %s%%O risulta presente nella cartella dei file temporanei.\n' "${dcc_filename}"
		[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' w
		printf '/budus sendsess $focus_tab /ECHO %%B%%C3,1[XDCC MANAGER]\t %%O Il recupero dei file parziali risulta attivo; devi intervenire manualmente tramite il pulsante %%BRiprendi%%O nella finestra %%BTrasferimenti%%O.\n'
		
		accept_dcc_transfer_manual
	    else
		printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Il file%%B %s%%O risulta presente nella cartella dei file temporanei.\n' "${dcc_filename}"
		printf '/budus sendsess $focus_tab /ECHO %%B%%C3,1[XDCC MANAGER]\t %%O Il recupero dei file parziali risulta attivo e abilitato ad agire automaticamente.\n'
		
		if [ "${dcc_nickname}" != "" ]; then
		    if [ "${dcc_filename}" != "" ]; then
			printf '/DCC GET %s "%s"\n' "${dcc_nickname}" "${dcc_filename}"
			
			flag_automatic_resume_file=1
		    else
			printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O Non e'\'' possibile procedere al recupero automatico perche'\'' le informazioni sono insufficienti (NO DCC NICKNAME).\n'
			[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
			printf '/budus sendsess $focus_tab /ECHO %%B%%C3,1[XDCC MANAGER]\t %%O Devi intervenire manualmente tramite il pulsante %%BRiprendi%%O nella finestra %%BTrasferimenti%%O.\n'
			
			accept_dcc_transfer_manual
		    fi
		else
		    printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O Non e'\'' possibile procedere al recupero automatico perche'\'' le informazioni sono insufficienti (NO DCC FILENAME).\n'
		    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
		    printf '/budus sendsess $focus_tab /ECHO %%B%%C3,1[XDCC MANAGER]\t %%O Devi intervenire manualmente tramite il pulsante %%BRiprendi%%O nella finestra %%BTrasferimenti%%O.\n'
		    
		    accept_dcc_transfer_manual
		fi
	    fi
	else
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Il file%%B %s%%O risulta presente nella cartella dei file temporanei, lo elimino in automatico.\n' "${dcc_filename}"
	    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' w
	    printf '/EXEC rm -vf "%s"\n' "${dcc_temp_path}/${dcc_filename}"
	fi
    fi
    
    debug_print "*" "accept_dcc_transfer - dcc_download_path/dcc_filename=${dcc_download_path}/${dcc_filename} [$(if [ -f "${dcc_download_path}/${dcc_filename}" ]; then echo 'FOUND'; else echo 'MISSING'; fi)]"
    
    if [ -f "${dcc_download_path}/${dcc_filename}" ]; then
	printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Il file%%B %s%%O risulta presente nella cartella dei file scaricati.\n' "${dcc_filename}"
	[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' w
	
	debug_print "*" "accept_dcc_transfer - EVITA_DOWNLOAD_DEL_MEDESIMO_FILE=${EVITA_DOWNLOAD_DEL_MEDESIMO_FILE:-N}"
	
	if [ "${EVITA_DOWNLOAD_DEL_MEDESIMO_FILE:-Y}" == "N" ]; then
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C3,1[XDCC MANAGER]\t %%O Se desideri sostituirlo con quello in Download devi preventivamente eliminarlo con il comando:%%B /EXEC rm -vf "%s"\n' "${dcc_download_path}/${dcc_filename}"
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C3,1[XDCC MANAGER]\t %%O In alternativa puoi lasciare che XChat ne crei una copia con versione (comportamento predefinito).\n'
	else
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C9,1[XDCC MANAGER]\t Non e'\'' consentito il download del medesimo file, abortisco in automatico e passo al successivo download.\n'
	    
	    debug_print "*" "accept_dcc_transfer - dcc_nickname=$dcc_nickname / dcc_filename=$dcc_filename"
	    
	    printf '/TIMER -refnum 2255 8 DCC CLOSE GET %s %s\n' "${dcc_nickname:-ERROR}" "${dcc_filename:-ERROR}"
	    printf '/TIMER -refnum 2255 8 MSG %s XDCC CANCEL\n' "${dcc_nickname}"
	    printf '/TIMER -refnum 2255 8 MSG %s XDCC REMOVE\n' "${dcc_nickname}"
	    
	    remove_item_from_db "${request_db}" "${ITEM}"
	    remove_item_from_menu "REQUEST" "${ITEM}"
	    
	    add_item_to_db "${repeat_db}" "${ITEM}"
	    purge_db "${repeat_db}" 20
	    add_item_to_menu "REPEAT"
	    
	    add_item_to_db "${failed_db}" "${ITEM}"
	    purge_db "${failed_db}" 20
	    
	    printf '/event listh %s:BUDUS_XDCC_DOWNLOAD: -\n' "${item_code}"
	    printf '/event listh %s:BUDUS_XDCC_START_CHECK_MD5SUM: -\n' "${item_code}"
	    printf '/event listh spcl_BUDUS_XDCC_%s -\n' "${item_code}"
	    
	    ITEM=""
	    
	    printf '/TIMER -refnum 2255 16 budus macro xdcc DOWNLOAD_MANAGER check_download_queue\n'
	    
	    debug_print "<" 'accept_dcc_transfer :: 0'
	    
	    return 0
	fi
    else
	printf '/budus sendsess $focus_tab /ECHO %%B%%C6,1[XDCC MANAGER]\t DOWNLOAD RICHIESTO :%%O [%%B%s%%O:%%B%s%%O] => %%B%s\n' "${item_code}" "${dcc_nickname}" "${dcc_filename}"
    fi
    
    remove_item_from_db "${request_db}" "${ITEM}"
    remove_item_from_menu "REQUEST" "${ITEM}"
    
    add_item_to_db "${transfer_db}" "${ITEM}"
    add_item_to_menu "TRANSFER"
    
    if [ ${flag_automatic_resume_file:-0} == 0 ]; then
	printf '/TIMER -refnum 2255 3 DCC get %s\n' "${dcc_nickname:-INTERNAL_ERROR}"
    else
	printf '/budus sendsess $focus_tab /ECHO %%B%%C10,1[XDCC MANAGER]\t DOWNLOAD RECUPERATO:%%O [%%B%s%%O:%%B%s%%O] => %%B%s\n' "${item_code}" "${dcc_nickname}" "${dcc_filename}"
    fi
    
    debug_print "<" 'accept_dcc_transfer :: 1'
    
    return 1
}

#####################################################################
#____________________________________________________________________
function accept_connection() {
    debug_print ">" 'accept_connection'

    if [ -f "${temp_reflex_list}" ]; then
	reflexed_botserv=$(grep -F " ${dcc_nickname} " "${temp_reflex_list}" | tail -n1)
    fi
    
    if [ "${reflexed_botserv}" != "" ]; then
	printf '/budus sendsess $focus_tab /ECHO %%B%%C6,1[XDCC REFLEX]\t%%O Sul BOTSERV %%B%s%%O e'\'' attiva una redirezione, procedo di conseguenza.\n'
    else
	accept_dcc_transfer
    fi
    
    debug_print "<" 'accept_connection'
}

#####################################################################
#____________________________________________________________________
function check_dcc_transfer() {
    debug_print ">" 'check_dcc_transfer'

    join_code_to_item "${transfer_db}" "NO_ERROR"
    [ ${flag_static_join_code_to_item:-0} == 0 ] && return 0
    flag_static_join_code_to_item=0
    
    printf '/budus sendsess $focus_tab /ECHO %%B%%C5,1[XDCC MANAGER]\t DOWNLOAD PARTITO   :%%O [%%B%s%%O:%%B%s%%O] => %%B%s\n' "${item_code}" "${dcc_nickname}" "${dcc_filename}"
    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' m

    debug_print "<" 'check_dcc_transfer'
}

#####################################################################
#____________________________________________________________________
function check_end_download() {
    debug_print ">" 'check_end_download'

    join_code_to_item "${transfer_db}" "NO_ERROR"
    [ ${flag_static_join_code_to_item:-0} == 0 ] && return 0
    flag_static_join_code_to_item=0
    
    remove_item_from_db "${transfer_db}" "${ITEM}"
    remove_item_from_menu "TRANSFER" "${ITEM}"
    
    add_item_to_db "${repeat_db}" "${ITEM}"
    purge_db "${repeat_db}" 20
    add_item_to_menu "REPEAT"
    
    printf '/event listh %s:BUDUS_XDCC_DOWNLOAD: -\n' "${item_code}"
    printf '/event listh %s:BUDUS_XDCC_START_CHECK_MD5SUM: -\n' "${item_code}"
    printf '/event listh spcl_BUDUS_XDCC_%s -\n' "${item_code}"
    
    printf '/budus sendsess $focus_tab /ECHO %%B%%C3,1[XDCC MANAGER]\t DOWNLOAD TERMINATO :%%O [%%B%s%%O:%%B%s%%O] => %%B%s\n' "${item_code}" "${dcc_nickname}" "${dcc_filename}"
    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' m

    debug_print "*" "check_end_download - EVITA_DOWNLOAD_DEL_MEDESIMO_FILE=${EVITA_DOWNLOAD_DEL_MEDESIMO_FILE:-N}"
    
    if [ "${EVITA_DOWNLOAD_DEL_MEDESIMO_FILE:-Y}" == "Y" ]; then
	flag_static_find_item_in_db=0
	find_item_in_db "${download_queue_db}" "	${dcc_filename}	" "NO_ERROR"
	if [ ${flag_static_find_item_in_db:-0} == 1 ]; then
	    ITEM="${find_item_in_db_result}"
	    get_data_from_item
	    
	    remove_item_from_db "${download_queue_db}" "${ITEM}"
	    remove_item_from_menu "QUEUE" "${ITEM}"
	    
	    add_item_to_db "${repeat_db}" "${ITEM}"
	    purge_db "${repeat_db}" 20
	    add_item_to_menu "REPEAT"
	    
	    printf '/budus sendsess * /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Download con ID %%B%s%%O eliminato in automatico, risulta gia'\'' scaricato. Per ripetere il download usa (possibilmente nella finestra del Network corretto) il link: %%Bhttp://xdcc_%s%%O\n' "${item_code}" "${item_code}"
	fi
    fi

    debug_print "<" 'check_end_download'
}

#####################################################################
#____________________________________________________________________
function recover_item() {
    debug_print ">" 'recover_item'
    
    if [ "${ABILITA_NUOVO_TENTATIVO_AUTOMATICO_SU_FALLIMENTO:-Y}" == "N" ]; then
	check_download_queue
    else
	printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Tentativo di ripetere in automatico il Download %%B%s%%O avviato ...\n' "${item_code}"
	[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' w
	
	download_item
    fi

    debug_print "<" 'recover_item'
}

#####################################################################
#____________________________________________________________________
function failed_download_manager() {
    debug_print ">" "failed_download_manager(${1:-NONE})"

    debug_print "*" "dcc_nickname = ${dcc_nickname} / dcc_filename = ${dcc_filename}"

    [ "${dcc_filename}" != "" ] && \
	printf '/DCC CLOSE GET %s %s\n' "${dcc_nickname:-ERROR}" "${dcc_filename:-ERROR}"
    
    
    printf '/MSG %s XDCC CANCEL\n' "${dcc_nickname}"
    printf '/MSG %s XDCC REMOVE\n' "${dcc_nickname}"
    
    db_to_find="${waiting_db}"
    join_code_to_item "${db_to_find}" "NO_ERROR"
    if [ ${flag_static_join_code_to_item:-0} == 0 ]; then
	db_to_find="${request_db}"
	join_code_to_item "${db_to_find}" "NO_ERROR"
	if [ ${flag_static_join_code_to_item:-0} == 0 ]; then
	    db_to_find="${transfer_db}"
	    join_code_to_item "${db_to_find}" "NO_ERROR"
	    if [ ${flag_static_join_code_to_item:-0} == 0 ]; then
		if [ "${dcc_filename}" != "" ]; then
		    if [ "${1}" == "" ]; then
			printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Il file%%B %s%%O non risulta associabile con il Download %%B%s%%O.\n' "${dcc_filename}" "${item_code}"
			[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' w
		    else
			printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Il fallimento non risulta associabile con il Download %%B%s%%O.\n' "${item_code}"
			[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' w
		    fi
		else
		    flag_static_find_item_in_db=0
		    find_item_in_db_by_code "${transfer_db}" "${item_code}" "NO_ERROR"
		    if [ ${flag_static_find_item_in_db:-0} == 1 ]; then
			printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Il fallimento viene associato - con riserva - al Download %%B%s%%O.\n' "${item_code}"
			[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' w
			ITEM="${find_item_in_db_result}"
		    else
			printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE FATALE:%%O Impossibile associare il fallimento ad un Download.\n'
			[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
			
			debug_print "<" 'failed_download_manager (ERROR)'
			
			exit 1;
		    fi
		fi
	    fi
	fi
    fi
    flag_static_join_code_to_item=0
    
    case ${db_to_find} in
	"${waiting_db}")
	    printf '/event listh %s:BUDUS_XDCC_DOWNLOAD: -\n' "${item_code}"
	    printf '/event listh %s:BUDUS_XDCC_START_CHECK_MD5SUM: -\n' "${item_code}"
	    
	    remove_item_from_db "${waiting_db}" "${ITEM}"
	    remove_item_from_menu "WAITING" "${ITEM}"
	    
	    recover_item
	    ;;
	"${request_db}")
	    printf '/event listh %s:BUDUS_XDCC_DOWNLOAD: -\n' "${item_code}"
	    printf '/event listh %s:BUDUS_XDCC_START_CHECK_MD5SUM: -\n' "${item_code}"
	    
	    remove_item_from_db "${request_db}" "${ITEM}"
	    remove_item_from_menu "REQUEST" "${ITEM}"
	    
	    recover_item
	    ;;
	"${transfer_db}")
	    printf '/event listh %s:BUDUS_XDCC_DOWNLOAD: -\n' "${item_code}"
	    printf '/event listh %s:BUDUS_XDCC_START_CHECK_MD5SUM: -\n' "${item_code}"
	    
	    remove_item_from_db "${transfer_db}" "${ITEM}"
	    remove_item_from_menu "TRANSFER" "${ITEM}"
	    
	    recover_item
	    ;;
	*)
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C9,1[XDCC MANAGER]\t Potrebbe essere necessario un intervento manuale tramite il menu XDCC.\n'
	    ;;
    esac
    
    debug_print "<" 'failed_download_manager'
}

#####################################################################
#____________________________________________________________________
function cancel_download() {
    debug_print ">" "cancel_download(${1:-NONE}, ${2:-NONE})"
    
    code_to_cancel="${1}"
    
    [ "${code_to_cancel}" == "" ] && \
	printf '/ECHO [XDCC MANAGER]\t %%C4,1%%BERRORE FATALE:%%O%%C4,1 Problema interno nella cancellazione del download.\n' && \
	exit 1;
    
    [ ! -f "${download_queue_db}" ] && touch "${download_queue_db}"
    [ ! -f "${waiting_db}" ] && touch "${waiting_db}"
    [ ! -f "${request_db}" ] && touch "${request_db}"
    [ ! -f "${transfer_db}" ] && touch "${transfer_db}"
    
    debug_print "*" "code_to_cancel = ${code_to_cancel}"
    
    items_db=$(cat "${download_queue_db}" "${waiting_db}" "${request_db}" "${transfer_db}" \
	| grep -F "	${code_to_cancel}	" \
	| sort \
	| uniq)
    
    IFS=$'\n'
    for ITEM in ${items_db}; do
	debug_print "*" "ITEM = ${ITEM}"
	
	flag_item_found_in_db=1
	get_data_from_item
	item_network=$(search_server_for_network_connection_in_db "${item_network}")
	
	[ -f "${dcc_database}" ] && is_download_active=$(grep -F '	ACTIVE	RECV' "${dcc_database}")
	
	debug_print "*" "is_download_active = ${is_download_active}"
	
	if [ "${is_download_active}" != "" ]; then
	    is_download_active=$(echo "${is_download_active}" \
		| awk -F'\t' '{print "\t"$5"\t"$3"\t"}' \
		| grep -F "	${item_botserv}	")
	    
	    is_download_xdcc_manager="$(echo "${is_download_active}" | tr '\t' ';' | grep -iF "/${item_filename};")"
	    
	    debug_print "*" "is_download_active = ${is_download_active}"
	    debug_print "*" "item_filename = ${item_filename}"
	    debug_print "*" "is_download_xdcc_manager = ${is_download_xdcc_manager}"
	    
	    if [ "${is_download_xdcc_manager}" != "" ]; then
		printf '/ECHO %%B%%C9,1[XDCC MANAGER]\t %%OChiudo in automatico la connessione con %%B%s%%O.\n' "${item_botserv}"
		
		debug_print "*" "item_network = ${item_network}"
		
		printf '/budus sendsess %s/*! /DCC CLOSE GET %s %s\n' "${item_network}" "${item_botserv:-ERROR}" "${item_filename:-ERROR}"
		
		dcc_filename=$(echo "${is_download_active}" | tail -n1 | awk -F'\t' '{print $3}')
		
		debug_print "*" "dcc_filename = ${dcc_filename} : $(echo "${is_download_active}" | tail -n1)"
		
		printf '/ECHO %%B%%C3,1[XDCC MANAGER]\t SUGGERIMENTO:%%O Per cancellare il file temporaneo, utilizzare il comando:\n'
		printf '/ECHO %%B%%C3,1[XDCC MANAGER]\t              %%O%%B /EXEC rm -vf %s%%O\n' "${dcc_filename}"
	    else
		dcc_filename=$(echo "${is_download_active}" | tail -n1 | awk -F'\t' '{print $3}')
		
		debug_print "*" "dcc_filename = ${dcc_filename} : $(echo "${is_download_active}" | tail -n1)"
		
		if [ "${dcc_filename}" != "" ]; then
		    printf '/ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Non sono sicuro che il file %%B%s%%O sia associabile al Download con ID %%B%s%%O.\n' "${dcc_filename}" "${code_to_cancel}"
		    printf '/ECHO %%B%%C9,1[XDCC MANAGER]\t %%OSi rende necessario interrompere manualmente la connessione con %%B%s%%O tramite la finestra %%BTrasferimenti%%O.\n' "${item_botserv}"
		fi
	    fi
	fi
	
	debug_print "*" "item_network = ${item_network} / item_channel = ${item_channel}"
	
	printf '/budus if "session( %s,%s )" = 1 /budus sendsess %s/%s /MSG %s XDCC CANCEL\n' "${item_network}" "${item_channel}" "${item_network}" "${item_channel}" "${item_botserv}"
	printf '/budus if "session( %s,%s )" = 1 /budus sendsess %s/%s /MSG %s XDCC REMOVE\n' "${item_network}" "${item_channel}" "${item_network}" "${item_channel}" "${item_botserv}"
	
	add_item_to_db "${repeat_db}" "${ITEM}"
	purge_db "${repeat_db}" 20
	add_item_to_menu "REPEAT"
    done
    
    remove_item_from_db "${download_queue_db}" "	${code_to_cancel}	"
    remove_item_from_db "${waiting_db}" "	${code_to_cancel}	"
    remove_item_from_db "${request_db}" "	${code_to_cancel}	"
    remove_item_from_db "${transfer_db}" "	${code_to_cancel}	"
    
    remove_item_from_menu "QUEUE" "	${code_to_cancel}	"
    remove_item_from_menu "WAITING" "	${code_to_cancel}	"
    remove_item_from_menu "REQUEST" "	${code_to_cancel}	"
    remove_item_from_menu "TRANSFER" "	${code_to_cancel}	"
    
    printf '/event listh %s:BUDUS_XDCC_DOWNLOAD: -\n' "${code_to_cancel}"
    printf '/event listh %s:BUDUS_XDCC_START_CHECK_MD5SUM: -\n' "${code_to_cancel}"
    printf '/event listh spcl_BUDUS_XDCC_%s -\n' "${code_to_cancel}"
    
    if [ "${SUB_COMMAND/* /}" != "-" ] && [ "${2}" != "-" ]; then
	[ ${flag_item_found_in_db:-0} == 1 ] && \
	    printf '/budus sendsess * /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Download con ID %%B%s%%O eliminato (Per ripetere il download usa il link %%Bhttp://xdcc_%s%%O , possibilmente nella finestra del Network corretto).\n' "${code_to_cancel}" "${code_to_cancel}" || \
	    printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O ID %%B%s%%O non trovato.\n' "${code_to_cancel}"
	[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' w
    fi
    
    debug_print "<" 'cancel_download'
}

#####################################################################
#____________________________________________________________________
function list_item_in_db() {
    debug_print ">" "list_item_in_db(${1:-NONE}, ${2:-NONE}, ${3:-NONE})"
    
    db_path="${1}"
    status_type="${2}"
    link_type="${3:-CANCEL}"
    link_type_2="${4:-NONE}"
    
    if [ -f "${db_path}" ]; then
	lock_db "${db_path}"
	
	IFS=$'\n'
	for ITEM in $(cat "${db_path}"); do
	    get_data_from_item
	    if [ "${link_type}" == "no_link_type" ]; then
		printf '/ECHO %%B%%C11,1[XDCC MANAGER]\t %13s:%%O %%C3%%B%s%%O => %%C7%%B%s%%O [%%C4%%B%s%%O:%%C5%%B%s%%O:%%C6%%B%s%%O].\n' "${status_type}" "${item_code}" "${item_filename}" "${item_network}" "${item_channel}" "${item_botserv}"
	    elif [ "${link_type_2}" != "NONE" ]; then
		if [ "${link_type_2}" == "REPEAT" ]; then
		    printf '/ECHO %%B%%C11,1[XDCC MANAGER]\t %13s:%%O %%C3%%B%s%%O => %%C7%%B%s%%O [%%C4%%B%s%%O:%%C5%%B%s%%O:%%C6%%B%s%%O] ( %%Bhttp://xdcc_%s_%s%%O ) ( %%Bhttp://xdcc_%s%%O ).\n' "${status_type}" "${item_code}" "${item_filename}" "${item_network}" "${item_channel}" "${item_botserv}" "${link_type}" "${item_code}" "${item_code}"
		else
		    printf '/ECHO %%B%%C11,1[XDCC MANAGER]\t %13s:%%O %%C3%%B%s%%O => %%C7%%B%s%%O [%%C4%%B%s%%O:%%C5%%B%s%%O:%%C6%%B%s%%O] ( %%Bhttp://xdcc_%s_%s%%O ) ( %%Bhttp://xdcc_%s_%s%%O ).\n' "${status_type}" "${item_code}" "${item_filename}" "${item_network}" "${item_channel}" "${item_botserv}" "${link_type}" "${item_code}" "${link_type_2}" "${item_code}"
		fi
	    else
		printf '/ECHO %%B%%C11,1[XDCC MANAGER]\t %13s:%%O %%C3%%B%s%%O => %%C7%%B%s%%O [%%C4%%B%s%%O:%%C5%%B%s%%O:%%C6%%B%s%%O] ( %%Bhttp://xdcc_%s_%s%%O ).\n' "${status_type}" "${item_code}" "${item_filename}" "${item_network}" "${item_channel}" "${item_botserv}" "${link_type}" "${item_code}"
	    fi
	done
	
	unlock_db
    fi
    
    debug_print "<" 'list_item_in_db'
}

#####################################################################
#____________________________________________________________________
function make_search_db_from_parameters() {
    if [ "${item_network}" != "" ]; then
	if [ "${item_channel}" != "" ] && [ "$(echo "${item_channel}" | grep '^#')" != "" ]; then
	    if [ "${item_botserv}" != "" ]; then
		if [ "${item_command}" != "" ] && [ "$(echo "${item_command}" | grep '^[#/]')" != "" ]; then
		    if [ "$(echo ${item_command} | grep '^#')" != "" ]; then
			item_command="/MSG ${item_botserv} XDCC SEND ${item_command}"
		    fi
		    
		    if [ "${item_filename}" != "" ]; then
			printf '/ECHO %%C3,1[XDCC MANAGER]\t %%BRICHIESTA DOWNLOAD MANUALE:%%C8,01 %s%%O:%%C7,01%s%%O:%%C6,01%s%%O => ID:%%C5,01%s%%O (%%C4,01%s%%O)\n' "${item_network:-NULL}" "${item_channel:-NULL}" "${item_botserv:-NULL}" "${item_ID:-NULL}" "${item_filename:-NULL}"
			
			filelist_line_ok=$((${filelist_line_ok} + 1))
			if [ ${filelist_line_ok:-1} == 1 ]; then
			    printf '%s\t%s\t%s\t%s\t%s\t%s\t%s\t\n' "${item_ID:-NULL}" "${item_network:-NULL}" "${item_channel:-NULL}" "${item_botserv:-NULL}" "${item_filename:-NULL}" "${item_size:-UNKNOWN}" "${item_command:-NULL}" > "${search_engine_db}"
			else
			    printf '%s\t%s\t%s\t%s\t%s\t%s\t%s\t\n' "${item_ID:-NULL}" "${item_network:-NULL}" "${item_channel:-NULL}" "${item_botserv:-NULL}" "${item_filename:-NULL}" "${item_size:-UNKNOWN}" "${item_command:-NULL}" >> "${search_engine_db}"
			fi
		    else
			printf '/ECHO %%C4,1[XDCC MANAGER]\t %%BERRORE DI SINTASSI ALLA RIGA%%O%%B %d%%C4,01:%%C8,01 Manca la colonna con il Nome del File.%%O\n' "${filelist_line_count}"
			printf '/ECHO ( %%B%s%%O )\n' "$(echo "${line}" | sed 's@\t@%O|<- ->|%B@g')"
			flag_syntax_error=1
		    fi
		    
		else
		    printf '/ECHO %%C4,1[XDCC MANAGER]\t %%BERRORE DI SINTASSI ALLA RIGA%%O%%B %d%%C4,01:%%C8,01 Manca la colonna con l'\''ID o il Comando di Richiesta ( %s ).%%O\n' "${filelist_line_count}" "${item_command:-NULL}"
		    printf '/ECHO ( %%B%s%%O )\n' "$(echo "${line}" | sed 's@\t@%O|<- ->|%B@g')"
		    flag_syntax_error=1
		fi
	    else
		printf '/ECHO %%C4,1[XDCC MANAGER]\t %%BERRORE DI SINTASSI ALLA RIGA%%O%%B %d%%C4,01:%%C8,01 Manca la colonna con il Nickname del BOTSERV.%%O\n' "${filelist_line_count}"
		printf '/ECHO ( %%B%s%%O )\n' "$(echo "${line}" | sed 's@\t@%O|<- ->|%B@g')"
		flag_syntax_error=1
	    fi
	else
	    printf '/ECHO %%C4,1[XDCC MANAGER]\t %%BERRORE DI SINTASSI ALLA RIGA%%O%%B %d%%C4,01:%%C8,01 Manca la colonna con il nome del Canale ( %s ).%%O\n' "${filelist_line_count}" "${item_channel:-NULL}"
	    printf '/ECHO ( %%B%s%%O )\n' "$(echo "${line}" | sed 's@\t@%O|<- ->|%B@g')"
	    flag_syntax_error=1
	fi
    else
	printf '/ECHO %%C4,1[XDCC MANAGER]\t %%BERRORE DI SINTASSI ALLA RIGA%%O%%B %d%%C4,01:%%C8,01 Manca la colonna con il nome del Network.%%O\n' "${filelist_line_count}"
	printf '/ECHO ( %%B%s%%O )\n' "$(echo "${line}" | sed 's@\t@%O|<- ->|%B@g')"
	flag_syntax_error=1
    fi
}

#####################################################################
#####################################################################
#####################################################################
#####################################################################
#####################################################################
#####################################################################
#____________________________________________________________________
# Controllo: Verifica se deve eseguire il fork del processo; uno
# andra' ad eseguire la ricerca e l'altro a verificare quando
# quest'ultima e' terminata, per mostrare il risultato all'utente.
if [ "$(echo "${command}" | grep "^FORK_PROCESS")" != "" ]; then
    debug_print "x" 'FORK_PROCESS'
    
    elaboration_start_time=$(date +%s)
    
    if [ ${database:-X} != CHECK ]; then
	clear
	cat<<EOF
********************************************************************************
*                                                                              *
*                                  ATTENZIONE                                  *
*                                                                              *
* NON CHIUDERE QUESTA FINESTRA PRIMA CHE L'ELABORAZIONE SIA CONCLUSA.          *
* LA FINESTRA SI CHIUDERA' AUTOMATICAMENTE.                                    *
*                                                                              *
* NON LANCIARE ALTRI COMANDI BUDUSCRIPT FINO A QUANDO QUESTA FINESTRA NON SI   *
* E' CHIUSA, PER EVITARE MALFUNZIONAMENTI.                                     *
*                                                                              *
********************************************************************************
EOF
	sleep 3
    fi
    
    [ -f "${temp_stat_db}" ] && rm -f "${temp_stat_db}"
    
    {
	check_plugin_type="LIST"
	if [ ${CONSENTI_XBSPSE_CHE_RICHIEDONO_PASSWORD:-Y} == "N" ]; then
	    printf 'GLI XBSPSE CHE DEVONO INDIVIDUARE UNA PASSWORD SONO DISABILITATI E NON SARANNO USATI.\n' >&2
	fi
	filtering_search_forked
	if [ -f "${search_pattern_db}" ]; then
	    [ -f "${search_string_tempfile}" ] && current_search_string=$(cat "${search_string_tempfile}")
	    [ "${current_search_string}" != "" ] && \
		is_already_searched=$(tail -n3 "${search_pattern_db}" | grep -iFc "${current_search_string}")
	fi
	if [ ${total_result:-0} == 0 ] || [ ${is_already_searched:-0} -ge 2 ]; then
	    if [ ${total_result:-0} == 0 ]; then
		printf 'LA RICERCA NON HA PRODOTTO RISULTATI UTILIZZANDO XBSPSE CHE FANNO USO DI LISTA; TENTO CON I WEB XDCC SEARCH ENGINE.\n' >&2
	    else
		flag_dont_reset_item_number=1
		printf 'AVENDO RIPETUTO LA RICERCA, DEDUCO NON SIANO STATI PRODOTTI RISULTATI SODDISFACENTI UTILIZZANDO XBSPSE CHE FANNO USO DI LISTA; TENTO CON I WEB XDCC SEARCH ENGINE.\n' >&2
	    fi
	    check_plugin_type="WEB"
	    elaboration_current_time=$(date +%s)
	    elaboration_time=$((${elaboration_current_time:-0} - ${elaboration_start_time:-0}))
	    if [ ${elaboration_time:-0} -lt ${TIMEOUT_RICERCA:-600} ]; then
		TIMEOUT_RICERCA=$((${TIMEOUT_RICERCA:-600} - ${elaboration_time:-0}))
		flag_skip_other_result=0
		filtering_search_forked
	    else
		printf 'TIMEOUT RAGGIUNTO, DEVO ABORTIRE IMMEDIATAMENTE [ELABORAZIONE: %d secondi].\n' ${elaboration_current_time:-0} >&2
	    fi
	fi
    } > "${search_query}"
    
    [ -f "${search_string_tempfile}" ] && rm -f ${search_string_tempfile}
    
    current_time=$(date +%s)
    elaboration_time=$((${current_time} - ${elaboration_start_time}))
    printf 'STATISTICA ELABORAZIONE: %d secondi per %d risultati.\n' ${elaboration_time} ${total_result:-0}
    [ $((${TIMEOUT_RICERCA} - 16)) -gt ${elaboration_time} ] && sleep 8;
    
    mv -f ${search_query} ${search_query}.exit
    
    debug_print "<" 'FORK_PROCESS'
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# Controllo: Verifica se il processo di ricerca e' terminato; se lo
# e', deve mostrare il risultato.
if [ "${command}" == "FORK_CHECK" ]; then
    load_config
    
    debug_print "x" 'FORK_CHECK'
    
    if [ -f ${search_query} ]; then
	timeout=$((${CURRENT_TIMEOUT:-${TIMEOUT_RICERCA}} - 8))
	
	if [ $((${TIMEOUT_RICERCA} - ${timeout})) -le ${TIMEOUT_RICERCA} ]; then
	    if [ ${RANDOM_NUMBER} == 5 ]; then
		echo "/TIMER -refnum 2255 8 budus pipe_script_silent ${0} ${database} ${dcc_database} ${server} FORK_CHECK 0 ${timeout}"
		
		printf '/ECHO %%C3,1%%B[XDCC MANAGER]\t%%C8,1 Sto ancora cercando, attendere il TIMEOUT di %d/%d secondi, prego ...\n' "$((${TIMEOUT_RICERCA} - ${timeout}))" "${TIMEOUT_RICERCA}"
	    else
		echo "/TIMER -refnum 2255 8 budus pipe_script_silent ${0} ${database} ${dcc_database} ${server} FORK_CHECK $((${RANDOM_NUMBER} + 1)) ${timeout}"
	    fi
	else
	    echo "XDCC MANAGER ERROR: TIMEOUT RAGGIUNTO !" >&2
	    printf '/ECHO %%C3,1%%B[XDCC MANAGER]\t%%C4,1 Timeout raggiunto, devo interrompere la ricerca. Se il problema persiste, limitare il numero dei motori di ricerca abilitati.%C8,1 Prova a ripetere la ricerca, la cache potrebbe favorire i tempi di elaborazione.\n'
	    
	    . "${script_path}/budus_XBSPSE_Crawler.sh"
	    queue_connection_manager 'FORCE_RELEASE'
	    
	    if [ -f ${search_query}.exit ]; then
		rm -f ${search_query}.exit
	    fi
	fi
    else
	if [ -f ${search_query}.exit ]; then
	    cat ${search_query}.exit
	    rm -f ${search_query}.exit
	    
	    if [ -f "${temp_network_failed_db}" ]; then
		printf '/ECHO %%C3,1%%B[XDCC MANAGER]\t%%C8,1 La risoluzione dei Network ha intercettato dei domini che necessitano di un Alias, fornito manualmente dall'\''utente, per poter essere risolti; vedi menu: XDCC -> Configurazione -> Elenca i Network che necessitano di un Alias\n'
	    fi
	else
	    . "${script_path}/budus_XBSPSE_Crawler.sh"
	    queue_connection_manager 'FORCE_RELEASE'
	    
	    printf '/ECHO %%C3,1%%B[XDCC MANAGER]\t%%C4,1 La ricerca si e'\'' interrotta inaspettatamente. Se il problema persiste, segnalare l'\''anomalia a UDA'\''Software.\n'
	fi
    fi
    
    debug_print "<" 'FORK_CHECK'
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# Controllo: Verifica se sono stati passati sufficienti parametri allo
# script.
if [ "${database}" != "LIBRARY" ] && [ "${command}" == "" ]; then
    echo "/ECHO %C4,1Sintassi errata, manca il comando."
    print_help
    exit 1;
fi

#####################################################################
#____________________________________________________________________
# Controllo: Verifica se deve creare il menu XDCC.
# [MENU]
if [ "$(echo "${command}" | grep "^[mM][eE][nN][uU]")" != "" ]; then
    load_config
    
    debug_print "x" 'LOAD MENU'

    [ -f "${temp_lock_file}" ] && rm -f "${temp_lock_file}"

    [ "${XDCC_DEBUG_MODE}" != "Y" ] && \
	[ -f "${xdcc_log_file}" ] && \
	rm -f "${xdcc_log_file}"
    
    if [ "$(echo "${command}" | grep "^MENU_RELOAD_XBSPSE")" != "" ]; then
	cat<<EOF
/MENU DEL "XDCC/Gestione Motori di Ricerca"
EOF
	
	# Cerca gli XBSPSE che sono solo un link, ed elimina quelli "broken".
	delete_xbspse_unlinked
	
	if [ "${SUB_COMMAND}" == "ACTIVATE" ]; then
	    plugin_list=$(find "${script_path}" -maxdepth 1 -iname 'budus_xdcc_plugin_*.sh')
	    for plugin in ${plugin_list}; do
		check_plugin SKIP_TYPE
		
		if [ ! -f "${plugin/.sh/}" ]; then
		    plugin_name=$(echo "${plugin}" | sed 's@.*budus_xdcc_plugin_@@' | cut -f1 -d'.')
		    touch "${plugin/.sh/}" && echo "/ECHO XDCC Search Engine Plugin%B ${plugin_name/_/ }%O%C3 enabled."
		fi
	    done
	elif [ "${SUB_COMMAND}" == "DEACTIVATE" ]; then
	    plugin_list=$(find "${script_path}" -maxdepth 1 -iname 'budus_xdcc_plugin_*.sh')
	    for plugin in ${plugin_list}; do
		check_plugin SKIP_TYPE
		
		if [ -f "${plugin/.sh/}" ]; then
		    plugin_name=$(echo "${plugin}" | sed 's@.*budus_xdcc_plugin_@@' | cut -f1 -d'.')
		    rm -f "${plugin/.sh/}" && echo "/ECHO XDCC Search Engine Plugin%B ${plugin_name/_/ }%O%C4 disabled."
		fi
	    done
	fi
	
	load_menu_XBSPSE
	
	debug_print "<" 'UNLOAD MENU'
	exit 0;
    fi

    # Carica la creazione automatica dei database permanenti degli XBSPSE
    printf '/budus InsertCommandInQueueTimed(0) 60 /budus cmd /budus macro xdcc MAKE_DB_ENABLED_XBSPSE_LIST_PASSWORD $sFlagAway $iPidOfProcess\n'
    
    # Carica le variabili funzione
    printf '/budus seth_internal buduscript_script__xdcc_session_manager /budus macro xdcc SESSION_MANAGER\n'
    
    # Carica le sentinelle nascoste statiche
    printf '/event addh 0 jserver * /TIMER -refnum 2255 8 budus macro xdcc DOWNLOAD_MANAGER JSERVER $hostname $server\n'
    printf '/event addh 0 jchannel '\''$lu'\''='\''$ru'\'' /TIMER -refnum 2255 8 budus macro xdcc DOWNLOAD_MANAGER JCHANNEL $hostname $server $channel\n'
    printf '/event addh 0 other '\''DOWNLOAD_MANAGER::$server$_470$_='\''DOWNLOAD_MANAGER:$data'\'' /TIMER -refnum 2255 8 budus cmd /budus macro xdcc DOWNLOAD_MANAGER REDIRECT $hostname $server $channel filter( +#[^_BUDUSCRIPT_COMMA_ ]*,$data )\n'
    
    cat<<EOF
/budus ExecUserInput() /MENU ADD "\$URL/Download-XDCC" "budus macro xdcc %s"
/MENU DEL "XDCC"
/MENU ADD "_XDCC"
EOF
    if [ "$(echo "${command}" | grep "^MENU_PERSISTENT")" == "" ]; then
	cat<<EOF
/MENU -i.xchat2/buduscript/Icons/del_16.png ADD "XDCC/Elimina Menu XDCC Manager" "budus macro MC /MENU DEL _XDCC | /MENU DEL \$URL/Download-_XDCC"
/MENU ADD "XDCC/-"
EOF
    else
	[ -f "${temp_reflex_list}" ] && rm -f "${temp_reflex_list}"
    fi
    
    cat<<EOF
/budus seth_internal buduscript_macro__xdcc_find_command /budus cmd /budus macro buduscript_macro__getstr_quadri "replace( -", ,init( \$buduscript_script__xdcc_keywords,keywords ) )" budus macro xdcc s Inserire la chiave di ricerca
/MENU -i.xchat2/buduscript/Icons/find_16.png ADD "XDCC/Cerca ..." "budus cmd \$buduscript_macro__xdcc_find_command"
/MENU ADD "XDCC/Ripeti Ricerca"
/MENU -i.xchat2/buduscript/Icons/del_16.png ADD "XDCC/Ripeti Ricerca/Elimina Cronologia Ricerca" "budus macro xdcc CLEAN_SEARCH_DB"
/MENU ADD "XDCC/Ripeti Ricerca/-"
/MENU -i.xchat2/buduscript/Icons/download_16.png ADD "XDCC/Scarica tramite ID BuDuScRiPt ..." "budus macro buduscript_macro__getstr_quadri ID budus macro xdcc d Inserire l'ID della risorsa desiderata:"
/budus seth_internal buduscript_macro__xdcc_botserv_download /GETSTR "ID" "budus cmd /budus macro xdcc DOWNLOAD_MANAGER BOTSERV_MANUAL_REQUEST \$network \$session" "Inserire l'ID della risorsa desiderata"
/MENU ADD "XDCC/Scarica dal BOTSERV Selezionato ..." "budus cmd *\$buduscript_macro__xdcc_botserv_download"
/budus seth_internal buduscript_macro__xdcc_filelist_download /GETFILE "budus macro xdcc DOWNLOAD_MANAGER FILELIST_DOWNLOAD" "Seleziona il File Lista contenente l'elenco da scaricare"
/MENU ADD "XDCC/Scarica tramite File Elenco ..." "budus cmd \$buduscript_macro__xdcc_filelist_download"
/MENU ADD "XDCC/-"
/MENU -i.xchat2/buduscript/Icons/save_config_16.png ADD "XDCC/Genera Database Risorse Disponibili" "EXEC ${script_path}/budus_xdcc.sh NULL NULL NULL MAKE_DB_AVAILABLE_RESOURCE"
/MENU -i.xchat2/buduscript/Icons/decorations_list_16.png ADD "XDCC/Cerca Risorse Disponibili nei Database Permanenti" "EXEC xterm -e ${0} '${database:-NULL}' '${dcc_database:-NULL}' '${server:-NULL}' VIEW_AVAILABLE_RESOURCE_ON_PERMANENT_DB &"
/MENU -i.xchat2/buduscript/Icons/list_16.png ADD "XDCC/Visualizza risultati successivi Ultima Ricerca" "budus macro xdcc VIEW_LAST_SEARCH"
/MENU ADD "XDCC/-"
/MENU -i.xchat2/buduscript/Icons/log_manager_16.png ADD "XDCC/Apri Cartella Download Incompleti" "budus cmd /EXEC [ \$(which nautilus 2> /dev/null) ] && nautilus xchatvar( dcc_dir ) || echo 'ERRORE: Nautilus non installato.'"
/MENU -i.xchat2/buduscript/Icons/log_manager_16.png ADD "XDCC/Apri Cartella Download Completati" "budus cmd /EXEC [ \$(which nautilus 2> /dev/null) ] && nautilus xchatvar( dcc_completed_dir ) || echo 'ERRORE: Nautilus non installato.'"
/MENU ADD "XDCC/-"
/MENU -i.xchat2/buduscript/Icons/list_16.png ADD "XDCC/Elenca Stato Coda dei Download" "budus macro xdcc l"
/MENU ADD "XDCC/Download in Coda"
/MENU ADD "XDCC/Download in Coda/FORZA"
/MENU -e0 ADD "XDCC/Download in Coda/FORZA/Seleziona il Download da lanciare" "budus help"
/MENU ADD "XDCC/Download in Coda/FORZA/-"
/MENU ADD "XDCC/Download in Coda/CANCELLA"
/MENU -e0 ADD "XDCC/Download in Coda/CANCELLA/Seleziona il Download da cancellare" "budus help"
/MENU ADD "XDCC/Download in Coda/CANCELLA/-"
/MENU ADD "XDCC/Download in Elaborazione"
/MENU -e0 ADD "XDCC/Download in Elaborazione/Seleziona il Download da cancellare" "budus help"
/MENU ADD "XDCC/Download in Elaborazione/-"
/MENU ADD "XDCC/Download in Trasferimento"
/MENU -e0 ADD "XDCC/Download in Trasferimento/Seleziona il Download da cancellare" "budus help"
/MENU ADD "XDCC/Download in Trasferimento/-"
/MENU ADD "XDCC/Cronologia Download"
/MENU ADD "XDCC/Cronologia Download/Cancella Cronologia" "budus macro xdcc CLEAN_REPEAT_DB"
/MENU ADD "XDCC/Cronologia Download/-"
/MENU -e0 ADD "XDCC/Cronologia Download/Seleziona il Download da ripetere" "budus help"
/MENU ADD "XDCC/Cronologia Download/-"
/MENU -i.xchat2/buduscript/Icons/list_16.png ADD "XDCC/Elenca Download Abortiti" "budus macro xdcc a"
/MENU -i.xchat2/buduscript/Icons/del_16.png ADD "XDCC/Svuota Elenco Download Abortiti" "budus macro xdcc ax"
/MENU ADD "XDCC/-"
EOF

if [ -f ${script_path}/xdcc_queue_lock ]; then
    echo -n '/MENU -t1'
else
    echo -n '/MENU -t0'
fi
echo ' ADD "XDCC/Blocca la Coda dei Download" "budus pipe_silent touch '${script_path}'/xdcc_queue_lock && echo '\''Coda dei Download: Bloccata.'\'' || echo '\''ERRORE: Impossibile Bloccare la Coda dei Download.'\''" "budus pipe_silent rm '${script_path}'/xdcc_queue_lock && echo '\''Coda dei Download: Sbloccata.'\'' || echo '\''ERRORE: Impossibile Sbloccare la Coda dei Download.'\''"'

    cat<<EOF
/MENU -i.xchat2/buduscript/Icons/del_16.png ADD "XDCC/Annulla Download in Coda" "budus macro xdcc ABORT_ALL_DOWNLOAD ONLY_QUEUE"
/MENU -i.xchat2/buduscript/Icons/del_16.png ADD "XDCC/Annulla Download in Coda\Elaborazione" "budus macro xdcc ABORT_ALL_DOWNLOAD"
/MENU ADD "XDCC/Gestione Coda Download"
/MENU -i.xchat2/buduscript/Icons/list_16.png ADD "XDCC/Gestione Coda Download/Elenca Stato Download Salvato" "budus macro xdcc LIST_QUEUE_STATUS"
/MENU ADD "XDCC/Gestione Coda Download/-"
/MENU -i.xchat2/buduscript/Icons/channel_rejoin_16.png ADD "XDCC/Gestione Coda Download/Ripristina Stato Download Salvato" "budus macro xdcc READ_QUEUE_STATUS"
/MENU -i.xchat2/buduscript/Icons/save_16.png ADD "XDCC/Gestione Coda Download/Salva Stato Download Corrente" "budus macro xdcc SAVE_QUEUE_STATUS"
/MENU ADD "XDCC/-"
/MENU -i.xchat2/buduscript/Icons/help_16.png ADD "XDCC/Guida della MACRO" "budus macro xdcc"
/MENU -i.xchat2/buduscript/Icons/help_16.png ADD "XDCC/XDCC Bash Script Plugin Search Engine" "exec xterm -e less $HOME/.xchat2/buduscript/XDCC.txt"
/MENU ADD "XDCC/-"
/MENU ADD "XDCC/XDCC Reflex - Redirezione Download"
/MENU -i.xchat2/buduscript/Icons/add_16.png ADD "XDCC/XDCC Reflex - Redirezione Download/Sorgente - Devia XDCC provenienti dall'Utente selezionato" "budus cmd /budus macro xdcc ADD_REFLEX_BOT \$network %c %s"
/MENU -i.xchat2/buduscript/Icons/add_16.png ADD "XDCC/XDCC Reflex - Redirezione Download/Destinazione - Utente selezionato al quale deviare XDCC" "budus cmd /budus macro xdcc ADD_REFLEX_USER \$network %c %s"
/MENU ADD "XDCC/XDCC Reflex - Redirezione Download/-"
/MENU -i.xchat2/buduscript/Icons/save_16.png ADD "XDCC/XDCC Reflex - Redirezione Download/Rendi Permanenti Tutte le Redirezioni Attive" "EXEC cp -f ${temp_reflex_list} ${permanent_reflex_list} && printf '[XDCC REFLEX]\t Redirezioni Attive rese Permanenti.\n'"
/MENU ADD "XDCC/XDCC Reflex - Redirezione Download/-"
/MENU -i.xchat2/buduscript/Icons/del_16.png ADD "XDCC/XDCC Reflex - Redirezione Download/Cancella Tutte le Redirezioni Attive" "budus macro xdcc DEL_REFLEX_USER ALL"
/MENU ADD "XDCC/XDCC Reflex - Redirezione Download/-"
EOF
    
    if [ -f "${search_pattern_db}" ]; then
	debug_print "*" 'LOAD SEARCH PATTERN DB'
	
	IFS_OLD=${IFS}
	IFS=$'\n'
	for search_pattern in $(cat "${search_pattern_db}" | sed 's@[/"]@ @g' | uniq | tail -n 20 | sort | uniq); do
	    debug_print "*" "${search_pattern}"
	    
	    cat<<EOF
/MENU ADD "XDCC/Ripeti Ricerca/${search_pattern}" "budus macro xdcc s ${search_pattern}"
EOF
	done
	
	mv "${search_pattern_db}" "${search_pattern_db}.purge"
	cat "${search_pattern_db}.purge" | sed 's@[/"]@ @g' | uniq | tail -n 20 | sort | uniq > "${search_pattern_db}"
	rm -f  "${search_pattern_db}.purge"
	
	IFS=${IFS_OLD}
    fi
    
    if [ -f "${repeat_db}" ]; then
	debug_print "*" 'LOAD REPEAT DB'
	
	IFS_OLD=${IFS}
	IFS=$'\n'
	for ITEM in $(tail -n20 "${repeat_db}"); do
	    debug_print "*" "${ITEM}"
	    
	    add_item_to_menu "REPEAT"
	done
	IFS=${IFS_OLD}
    else
	if [ "${DISABILITA_PRIVATE_KILLER_SYSTEM_AUTOMATICAMENTE}" == "N" ]; then
	    # Verifica la presenza del Private Killer System
	    cat<<EOF
/TIMER -refnum 2255 16 budus if \$iPrivateKillerAlert > 0 /budus sendsess \$current_tab /ECHO [XDCC MANAGER]	%C8,1%BATTENZIONE:%O Il %BPrivate Killer System%O risulta abilitato a censurare gli utenti sconosciuti. Questo puo' comportare malfunzionamenti nell'uso del %BXDCC DOWNLOAD MANAGER%O. Se fai uso di questo sistema e' consigliato disabilitare il %BPrivate Killer System%O; in alternativa, puoi disabilitare il menu %BXDCC%O, oppure, configurarlo in modo diverso (vedi: %BXDCC -> Configurazione -> Disabilita Private Killer System Automaticamente%O).
EOF
	fi
    fi
    
    [ -f "${permanent_reflex_list}" ] && \
	cp -f "${permanent_reflex_list}" "${temp_reflex_list}" && \
	printf '/ECHO [XDCC REFLEX]\t Caricamento Redirezioni Permanenti.\n'
    
    if [ -f "${temp_reflex_list}" ]; then
	temp_reflex_list_db=$(cat "${temp_reflex_list}")
	rm -f "${temp_reflex_list}"
	
	IFS_OLD=${IFS}
	IFS=$'\n'
	for reflex_item in ${temp_reflex_list_db}; do
	    get_data_from_reflex_item
	    
	    add_menu_item_reflex "${reflex_source_user_name}" "${reflex_source_network_name}" "${reflex_source_channel_name}" "${reflex_destination_user_name}" "${reflex_destination_network_name}" "${reflex_destination_channel_name}"
	done
	IFS=${IFS_OLD}
    fi
    
    [ ! -f "${temp_reflex_list}" ] && rm -f "${permanent_reflex_list}"
    
    cat<<EOF
/MENU ADD "XDCC/-"
/MENU ADD "XDCC/Configurazione"
/MENU ADD "XDCC/Configurazione/Visualizza Configurazione Corrente" "EXEC cat ${config_file}"
/MENU ADD "XDCC/Configurazione/Elenca Statistica degli XBSPSE sull'Ultima Ricerca." "budus pipe_script_silent echo '/ECHO Elenco statistica risultati dell'\''ultima ricerca:' && cat ${temp_stat_db} | sed 's@^@/ECHO @g'"
/MENU ADD "XDCC/Configurazione/-"
/MENU ADD "XDCC/Configurazione/Secondi di attesa prima di abortire la ricerca ..." "budus macro MC EXEC echo 'TIMEOUT_RICERCA \$\$?=_VIRGOLETTE_Inserire il numero di secondi prima di abortire la ricerca_VIRGOLETTE_' >> ${config_file}"
/MENU ADD "XDCC/Configurazione/Numero massimo di risultati ..." "budus macro MC EXEC echo 'NUMERO_MASSIMO_DI_RISULTATI \$\$?=_VIRGOLETTE_Inserire il numero massimo di risultati visualizzabili_VIRGOLETTE_' >> ${config_file}"
EOF
    if [ "${RIMUOVI_RISULTATI_INCOMPLETI}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Elimina Risultati incompleti" "EXEC echo '\''RIMUOVI_RISULTATI_INCOMPLETI Y'\'' >> %s" "EXEC echo '\''RIMUOVI_RISULTATI_INCOMPLETI N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Elimina Risultati incompleti" "EXEC echo '\''RIMUOVI_RISULTATI_INCOMPLETI Y'\'' >> %s" "EXEC echo '\''RIMUOVI_RISULTATI_INCOMPLETI N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi

    if [ "${ELENCA_RISULTATI_SENZA_FORMATTAZIONE}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Elenca Risultati senza Formattazione" "EXEC echo '\''ELENCA_RISULTATI_SENZA_FORMATTAZIONE Y'\'' >> %s" "EXEC echo '\''ELENCA_RISULTATI_SENZA_FORMATTAZIONE N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Elenca Risultati senza Formattazione" "EXEC echo '\''ELENCA_RISULTATI_SENZA_FORMATTAZIONE Y'\'' >> %s" "EXEC echo '\''ELENCA_RISULTATI_SENZA_FORMATTAZIONE N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi
    
    if [ "${MANTIENI_SOLO_I_RISULTATI_CHE_RISPETTANO_TUTTE_LE_CHIAVI_DI_RICERCA}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Mantieni solo i risultati che soddisfano tutte le chiavi di ricerca" "EXEC echo '\''MANTIENI_SOLO_I_RISULTATI_CHE_RISPETTANO_TUTTE_LE_CHIAVI_DI_RICERCA Y'\'' >> %s" "EXEC echo '\''MANTIENI_SOLO_I_RISULTATI_CHE_RISPETTANO_TUTTE_LE_CHIAVI_DI_RICERCA N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Mantieni solo i risultati che soddisfano tutte le chiavi di ricerca" "EXEC echo '\''MANTIENI_SOLO_I_RISULTATI_CHE_RISPETTANO_TUTTE_LE_CHIAVI_DI_RICERCA Y'\'' >> %s" "EXEC echo '\''MANTIENI_SOLO_I_RISULTATI_CHE_RISPETTANO_TUTTE_LE_CHIAVI_DI_RICERCA N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi
    
    if [ "${TOGLI_CHIAVI_SUPERFLUE_NELLA_RICERCA}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Togli le chiavi superflue durante la ricerca" "EXEC echo '\''TOGLI_CHIAVI_SUPERFLUE_NELLA_RICERCA Y'\'' >> %s" "EXEC echo '\''TOGLI_CHIAVI_SUPERFLUE_NELLA_RICERCA N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Togli le chiavi superflue durante la ricerca" "EXEC echo '\''TOGLI_CHIAVI_SUPERFLUE_NELLA_RICERCA Y'\'' >> %s" "EXEC echo '\''TOGLI_CHIAVI_SUPERFLUE_NELLA_RICERCA N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi
    
    if [ "${ELIMINA_RISULTATI_RICERCA_WEB_SOVRAPPOSTI_XBSPSE_LIST}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Elimina i risultati della ricerca WEB sovrapposti a quella LIST" "EXEC echo '\''ELIMINA_RISULTATI_RICERCA_WEB_SOVRAPPOSTI_XBSPSE_LIST Y'\'' >> %s" "EXEC echo '\''ELIMINA_RISULTATI_RICERCA_WEB_SOVRAPPOSTI_XBSPSE_LIST N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Elimina i risultati della ricerca WEB sovrapposti a quella LIST" "EXEC echo '\''ELIMINA_RISULTATI_RICERCA_WEB_SOVRAPPOSTI_XBSPSE_LIST Y'\'' >> %s" "EXEC echo '\''ELIMINA_RISULTATI_RICERCA_WEB_SOVRAPPOSTI_XBSPSE_LIST N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi
    
    if [ "${USA_CODA_DEI_DOWNLOAD}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Usa la Coda dei Download" "EXEC echo '\''USA_CODA_DEI_DOWNLOAD Y'\'' >> %s" "EXEC echo '\''USA_CODA_DEI_DOWNLOAD N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Usa la Coda dei Download" "EXEC echo '\''USA_CODA_DEI_DOWNLOAD Y'\'' >> %s" "EXEC echo '\''USA_CODA_DEI_DOWNLOAD N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi
    
    if [ "${ESEGUI_XBSPSE_CONTEMPORANEAMENTE}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Esegui Plugin di Ricerca (XBSPSE) in parallelo" "EXEC echo '\''ESEGUI_XBSPSE_CONTEMPORANEAMENTE Y'\'' >> %s" "EXEC echo '\''ESEGUI_XBSPSE_CONTEMPORANEAMENTE N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Esegui Plugin di Ricerca (XBSPSE) in parallelo" "EXEC echo '\''ESEGUI_XBSPSE_CONTEMPORANEAMENTE Y'\'' >> %s" "EXEC echo '\''ESEGUI_XBSPSE_CONTEMPORANEAMENTE N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi
    
    if [ "${CONSENTI_XBSPSE_CHE_RICHIEDONO_PASSWORD}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Consenti Plugin di Ricerca (XBSPSE) che richiedono Password" "EXEC echo '\''CONSENTI_XBSPSE_CHE_RICHIEDONO_PASSWORD Y'\'' >> %s" "EXEC echo '\''CONSENTI_XBSPSE_CHE_RICHIEDONO_PASSWORD N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Consenti Plugin di Ricerca (XBSPSE) che richiedono Password" "EXEC echo '\''CONSENTI_XBSPSE_CHE_RICHIEDONO_PASSWORD Y'\'' >> %s" "EXEC echo '\''CONSENTI_XBSPSE_CHE_RICHIEDONO_PASSWORD N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi
    
    if [ "${ESEGUI_VERIFICA_MD5SUM_SUI_FILE_SCARICATI}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Controlla files scaricati quando viene fornito MD5SUM" "EXEC echo '\''ESEGUI_VERIFICA_MD5SUM_SUI_FILE_SCARICATI Y'\'' >> %s" "EXEC echo '\''ESEGUI_VERIFICA_MD5SUM_SUI_FILE_SCARICATI N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Controlla files scaricati quando viene fornito MD5SUM" "EXEC echo '\''ESEGUI_VERIFICA_MD5SUM_SUI_FILE_SCARICATI Y'\'' >> %s" "EXEC echo '\''ESEGUI_VERIFICA_MD5SUM_SUI_FILE_SCARICATI N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi
    
    if [ "${EVITA_DOWNLOAD_DEL_MEDESIMO_FILE}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Annulla Automaticamente Download Medesimo File" "EXEC echo '\''EVITA_DOWNLOAD_DEL_MEDESIMO_FILE Y'\'' >> %s" "EXEC echo '\''EVITA_DOWNLOAD_DEL_MEDESIMO_FILE N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Annulla Automaticamente Download Medesimo File" "EXEC echo '\''EVITA_DOWNLOAD_DEL_MEDESIMO_FILE Y'\'' >> %s" "EXEC echo '\''EVITA_DOWNLOAD_DEL_MEDESIMO_FILE N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi
    
    if [ "${CONSENTI_RIPRESA_DOWNLOAD_AUTOMATICA}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Consenti Ripresa Download Automatica" "EXEC echo '\''CONSENTI_RIPRESA_DOWNLOAD_AUTOMATICA Y'\'' >> %s" "EXEC echo '\''CONSENTI_RIPRESA_DOWNLOAD_AUTOMATICA N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Consenti Ripresa Download Automatica" "EXEC echo '\''CONSENTI_RIPRESA_DOWNLOAD_AUTOMATICA Y'\'' >> %s" "EXEC echo '\''CONSENTI_RIPRESA_DOWNLOAD_AUTOMATICA N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi
    
    if [ "${CONSENTI_RIPRESA_DOWNLOAD_MANUALE}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Consenti Ripresa Download Manuale" "EXEC echo '\''CONSENTI_RIPRESA_DOWNLOAD_MANUALE Y'\'' >> %s" "EXEC echo '\''CONSENTI_RIPRESA_DOWNLOAD_MANUALE N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Consenti Ripresa Download Manuale" "EXEC echo '\''CONSENTI_RIPRESA_DOWNLOAD_MANUALE Y'\'' >> %s" "EXEC echo '\''CONSENTI_RIPRESA_DOWNLOAD_MANUALE N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi
    
    if [ "${ABILITA_NUOVO_TENTATIVO_AUTOMATICO_SU_FALLIMENTO}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Consenti Ripetizione Automatica Download Fallito" "EXEC echo '\''ABILITA_NUOVO_TENTATIVO_AUTOMATICO_SU_FALLIMENTO Y'\'' >> %s" "EXEC echo '\''ABILITA_NUOVO_TENTATIVO_AUTOMATICO_SU_FALLIMENTO N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Consenti Ripetizione Automatica Download Fallito" "EXEC echo '\''ABILITA_NUOVO_TENTATIVO_AUTOMATICO_SU_FALLIMENTO Y'\'' >> %s" "EXEC echo '\''ABILITA_NUOVO_TENTATIVO_AUTOMATICO_SU_FALLIMENTO N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi
    
    if [ "${MANTIENI_DOWNLOAD_IN_CODA_ANCHE_DOPO_TIMEOUT}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Mantieni Download in Coda anche dopo Timeout" "EXEC echo '\''MANTIENI_DOWNLOAD_IN_CODA_ANCHE_DOPO_TIMEOUT Y'\'' >> %s" "EXEC echo '\''MANTIENI_DOWNLOAD_IN_CODA_ANCHE_DOPO_TIMEOUT N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Mantieni Download in Coda anche dopo Timeout" "EXEC echo '\''MANTIENI_DOWNLOAD_IN_CODA_ANCHE_DOPO_TIMEOUT Y'\'' >> %s" "EXEC echo '\''MANTIENI_DOWNLOAD_IN_CODA_ANCHE_DOPO_TIMEOUT N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi
    
    if [ "${FORZA_PERIODICAMENTE_DOWNLOAD_IN_STATO_DI_TIMEOUT}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Forza periodicamente Download in stato di Timeout" "EXEC echo '\''FORZA_PERIODICAMENTE_DOWNLOAD_IN_STATO_DI_TIMEOUT Y'\'' >> %s" "EXEC echo '\''FORZA_PERIODICAMENTE_DOWNLOAD_IN_STATO_DI_TIMEOUT N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Forza periodicamente Download in stato di Timeout" "EXEC echo '\''FORZA_PERIODICAMENTE_DOWNLOAD_IN_STATO_DI_TIMEOUT Y'\'' >> %s" "EXEC echo '\''FORZA_PERIODICAMENTE_DOWNLOAD_IN_STATO_DI_TIMEOUT N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi
    
    if [ "${ACCETTA_TRASFERIMENTI_AMBIGUI}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Accetta Trasferimenti Ambigui" "EXEC echo '\''ACCETTA_TRASFERIMENTI_AMBIGUI Y'\'' >> %s" "EXEC echo '\''ACCETTA_TRASFERIMENTI_AMBIGUI N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Accetta Trasferimenti Ambigui" "EXEC echo '\''ACCETTA_TRASFERIMENTI_AMBIGUI Y'\'' >> %s" "EXEC echo '\''ACCETTA_TRASFERIMENTI_AMBIGUI N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi
    
    if [ "${DISABILITA_PRIVATE_KILLER_SYSTEM_AUTOMATICAMENTE}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Disabilita Private Killer System Automaticamente" "EXEC echo '\''DISABILITA_PRIVATE_KILLER_SYSTEM_AUTOMATICAMENTE Y'\'' >> %s" "EXEC echo '\''DISABILITA_PRIVATE_KILLER_SYSTEM_AUTOMATICAMENTE N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Disabilita Private Killer System Automaticamente" "EXEC echo '\''DISABILITA_PRIVATE_KILLER_SYSTEM_AUTOMATICAMENTE Y'\'' >> %s" "EXEC echo '\''DISABILITA_PRIVATE_KILLER_SYSTEM_AUTOMATICAMENTE N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi
    
    if [ "${MESSAGGI_BOTSERV_SOLO_NELLA_FINESTRA_RELATIVA}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Messaggi del BOTSERV solo nella Finestra Relativa" "EXEC echo '\''MESSAGGI_BOTSERV_SOLO_NELLA_FINESTRA_RELATIVA Y'\'' >> %s" "EXEC echo '\''MESSAGGI_BOTSERV_SOLO_NELLA_FINESTRA_RELATIVA N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Messaggi del BOTSERV solo nella Finestra Relativa" "EXEC echo '\''MESSAGGI_BOTSERV_SOLO_NELLA_FINESTRA_RELATIVA Y'\'' >> %s" "EXEC echo '\''MESSAGGI_BOTSERV_SOLO_NELLA_FINESTRA_RELATIVA N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi
    
    if [ "${CREA_DATABASE_PERMANENTI_AUTOMATICAMENTE_QUANDO_SONO_AWAY}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Crea Database Permanenti degli XBSPSE Automaticamente quando sono AWAY" "EXEC echo '\''CREA_DATABASE_PERMANENTI_AUTOMATICAMENTE_QUANDO_SONO_AWAY Y'\'' >> %s" "EXEC echo '\''CREA_DATABASE_PERMANENTI_AUTOMATICAMENTE_QUANDO_SONO_AWAY N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Crea Database Permanenti degli XBSPSE Automaticamente quando sono AWAY" "EXEC echo '\''CREA_DATABASE_PERMANENTI_AUTOMATICAMENTE_QUANDO_SONO_AWAY Y'\'' >> %s" "EXEC echo '\''CREA_DATABASE_PERMANENTI_AUTOMATICAMENTE_QUANDO_SONO_AWAY N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi
    
    if [ "${AGGIORNA_AUTOMATICAMENTE_DATABASE_PERMANENTI_OBSOLETI}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Aggiorna automaticamente database permanenti obsoleti" "EXEC echo '\''AGGIORNA_AUTOMATICAMENTE_DATABASE_PERMANENTI_OBSOLETI Y'\'' >> %s" "EXEC echo '\''AGGIORNA_AUTOMATICAMENTE_DATABASE_PERMANENTI_OBSOLETI N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Aggiorna automaticamente database permanenti obsoleti" "EXEC echo '\''AGGIORNA_AUTOMATICAMENTE_DATABASE_PERMANENTI_OBSOLETI Y'\'' >> %s" "EXEC echo '\''AGGIORNA_AUTOMATICAMENTE_DATABASE_PERMANENTI_OBSOLETI N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi
    
    if [ "${EMETTI_AVVISI_ACUSTICI_DI_AVVISO}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Emetti Segnali Acustici di Avviso" "EXEC echo '\''EMETTI_AVVISI_ACUSTICI_DI_AVVISO Y'\'' >> %s" "EXEC echo '\''EMETTI_AVVISI_ACUSTICI_DI_AVVISO N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Emetti Segnali Acustici di Avviso" "EXEC echo '\''EMETTI_AVVISI_ACUSTICI_DI_AVVISO Y'\'' >> %s" "EXEC echo '\''EMETTI_AVVISI_ACUSTICI_DI_AVVISO N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi
    
    if [ "${VISUALIZZA_DATABASE_PERMANENTI_IN_FORMATO_FILE_ELENCO}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Visualizza Database Permanenti in Formato File Elenco" "EXEC echo '\''VISUALIZZA_DATABASE_PERMANENTI_IN_FORMATO_FILE_ELENCO Y'\'' >> %s" "EXEC echo '\''VISUALIZZA_DATABASE_PERMANENTI_IN_FORMATO_FILE_ELENCO N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Visualizza Database Permanenti in Formato File Elenco" "EXEC echo '\''VISUALIZZA_DATABASE_PERMANENTI_IN_FORMATO_FILE_ELENCO Y'\'' >> %s" "EXEC echo '\''VISUALIZZA_DATABASE_PERMANENTI_IN_FORMATO_FILE_ELENCO N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi
    
    if [ "${UTILIZZA_UDA_DATA_COPY_COME_VISUALIZZATORE_ESTERNO}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Utilizza UDA DATA COPY come Visualizzatore Esterno" "EXEC echo '\''UTILIZZA_UDA_DATA_COPY_COME_VISUALIZZATORE_ESTERNO Y'\'' >> %s" "EXEC echo '\''UTILIZZA_UDA_DATA_COPY_COME_VISUALIZZATORE_ESTERNO N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Utilizza UDA DATA COPY come Visualizzatore Esterno" "EXEC echo '\''UTILIZZA_UDA_DATA_COPY_COME_VISUALIZZATORE_ESTERNO Y'\'' >> %s" "EXEC echo '\''UTILIZZA_UDA_DATA_COPY_COME_VISUALIZZATORE_ESTERNO N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi
    
    if [ "${XDCC_DEBUG_MODE}" == "N" ]; then
	printf '/MENU -t0 ADD "XDCC/Configurazione/Modalita Debug" "EXEC echo '\''XDCC_DEBUG_MODE Y'\'' >> %s" "EXEC echo '\''XDCC_DEBUG_MODE N'\'' >> %s"\n' "${config_file}" "${config_file}"
    else
	printf '/MENU -t1 ADD "XDCC/Configurazione/Modalita Debug" "EXEC echo '\''XDCC_DEBUG_MODE Y'\'' >> %s" "EXEC echo '\''XDCC_DEBUG_MODE N'\'' >> %s"\n' "${config_file}" "${config_file}"
    fi

    #
    cat<<EOF
/MENU ADD "XDCC/Configurazione/-"
/MENU -i.xchat2/buduscript/Icons/del_16.png ADD "XDCC/Configurazione/Cancella la Cache del Search Engine" "budus macro xdcc DELETE_CACHE"
/MENU -i.xchat2/buduscript/Icons/del_16.png ADD "XDCC/Configurazione/Cancella lo Stato della Coda dei Download" "budus macro xdcc DELETE_QUEUE_STATUS"
/MENU ADD "XDCC/Configurazione/-"
/MENU -i.xchat2/buduscript/Icons/list_16.png ADD "XDCC/Configurazione/Elenca i Network che necessitano di un Alias" "budus cmd /ECHO Elenco i Network IRC che necessitano di un Alias (puoi cercarli usando: %Bhttp://searchirc.com%O):\;/EXEC [ -f ${temp_network_failed_db} ] && cat ${temp_network_failed_db} || echo 'Non risultano Network per i quali sia necessario un Alias; prova ad effettuare una ricerca prima di usare questo comando.'"
/MENU -i.xchat2/buduscript/Icons/add_16.png ADD "XDCC/Configurazione/Aggiungi un Network Alias" "budus macro xdcc ADD_NETWORK_ALIAS"
/MENU ADD "XDCC/Configurazione/Rimuovi un Network Alias"
/MENU ADD "XDCC/-"
EOF
    
    #
    if [ -f "${xdcc_network_alias_db}" ]; then
	IFS_OLD=${IFS}
	IFS=$'\n'
	
	for item in $(cat "${xdcc_network_alias_db}"); do
	    network_name=$(echo "${item}" | awk '{print $1}')
	    network_alias=$(echo "${item}" | awk '{print $2}')
	    printf '/MENU ADD "XDCC/Configurazione/Rimuovi un Network Alias/%s = %s" "budus macro xdcc DEL_NETWORK_ALIAS %s"\n' "${network_name}" "${network_alias}" "${network_name}"
	done
	
	IFS=${IFS_OLD}
    fi
    
    # Se e' stata pronotata una cancellazione del database, procede
    # con l'eliminazione di tutti i files coinvolti.
    if [ -f "${db_default_path}DELETE_QUEUE_STATUS" ]; then
	rm -f "${db_default_path}"*
	
	printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Tutti i files relativi all'\''XDCC MANAGER custoditi nella cartella "tmp" di BuDuScRiPt sono stati eliminati.\n'
    fi
    
    # Recupera l'eventuale coda precedente.
    recovering_database=$(ls "${db_default_path}download_queue_"*".dat" "${db_default_path}waiting_"*".dat" "${db_default_path}request_"*".dat" "${db_default_path}transfer_"*".dat" 2> /dev/null | wc -l)
    printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t Database recuperabili da precedenti sessioni:%%C4,1 %d\n' ${recovering_database:-0}
    
    for current_db_to_recover in "${db_default_path}download_queue_"*".dat"; do
	db_recover "${current_db_to_recover}"
    done
    for current_db_to_recover in "${db_default_path}waiting_"*".dat"; do
	db_recover "${current_db_to_recover}"
    done
    for current_db_to_recover in "${db_default_path}request_"*".dat"; do
	db_recover "${current_db_to_recover}"
    done
    for current_db_to_recover in "${db_default_path}transfer_"*".dat"; do
	db_recover "${current_db_to_recover}"
    done
    
    [ ${flag_db_recovered:-0} == 1 ] && \
	printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Sono stati recuperati dei database appartenenti a precedenti sessioni di XChat; gli item recuperati sono stati messi in CODA DOWNLOAD e saranno elaborati tra %d secondi.\n' 60 && \
	printf '/budus macro xdcc l\n' && \
	printf '/TIMER -refnum 2255 %d budus macro xdcc DOWNLOAD_MANAGER check_download_queue\n' 60 && \
	[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' d
    
    # Carica il menu dei motori di ricerca.
    load_menu_XBSPSE
    
    printf "/ECHO ---\t %%C3,1%%BMenu XDCC Manager aggiunto.\n"
    
    if [ -f ${script_path}/xdcc_queue_lock ]; then
	printf '/TIMER -refnum 2255 30 budus pipe_script_silent [ -f ${script_path}/xdcc_queue_lock ] && echo "/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O La Coda dei Download risulta bloccata."\n'
    fi
    
    debug_print "<" 'LOAD MENU'
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# Controllo: Verifica se deve eliminare il menu XDCC.
if [ "$(echo "${command}" | grep -i "^[uU][mM][eE][nN][uU]")" != "" ]; then
    load_config
    
    debug_print "x" 'UNLOAD MENU'
    
    cat<<EOF
/MENU DEL "XDCC"
/budus ExecUserInput() /MENU DEL "\$URL/Download-XDCC"
EOF
    # Rimuove le sentinelle nascoste statiche
    printf '/event listh DOWNLOAD_MANAGER -\n'
    
    # Rimuove la creazione automatica dei database permanenti degli XBSPSE
    printf '/budus DeleteCommandInQueue(0) MAKE_DB_ENABLED_XBSPSE_LIST_PASSWORD\n'
    
    printf "/ECHO ---\t %%C3,1%%BMenu XDCC Manager rimosso."
    
    debug_print "<" 'UNLOAD MENU'
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# Controllo: Verifica se deve gestire i Network Alias.
if [ "$(echo "${command}" | grep -i "^ADD_NETWORK_ALIAS")" != "" ]; then
    load_config
    
    debug_print "x" 'ADD_NETWORK_ALIAS'
    
    xterm -e ${script_path}/buduscript_script__multicommand.sh QUERY "Inserire il Nome del Network al quale associare l'Alias"
    answer_network=$(cat ${temp_input_utente_file} | sed s/@/_BUDUS_CHIOCCIOLA_/g)
    if [ "$(echo ${command} | grep "_VIRGOLETTA_.*_VIRGOLETTA_")" != "" ]; then
	answer_network=$(echo "${answer}" | sed s/\'/\'\\\\\\\\\'\'/g)
    fi
    rm -f ${temp_input_utente_file}
    
    # Verifica che per il Network inserito non sia gia' presente un
    # Alias. Se lo trova, invita l'utente ad eliminare l'Alias
    # corrente.
    if [ -f "${xdcc_network_alias_db}" ] && \
	[ "$(grep -iF " ${answer_network}  " "${xdcc_network_alias_db}")" != "" ]; then
	echo "/ECHO %C4,1Non puoi associare un Alias al Network %B${answer_network}%O%C4,1 perche' gia' ne possiede uno; devi eliminare quello corrente da %%BXDCC->Configurazione%%O se vuoi dargliene un altro."
    else
	if [ "${answer_network}" != "" ]; then
	    xterm -e ${script_path}/buduscript_script__multicommand.sh QUERY "Inserire il Nome dell'Alias da associare al Network ${answer_network}"
	    answer_alias=$(cat ${temp_input_utente_file} | sed s/@/_BUDUS_CHIOCCIOLA_/g)
	    if [ "$(echo ${command} | grep "_VIRGOLETTA_.*_VIRGOLETTA_")" != "" ]; then
		answer_alias=$(echo "${answer}" | sed s/\'/\'\\\\\\\\\'\'/g)
	    fi
	    rm -f ${temp_input_utente_file}

	    if [ "${answer_alias}" != "" ]; then
		# Verifica se l'alias funziona.
		wget --spider --timeout=8 --tries=1 ${answer_alias}:6667 > /dev/null 2> /dev/null
		if [ $? == 0 ]; then
		    printf ' %s  %s\n' "${answer_network}" "${answer_alias}" >> "${xdcc_network_alias_db}"
		    printf '/MENU ADD "XDCC/Configurazione/Rimuovi un Network Alias/%s = %s" "budus macro xdcc DEL_NETWORK_ALIAS %s"\n' "${answer_network}" "${answer_alias}" "${answer_network}"
		    printf '/ECHO %%C3,1Network %%B%s%%O%%C3,1 associato all'\''Alias %%B%s%%O%%C3,1 .\n' "${answer_network}" "${answer_alias}"
		else
		    printf '/ECHO %%C4,1Network %%B%s%%O%%C4,1 non associato all'\''Alias %%B%s%%O%%C4,1: Impossibile risolverlo.\n' "${answer_network}" "${answer_alias}"
		fi
	    else
		echo "/ECHO %C4,1Non puoi associare un Alias nullo ad un Network."
	    fi
	else
	    echo "/ECHO %C4,1Non puoi associare un Alias ad un Network nullo."
	fi
    fi
    
    debug_print "<" 'ADD_NETWORK_ALIAS'
    exit 0;
fi

#####################################################################
#____________________________________________________________________
if [ "$(echo "${command}" | grep -i "^DEL_NETWORK_ALIAS")" != "" ]; then
    load_config
    
    debug_print "x" 'DEL_NETWORK_ALIAS'
    
    network_alias=${command}
    
    if [ -f "${xdcc_network_alias_db}" ] && \
	[ "$(grep -iF " ${network_alias}  " "${xdcc_network_alias_db}")" != "" ]; then
	xdcc_network_alias_db_temp=$(grep -ivF " ${network_alias}  " "${xdcc_network_alias_db}")
	echo "${xdcc_network_alias_db_temp}" > "${xdcc_network_alias_db}"
	printf '/MENU DEL "XDCC/Configurazione/Rimuovi un Network Alias/%s = %s"\n' "${answer_network}" "${answer_alias}"
    else
	echo "/ECHO %C4,1Si e' verificato un problema durante l'eliminazione dell'Alias al Network %B${network_alias}%O."
    fi
    
    debug_print "<" 'DEL_NETWORK_ALIAS'
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# Controllo: Verifica se deve gestire il Reflex ADD USER.
if [ "$(echo "${command}" | grep -i "^ADD_REFLEX_BOT")" != "" ]; then
    load_config
    
    debug_print "x" 'ADD_REFLEX_BOT'
    
    reflex_source_network_name=$(echo "${SUB_COMMAND}" | awk -F' ' '{print $1}')
    reflex_source_channel_name=$(echo "${SUB_COMMAND}" | awk -F' ' '{print $2}')
    reflex_source_user_name=$(echo "${SUB_COMMAND}" | awk -F' ' '{print $3}')
    
    if [ "${reflex_source_network_name}" == "" ] || \
	[ "${reflex_source_channel_name}" == "" ] || \
	[ "${reflex_source_user_name}" == "" ] ; then
	printf '/ECHO %%B%%C4,1ERRORE:\t%%O%%C4,1 Devi necessariamente selezionare l'\''utente i cui XDCC inviati saranno deviati.\n'
	
	debug_print "<" 'ADD_REFLEX_BOT'
	exit 1;
    fi
    
    printf '%s %s %s\n' "${reflex_source_network_name}" "${reflex_source_channel_name}" "${reflex_source_user_name}" > "${script_path}/budus_xdcc_reflex.dat"
    printf '/ECHO %%B%%C3,1[XDCC REFLEX]\t%%O Tutti i file XDCC provenienti da %%B%s%%O [%%B%s%%O:%%B%s%%O] potranno essere deviati; ora devi aggiungere almeno un utente verso il quale eseguire la deviazione.\n' "${reflex_source_user_name}" "${reflex_source_network_name}" "${reflex_source_channel_name}"
    
    debug_print "<" 'ADD_REFLEX_BOT'
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# Controllo: Verifica se deve gestire il Reflex ADD USER.
if [ "$(echo "${command}" | grep -i "^ADD_REFLEX_USER")" != "" ]; then
    load_config
    
    debug_print "x" 'ADD_REFLEX_USER'
    
    reflex_source_network_name=$(cat "${script_path}/budus_xdcc_reflex.dat" | awk -F' ' '{print $1}')
    reflex_source_channel_name=$(cat "${script_path}/budus_xdcc_reflex.dat" | awk -F' ' '{print $2}')
    reflex_source_user_name=$(cat "${script_path}/budus_xdcc_reflex.dat" | awk -F' ' '{print $3}')
    
    if [ "${reflex_source_network_name}" == "" ] || \
	[ "${reflex_source_channel_name}" == "" ] || \
	[ "${reflex_source_user_name}" == "" ] ; then
	printf '/ECHO %%B%%C4,1ERRORE:\t%%O%%C4,1 Devi necessariamente selezionare l'\''utente del quale deviare i file XDCC.\n'
	
	debug_print "<" 'ADD_REFLEX_USER'
	exit 1;
    fi
    
    reflex_destination_network_name=$(echo "${SUB_COMMAND}" | awk -F' ' '{print $1}')
    reflex_destination_channel_name=$(echo "${SUB_COMMAND}" | awk -F' ' '{print $2}')
    reflex_destination_user_name=$(echo "${SUB_COMMAND}" | awk -F' ' '{print $3}')
    
    if [ "${reflex_destination_network_name}" != "" ] && \
	[ "${reflex_destination_channel_name}" != "" ] && \
	[ "${reflex_destination_user_name}" != "" ] ; then
	
	add_menu_item_reflex "${reflex_source_user_name}" "${reflex_source_network_name}" "${reflex_source_channel_name}" "${reflex_destination_user_name}" "${reflex_destination_network_name}" "${reflex_destination_channel_name}"
    else
	printf '/ECHO %%B%%C4,1ERRORE:\t%%O Devi necessariamente selezionare un utente verso cui inviare tutti i file XDCC provenienti da %%B%s%%O [%%B%s%%O:%%B%s%%O].\n' "${reflex_source_user_name}" "${reflex_source_network_name}" "${reflex_source_channel_name}"
    fi
    
    debug_print "<" 'ADD_REFLEX_USER'
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# Controllo: Verifica se deve gestire il Reflex DEL USER.
if [ "$(echo "${command}" | grep -i "^DEL_REFLEX_USER")" != "" ]; then
    load_config
    
    debug_print "x" 'DEL_REFLEX_USER'
    
    reflex_code=$(echo "${SUB_COMMAND}" | awk -F' ' '{print $1}')
    
    if [ "${reflex_code:-ALL}" == "ALL" ]; then
	temp_reflex_list_db=$(cat "${temp_reflex_list}" | awk -F' ' '{print $1}')
	
	IFS_OLD=${IFS}
	IFS=$'\n'
	for reflex_code in ${temp_reflex_list_db}; do
	    del_menu_item_reflex
	done
	IFS=${IFS_OLD}
	
	printf '/event listh :BUDUS_XDCC_REFLEX: -\n'
    else
	del_menu_item_reflex
    fi
    
    debug_print "<" 'DEL_REFLEX_USER'
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# Controllo: Verifica se deve gestire l'eliminazione della CACHE.
if [ "$(echo "${command}" | grep -i "^DELETE_CACHE")" != "" ]; then
    load_config
    
    debug_print "x" 'DELETE_CACHE'
    
    IFS_OLD=${IFS}
    IFS=$'\n'
    for file in $(find /tmp -type f -iname 'budus_XDCC_db_*'); do
	rm -f "${file}"
	
	[ -f "${file}" ] && printf '/ECHO ERRORE GRAVE: Impossibile eliminare la Cache, probabile problema di permessi.\n' && exit 1
    done
    for file in $(find /tmp -type f -iname 'budus_XDCC_*.database'); do
	rm -f "${file}"
	
	[ -f "${file}" ] && printf '/ECHO ERRORE GRAVE: Impossibile eliminare la Cache, probabile problema di permessi.\n' && exit 1
    done
    
    [ -f "${search_engine_db}" ] && rm -f "${search_engine_db}"
    [ -f "${search_query}" ] && rm -f "${search_query}"
    [ -f "${search_string_tempfile}" ] && rm -f "${search_string_tempfile}"
    [ -f "${resolving_cache}" ] && rm -f "${resolving_cache}"
    [ -f "${temp_input_utente_file}" ] && rm -f "${temp_input_utente_file}"
    [ -f "${temp_reflex_list}" ] && rm -f "${temp_reflex_list}"
    [ -f "${temp_network_failed_db}" ] && rm -f "${temp_network_failed_db}"
    [ -f "${temp_stat_db}" ] && rm -f "${temp_stat_db}"
    [ -f "${db_default_path}last_result.dat" ] && rm -f "${db_default_path}last_result.dat"
    
    IFS=${IFS_OLD}
    
    printf '/ECHO [XDCC MANAGER]\t Cache degli XBSPSE eliminata.\n'
    
    debug_print "<" 'DELETE_CACHE'
    exit 0
fi    

#####################################################################
#____________________________________________________________________
# Controllo: Verifica se deve gestire l'eliminazione della Download
# Queue.
if [ "$(echo "${command}" | grep -i "^DELETE_QUEUE_STATUS")" != "" ]; then
    load_config
    
    debug_print "x" 'DELETE_QUEUE_STATUS'
    
    touch "${db_default_path}DELETE_QUEUE_STATUS"
    if [ -f "${db_default_path}DELETE_QUEUE_STATUS" ]; then
	printf '/ECHO [XDCC MANAGER]\t ATTENZIONE: La cancellazione dei Database utilizzati dalla Coda dei Download e'\'' stata prenotata e sara'\'' eseguita al prossimo avvio di XChat (o comunque al prossimo caricamento del menu XDCC).\n'
    else
	printf '/ECHO ERRORE GRAVE: Impossibile prenotare la pulizia dello Stato dei Download , probabile problema di permessi.\n' && exit 1
    fi
    
    debug_print "<" 'DELETE_QUEUE_STATUS'
    exit 0
fi    

#####################################################################
#____________________________________________________________________
# Controllo: Verifica se deve gestire la creazione dei database
# permanenti, in base alla variabile
# "CREA_DATABASE_PERMANENTI_AUTOMATICAMENTE_QUANDO_SONO_AWAY".
if [ "$(echo "${command}" | grep -i "^MAKE_DB_ENABLED_XBSPSE_LIST_PASSWORD")" != "" ]; then
    load_config
    
    away_status=${SUB_COMMAND:-0}
    pid_of_process=${PARAMETER_1:-0}
    check_XBSPSE=${PARAMETER_2:-0}
    
    if [ ${away_status} = 1 ] && \
	([ "${CREA_DATABASE_PERMANENTI_AUTOMATICAMENTE_QUANDO_SONO_AWAY:-N}" == "Y" ] || [ "${check_XBSPSE:-NONE}" == "FORCE" ]) && 
	([ ! -f "${flag_make_db_permanent}" ] || [ "${check_XBSPSE:-NONE}" == "FORCE" ]); then
	if [ ! -f "${search_query}" ]; then
	    touch "${search_query}"
	    if [ ! -f "${search_query}" ]; then
		printf '/ECHO [XDCC MANAGER]\t ATTENZIONE: Impossibile bloccare il Motore di Ricerca XBSPSE; probabile problema di permessi.\n'
		
		exit 1;
	    fi
	    
	    if [ "${check_XBSPSE:-NONE}" == "FORCE" ]; then
		printf '/ECHO [XDCC MANAGER]\t ATTENZIONE: E'\'' in corso la verifica degli XBSPSE; non chiudere la finestra di elaborazione (anzi, leggerne il contenuto, per verificare eventuali anomalie), ma attendere che si chiuda da sola prima di usare l'\''XDCC MANAGER.\n'
		
		echo "/EXEC xterm -e \"${script_path}/buduscript_script__test_xbspse.sh\" --do-not-remove-permanent-db --view-malformed-record --min-malformed-record-average 950 && rm -f \"${search_query}\" && sleep 120 &"
	    else
		printf '/ECHO [XDCC MANAGER]\t ATTENZIONE: E'\'' in corso la creazione dei database permanenti degli XBSPSE di tipo LIST/PASSWORD; non chiudere la finestra di elaborazione (limitarsi a ridurla ad icona), ma attendere che si chiuda da sola prima di usare l'\''XDCC MANAGER.\n'
		
		echo "/EXEC xterm -e \"${script_path}/buduscript_script__test_xbspse.sh\" --check-only-active-xbspse --do-not-ask-user --do-not-remove-permanent-db --skip-db-check --skip-web-xbspse && rm -f \"${search_query}\" &"
	    fi
	    
	    rm -f "${db_default_path}flag_make_db_permanent."*
	    printf 'DATABASE PERMANENTI XBSPSE CREATO IL %s' "$(date +%Y%m%d)" > "${flag_make_db_permanent}"
	else
	    printf '/ECHO %%C3,1%%B[XDCC MANAGER]\t %%C4,1ATTENZIONE: E'\'' in corso un'\''altra ricerca. Se non termina entro '"${TIMEOUT_RICERCA}"' secondi, usare il seguente comando per terminarla:\n'
	    printf '/ECHO %%B/EXEC rm -vf %s\n' "${search_query}"
	fi
    fi
    
    if [ "${check_XBSPSE:-NONE}" != "FORCE" ]; then
	printf '/budus if %s = $iPidOfProcess |/budus InsertCommandInQueueTimed(0) 3600 /budus cmd /budus macro xdcc MAKE_DB_ENABLED_XBSPSE_LIST_PASSWORD $sFlagAway $iPidOfProcess\n' "${pid_of_process}"
    fi
    
    exit 0;
fi    

#####################################################################
#____________________________________________________________________
# Controllo: Verifica se deve gestire l'eliminazione della CACHE.
if [ "$(echo "${command}" | grep -i "^VIEW_AVAILABLE_RESOURCE_ON_PERMANENT_DB")" != "" ]; then
    load_config
    
    printf 'Inserisci una chiave di ricerca (anche espressione regolare) per filtrare i\nrisultati (INVIO per nessuna): '
    read regexp
    
    printf '\nGENERAZIONE DEL DATABASE IN CORSO, ATTENDERE ...\n'
    
    date_code=$(date +%Y%m%d)
    permanent_db_list=$(ls /tmp/budus_XDCC_db_* | grep "\.${date_code}$")
    
    if [ "${permanent_db_list}" != "" ]; then
	if [ "${regexp}" == "" ]; then
	    if [ ${VISUALIZZA_DATABASE_PERMANENTI_IN_FORMATO_FILE_ELENCO:-N} == "Y" ]; then
		cat ${permanent_db_list} \
		    | awk -F'\t' '{print $2"\t"$3"\t"$4"\t"$5"\t"$7"\t"$6}' \
		    | sort \
		    | uniq \
		    > "/tmp/budus_XDCC_db_AVAILABLE_RESOURCE_ON_PERMANENT_DB.dat"
	    else
		cat ${permanent_db_list} \
		    | awk -F'\t' '{print $6}' \
		    | sed 's@\(^ *\| *$\)@@' \
		    | tr '.' ' ' \
		    | sort \
		    | uniq \
		    > "/tmp/budus_XDCC_db_AVAILABLE_RESOURCE_ON_PERMANENT_DB.dat"
	    fi
	else
	    regexp=$(echo "${regexp}" | sed 's@ @.*@g')
	    
	    if [ ${VISUALIZZA_DATABASE_PERMANENTI_IN_FORMATO_FILE_ELENCO:-N} == "Y" ]; then
		cat ${permanent_db_list} \
		    | awk -F'\t' '{print $2"\t"$3"\t"$4"\t"$5"\t"$7"\t"$6}' \
		    | grep -i "${regexp}" \
		    | sort \
		    | uniq \
		    > "/tmp/budus_XDCC_db_AVAILABLE_RESOURCE_ON_PERMANENT_DB.dat"
	    else
		cat ${permanent_db_list} \
		    | awk -F'\t' '{print $6}' \
		    | grep -i "${regexp}" \
		    | sed 's@\(^ *\| *$\)@@' \
		    | tr '.' ' ' \
		    | sort \
		    | uniq \
		    > "/tmp/budus_XDCC_db_AVAILABLE_RESOURCE_ON_PERMANENT_DB.dat"
	    fi
	fi
	
	if [ -f "/tmp/budus_XDCC_db_AVAILABLE_RESOURCE_ON_PERMANENT_DB.dat" ]; then
	    if [ ${UTILIZZA_UDA_DATA_COPY_COME_VISUALIZZATORE_ESTERNO:-N} == "Y" ]; then
		if [ "$(which /usr/local/bin/udc 2> /dev/null)" != "" ]; then
		    flag_use_udc=1
		    
		    /usr/local/bin/udc "/tmp/budus_XDCC_db_AVAILABLE_RESOURCE_ON_PERMANENT_DB.dat"
		elif [ "$(which udc 2> /dev/null)" != "" ]; then
		    flag_use_udc=1
		    
		    udc "/tmp/budus_XDCC_db_AVAILABLE_RESOURCE_ON_PERMANENT_DB.dat"
		else
		    printf 'ATTENZIONE: Il Visualizzatore Esterno UDA Data Copy non risulta installato, oppure, non si trova nel percorso di ricerca degli eseguibili; per installarlo, consultare: http://digilander.libero.it/udasoft/multiplatform.html\n'
		    printf 'PREMI INVIO' && read
		fi
	    fi
	    
	    if [ ${flag_use_udc:-0} == 0 ]; then
		permanent_db_size=$(cat "/tmp/budus_XDCC_db_AVAILABLE_RESOURCE_ON_PERMANENT_DB.dat" | wc -l)
		
		{
		    cat<<EOF
********************************************************************************
ELENCO DELLE RISORSE DISPONIBILI PRESENTI NEI DATABASE PERMANENTI DEGLI XBSPSE

Complessivamente sono presenti ${permanent_db_size} records.
********************************************************************************
Premi il tasto 'q' per uscire e usa i tasti freccia per spostarti su e giu.

Premi il tasto '/' , seguito da una espressione regolare, per eseguire ricerche;
e' case-sensitive e puoi cercare l'elemento successivo premendo 'n'.
********************************************************************************
EOF
		
		    cat "/tmp/budus_XDCC_db_AVAILABLE_RESOURCE_ON_PERMANENT_DB.dat"
		    
		    cat<<EOF
********************************************************************************
Premi il tasto 'q' per uscire e usa i tasti freccia per spostarti su e giu.
********************************************************************************
EOF
		} | less
	    fi
	else
	    printf 'ATTENZIONE: I Database Permanenti individuati sono probabilmente vuoti o malformati (sarebbe opportuno eseguire una verifica degli XBSPSE installati).\n'
	    printf 'PREMI INVIO' && read
	fi
    else
	printf 'ATTENZIONE: Non risultano presenti Database Permanenti (sarebbe opportuno eseguire preventivamente una verifica degli XBSPSE installati).\n'
	printf '\nPREMI INVIO\n' && read
    fi

    exit 0
fi

#####################################################################
#____________________________________________________________________
# Controllo: Verifica se deve gestire l'eliminazione della CACHE.
if [ "$(echo "${command}" | grep -i "^MAKE_DB_AVAILABLE_RESOURCE")" != "" ]; then
    load_config
    
    IFS_OLD=${IFS}
    IFS=$'\n'
    
    available_db_list=$(find /tmp -iname "budus_XDCC_db_*.$(date +%Y%m%d)" 2> /dev/null)
    if [ "${available_db_list}" != "" ]; then
	if [ ! -d "${HOME}/.xchat2/buduscript/tmp" ]; then
	    mkdir "${HOME}/.xchat2/buduscript/tmp"
	    if [ ! -d "${HOME}/.xchat2/buduscript/tmp" ]; then
		printf '/budus sendsess $focus_tab /ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O Impossibile creare la cartella dei file temporanei (%%B%s%%O).\n' "${HOME}/.xchat2/buduscript/tmp"
		[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
		
		exit 1;
	    fi
	fi
	printf '[XDCC MANAGER]\t Generazione del file HTML contenente il database delle risorse disponibili. Attendere ...\n'
	rm -f "${HOME}/.xchat2/buduscript/tmp/budus_xdcc_available_resource_db_"*
	rm -f "${HOME}/.xchat2/buduscript/tmp/budus_xdcc_available_resource_db_"*".html"
	
	{
	    for available_db in ${available_db_list}; do
		cat ${available_db}
	    done
	} | sort -t'	' -k 6 \
	    | awk -F'\t' '{print "<tr bgcolor=#BBBBBB><td>"$1"</td><td>"$2"</td><td>"$3"</td><td>"$4"</td><td align=right>"$5"</td><td>"$6"</td><td align=right>"$7"</td></tr>"}' \
	    | split --suffix-length=4 --numeric-suffixes --lines=1000 - "${HOME}/.xchat2/buduscript/tmp/budus_xdcc_available_resource_db_"

	echo 'Network	Server	Channel	BOT	ID	Filename	Size' \
	    | awk -F'\t' '{print $1"\t"$2"\t"$3"\t"$4"\t"$5"\t"$6"\t"$7}' > \
	    ${HOME}/budus_xdcc_available_resource_db.csv
	
	{
	    for available_db in ${available_db_list}; do
		cat ${available_db}
	    done
	} | sort -t'	' -k 6 \
	    | awk -F'\t' '{print $1"\t"$2"\t"$3"\t"$4"\t"$5"\t"$6"\t"$7}' >> \
	    ${HOME}/budus_xdcc_available_resource_db.csv
	
	max_item_number=$(ls "${HOME}/.xchat2/buduscript/tmp/budus_xdcc_available_resource_db_"* | grep -o '[0-9]\{4\}' | sort | tail -n1)
	
	for splitted_file in $(find "${HOME}/.xchat2/buduscript/tmp/" -name 'budus_xdcc_available_resource_db_*' 2> /dev/null); do
	    current_item_number=$(echo "${splitted_file}" | grep -o '[0-9]*$' | sed 's@^[0]\{1,3\}@@')
	    previous_item_number=$((${current_item_number} - 1))
	    [ ${previous_item_number} -lt 0 ] && previous_item_number=0
	    forward_item_number=$((${current_item_number} + 1))
	    
	    max_item_number_int=$(echo "${max_item_number}" | sed 's@^[0]\{1,3\}@@')
	    page_step=$((${max_item_number_int} / 10))
	    ten_previous_item_number=$((${previous_item_number} - ${page_step:-2}))
	    ten_forward_item_number=$((${forward_item_number} + ${page_step:-2}))
	    
	    [ ${ten_previous_item_number} -lt 0 ] && ten_previous_item_number=0
	    [ ${ten_forward_item_number} -gt ${max_item_number_int} ] && ten_forward_item_number=${max_item_number_int}
	    
	    current_item_number=$(printf '%04d\n' ${current_item_number})
	    previous_item_number=$(printf '%04d\n' ${previous_item_number})
	    forward_item_number=$(printf '%04d\n' ${forward_item_number})
	    
	    ten_previous_item_number=$(printf '%04d\n' ${ten_previous_item_number})
	    ten_forward_item_number=$(printf '%04d\n' ${ten_forward_item_number})
	    
	    [ ! -f "${HOME}/.xchat2/buduscript/tmp/budus_xdcc_available_resource_db_${forward_item_number}" ] && \
		forward_item_number=${current_item_number}
	    
	    {
		cat<<EOF
<!DOCTYPE html>
<html dir="ltr" lang="it-IT">
 <head>
  <meta charset="UTF-8" />
  <title>BuDuScRiPt XDCC Database</title>
 </head>
 <body>
  <center>
   <table cellspacing=2 cellpadding=2>
    <tr>
     <td>
      <a href="file://${HOME}/.xchat2/buduscript/tmp/budus_xdcc_available_resource_db_${ten_previous_item_number}.html">&lt;&lt;&lt;=</a>
     </td>
     <td>
      <a href="file://${HOME}/.xchat2/buduscript/tmp/budus_xdcc_available_resource_db_${previous_item_number}.html">&lt;= BACKWARD</a>
     </td>
     <td>
      <a name="GO_TO_BEGIN"></a>
      ::[ <a href="file://${HOME}/.xchat2/buduscript/tmp/budus_xdcc_available_resource_db_0001.html">0001</a> / ${current_item_number} : <a href="#GO_TO_END">VAI ALLA FINE</a> / <a href="file://${HOME}/.xchat2/buduscript/tmp/budus_xdcc_available_resource_db_${max_item_number}.html">${max_item_number}</a> ]:: 
     </td>
     <td>
      <a href="file://${HOME}/.xchat2/buduscript/tmp/budus_xdcc_available_resource_db_${forward_item_number}.html">FORWARD =&gt;</a>
     </td>
     <td>
      <a href="file://${HOME}/.xchat2/buduscript/tmp/budus_xdcc_available_resource_db_${ten_forward_item_number}.html">=&gt;&gt;&gt;</a>
     </td>
    </tr>
   </table>
  </center>
  <font size=2>
   <table bgcolor=#777777 width=100%>
    <tr>
     <td>
      <table bgcolor=#666666 cellpadding=2 cellspacing=1 width=100%>
       <tr bgcolor=#AAAAAA><b><td>Network</td><td>Server</td><td>Channel</td><td>BOT</td><td>ID</td><td>Filename</td><td>Size</td></b></tr>
EOF
		
		cat "${splitted_file}"
		
		cat<<EOF
      </table>
     </td>
    </tr>
   </table>
  </font>
  <center>
   <table cellspacing=2 cellpadding=2>
    <tr>
     <td>
      <a href="file://${HOME}/.xchat2/buduscript/tmp/budus_xdcc_available_resource_db_${ten_previous_item_number}.html">&lt;&lt;&lt;=</a>
     </td>
     <td>
      <a href="file://${HOME}/.xchat2/buduscript/tmp/budus_xdcc_available_resource_db_${previous_item_number}.html">&lt;= BACKWARD</a>
     </td>
     <td>
      <a name="GO_TO_END"></a>
      ::[ <a href="file://${HOME}/.xchat2/buduscript/tmp/budus_xdcc_available_resource_db_0001.html">0001</a> / ${current_item_number} : <a href="#GO_TO_BEGIN">VAI ALL'INIZIO</a> / <a href="file://${HOME}/.xchat2/buduscript/tmp/budus_xdcc_available_resource_db_${max_item_number}.html">${max_item_number}</a> ]:: 
     </td>
     <td>
      <a href="file://${HOME}/.xchat2/buduscript/tmp/budus_xdcc_available_resource_db_${forward_item_number}.html">FORWARD =&gt;</a>
     </td>
     <td>
      <a href="file://${HOME}/.xchat2/buduscript/tmp/budus_xdcc_available_resource_db_${ten_forward_item_number}.html">=&gt;&gt;&gt;</a>
     </td>
    </tr>
   </table>
  </center>
 </body>
</html>
EOF
		# OUTPUT
	    } > "${HOME}/.xchat2/buduscript/tmp/budus_xdcc_available_resource_db_${current_item_number}.html"
	    
	    rm -f "${splitted_file}"
	done
	
	if [ ! -f "${HOME}/.xchat2/buduscript/tmp/budus_xdcc_available_resource_db_0000.html" ]; then
	    printf '[XDCC MANAGER]\t Si e'\'' verificato un problema nella creazione del file html.\n'
	    
	    exit 1;
	fi
	
	printf '[XDCC MANAGER]\t Puoi aprire il database con un Browser qui: file://%s\n' "${HOME}/.xchat2/buduscript/tmp/budus_xdcc_available_resource_db_0000.html"
	
	printf '[XDCC MANAGER]\t Puoi anche manipolare il database con un programma Office, importando il file "%s" (formato: Testo CSV) e usando il solo carattere di tabulazione come separatore campi.\n' "${HOME}/budus_xdcc_available_resource_db.csv"
	
	printf '[XDCC MANAGER]\t Cerco di aprire il Database creato con il Browser WEB impostato di default.\n' && \
	    exec xdg-open "file://${HOME}/.xchat2/buduscript/tmp/budus_xdcc_available_resource_db_0000.html"
    else
	printf '[XDCC MANAGER]\t ATTENZIONE: Per creare il database delle risorse disponibili deve essere attivo almeno un plugin di ricerca che si affida ad una lista specifica (dedicata ad un particolare canale) e non un generico Web XDCC Search Engine.\n'
	printf '[XDCC MANAGER]\t Non ho trovato un database aggiornato, provo ad aggiornarlo in automatico (attendere almeno %d secondi e non chiudere la finestra di elaborazione).\n' "${TIMEOUT_RICERCA}"
	
	xterm -e ${0} NULL NULL NULL FORK_PROCESS ${RANDOM_NUMBER} && \
	    rm -f ${search_query}.exit && \
	    [ "$(find /tmp -iname "budus_XDCC_db_*.$(date +%Y%m%d)" 2> /dev/null)" != "" ] && \
	    ${script_path}/budus_xdcc.sh NULL NULL NULL MAKE_DB_AVAILABLE_RESOURCE || \
	    printf '[XDCC MANAGER]\t ATTENZIONE: Nessuno dei plugin abilitati genera un database permanente.\n'
    fi
    
    IFS=${IFS_OLD}
    
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# Controllo: Installazione di XBSPSE provenienti da terzi.
if [ "$(echo "${command}" | grep -i "^INSTALL_EXTERNAL_XBSPSE")" != "" ]; then
    load_config

    XBSPSE_package_url=${SUB_COMMAND:-NULL}

    # Gestione dei parametri
    case ${SUB_COMMAND:-START} in
	"START")
	    cat<<EOF | sed 's@^@/ECHO @g'
********************************************************************************
 Questa procedura consente di installare un pacchetto di XBSPSE prodotti e
gestiti da terzi (cioe' non da UDA'Software).

ATTENZIONE: %C4,1%BE' UN'OPERAZIONE POTENZIALMENTE MOLTO PERICOLOSA PERCHE', SE LA
            %C4,1%BFONTE NON E' ATTENDIBILE, SI ESPONE IL PROPRIO SISTEMA
            %C4,1%BALL'INSTALLAZIONE ED ESECUZIONE DI SOFTWARE CHE VERRA' ESEGUITO CON
            %C4,1%BI PRIVILEGI DELL'ATTUALE UTENTE.

            %C4,1%BSI SOTTOLINEA COME UDA'SOFTWARE NON ESEGUA NESSUN CONTROLLO SUL
            %C4,1%BMATERIALE INSTALLATO CON QUESTA MODALITA'; BISOGNA ESSERE
            %C4,1%BCONSAPEVOLI CHE LO SI FA A PROPRIO RISCHIO E PERICOLO.

 Verra' aperta una finestra nella quale bisogna inserire un indirizzo URL che
fa riferimento al pacchetto contenente gli XBSPSE aggiuntivi; al termine
dell'operazione, viene eseguita una procedura automatica, realizzata da chi ha
realizzato il pacchetto, quindi, viene aggiornato il menu XDCC.

 Sara' quindi opportuno verificare se e' necessario abilitare nuovi XBSPSE,
tramite il menu XDCC.

 Prima di eseguire l'installazione viene eseguito un backup della cartella XChat
in modo che sia possibile ripristinare la situazione precedente (e' comunque
possibile rimuovere il pacchetto installato tramite apposito comando di menu).

********************************************************************************
Tra qualche istante verra' chiesto l'URL del pacchetto XBSPSE da installare ....
EOF
	    
	    # RICHIEDE l'URL
	    cat<<EOF
/budus InsertCommandInQueueTimed(0) 20 /budus macro buduscript_macro__getstr_quadri "http://" budus macro xdcc INSTALL_EXTERNAL_XBSPSE Inserire URL paccheto XBSPSE
EOF
	    ;;
	*)
	    printf '/ECHO [EXTERNAL XBSPSE]\t  * Installazione di %s\n' "${XBSPSE_package_url}"
	    
	    printf '/ECHO [EXTERNAL XBSPSE]\t  * Backup della cartella %s\n' "${HOME}/.xchat2"
	    tar czf ${HOME}/buduscript_update_backup_$(date +%Y%m%d%H%M%S).tar.gz ${HOME}/.xchat2 2>&1 | sed 's@^@/ECHO @'
	    
	    printf '/ECHO [EXTERNAL XBSPSE]\t  * Download di %s\n' "${XBSPSE_package_url}"
	    cd "${HOME}/.xchat2/buduscript/tmp"
	    wget --user-agent 'BuDuScRiPt plugin' --timeout 16 -t 1 "${XBSPSE_package_url}" 2>&1 | sed 's@^@/ECHO @'
	    
	    package_filename=$(basename "${XBSPSE_package_url}")	    
	    printf '/ECHO [EXTERNAL XBSPSE]\t  * Verifica di %s\n' "${package_filename}"
	    if [ ! -f "${package_filename}" ]; then
		printf '/ECHO [EXTERNAL XBSPSE]\t  * ERRORE: Pacchetto %s non trovato; problema di download.\n' "${package_filename}"
		
		exit 1;
	    else
		package_name="$(echo "${package_filename}" | sed 's@.tar.gz$@@')"
		
		[ -d "${HOME}/.xchat2/buduscript/${package_name}" ] && \
		    rm -fr "${HOME}/.xchat2/buduscript/${package_name}" && \
		    printf '/ECHO [EXTERNAL XBSPSE]\t  * Eliminazione cartella di installazione vecchia: %s\n' "${package_name}"
		
		[ ! -d "${HOME}/.xchat2/buduscript/${package_name}" ] && \
		    mkdir "${HOME}/.xchat2/buduscript/${package_name}" && \
		    printf '/ECHO [EXTERNAL XBSPSE]\t  * Creazione cartella di installazione: %s\n' "${package_name}" || \
		    printf '/ECHO [EXTERNAL XBSPSE]\t  ! Cartella di installazione occupata, probabile problema di permessi.\n'
		
		printf '/ECHO [EXTERNAL XBSPSE]\t  * Estrazione di %s\n' "${package_filename}"
		tar xvzf "${package_filename}" -C "${HOME}/.xchat2/buduscript/${package_name}" > /dev/null 2>&1 | sed 's@^@/ECHO @'
		
		printf '/ECHO [EXTERNAL XBSPSE]\t  * Eliminazione di %s\n' "${package_filename}"
		rm "${package_filename}" 2>&1 | sed 's@^@/ECHO @'
		
		printf '/ECHO [EXTERNAL XBSPSE]\t  * Verifica XBSPSE installati.\n'
		delete_xbspse_unlinked
		
		printf '/ECHO [EXTERNAL XBSPSE]\t  * Installazione degli XBSPSE nuovi:\n'
		cd "${HOME}/.xchat2/buduscript/${package_name}/"
		for xbspse in $(ls "budus_xdcc_plugin_"*".sh"); do
		    printf '/ECHO [EXTERNAL XBSPSE]\t  \_%%B %64s\n' "$(echo "${xbspse}" | sed 's@.*budus_xdcc_plugin_@@' | cut -f1 -d'.')"
		    xbspse_lowercase="$(echo "${xbspse}" | tr [:upper:] [:lower:])"
		    if [ ! -f "${HOME}/.xchat2/buduscript/${xbspse_lowercase}" ]; then
			ln -s "${HOME}/.xchat2/buduscript/${package_name}/${xbspse}" "${HOME}/.xchat2/buduscript/${xbspse_lowercase}"
		    else
			printf '/ECHO [EXTERNAL XBSPSE]\t    \_ %%BATTENZIONE:%%C7,1 Il plugin risulta gia'\'' installato.\n'
		    fi
		done
		
		package_init_script="${HOME}/.xchat2/buduscript/${package_name}/${package_name}_init.sh"
		
		printf '/ECHO [EXTERNAL XBSPSE]\t  * Verifica di %s\n' "${package_init_script}"
		if [ ! -f "${package_init_script}" ]; then
		    [ -d "${HOME}/.xchat2/buduscript/${package_name}" ] && \
			rm -fr "${HOME}/.xchat2/buduscript/${package_name}" && \
			printf '/ECHO [EXTERNAL XBSPSE]\t  * Eliminazione cartella di installazione: %s\n' "${package_name}"
		    
		    printf '/ECHO [EXTERNAL XBSPSE]\t  * Verifica XBSPSE installati.\n'
		    delete_xbspse_unlinked
		    
		    printf '/ECHO [EXTERNAL XBSPSE]\t  ! ERRORE: Pacchetto %s malformato; non contiene script di inizializzazione, disinstallato in automatico.\n' "${package_name}"
		    
		    exit 1;
		else
		    printf '/ECHO [EXTERNAL XBSPSE]\t  * Esecuzione di %s .\n' "${package_name}"
		    cd "${HOME}/.xchat2/buduscript/tmp"
		    "${package_init_script}"
		    if [ $? != 0 ]; then
			[ -d "${HOME}/.xchat2/buduscript/${package_name}" ] && \
			    rm -fr "${HOME}/.xchat2/buduscript/${package_name}" && \
			    printf '/ECHO [EXTERNAL XBSPSE]\t  * Eliminazione cartella di installazione: %s\n' "${package_name}"
			
			printf '/ECHO [EXTERNAL XBSPSE]\t  * Verifica XBSPSE installati.\n'
			delete_xbspse_unlinked
			
			printf '/ECHO [EXTERNAL XBSPSE]\t  ! ERRORE: Installazione fallita.\n'
		    else
			printf '/ECHO [EXTERNAL XBSPSE]\t  * Ricarica menu XBSPSE disponibili.\n'
			cat<<EOF
/budus macro xdcc MENU_RELOAD_XBSPSE
EOF
		    fi
		fi
	    fi
	    
	    printf '/ECHO [EXTERNAL XBSPSE]\t  * Installazione terminata.\n'
	    ;;
    esac
    
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# Controllo: Verifica se deve gestire il comando che elenca l'ultima
# ricerca effettuata.
if [ "$(echo "${command}" | grep -i "^VIEW_LAST_SEARCH")" != "" ]; then
    load_config
    
    debug_print "x" 'VIEW_LAST_SEARCH'
    
    if [ ! -f "${search_engine_db}" ]; then
	last_search_engine_db=$(grep -l '^[0-9]*	' "${db_default_path}_"*".dat" | tail -n1)
	if [ -f "${last_search_engine_db}" ]; then
	    printf '/ECHO Recupero la ricerca piu'\'' recente relativa all'\''utente %s con PID %d .\n' "${user_home/_home_/}" "${XChat_PID}"
	    
	    mv -f "${last_search_engine_db}" "${search_engine_db}"
	fi
    fi
    
    if [ ! -f "${search_engine_db}" ]; then
	[ "${RANDOM_NUMBER:-X}" == "CHECK" ] && echo "* CHECK: Database non trovato."
	echo "/ECHO %C4,1Non risulta presente nessuna ricerca precedente (o comunque l'ultima non ha dato esito)."
	echo "/ECHO %C3,1Per procedere al download devi prima effettuare una ricerca, individuare l'%BID%O%C3,1 (il primo valore numerico che si presenta per ogni risultato) ed utilizzare la sintassi:"
	printf "/ECHO Esempio:\t%%C9,1/budus macro xdcc d ID\n"
	
	debug_print "<" 'VIEW_LAST_SEARCH'
	
	exit 1;
    fi
    
    if [ "$(echo "${NUMERO_MASSIMO_DI_RISULTATI}" | grep '^[0-9]*$')" == "" ]; then
	NUMERO_MASSIMO_DI_RISULTATI=100
    elif [ ${NUMERO_MASSIMO_DI_RISULTATI} -le 1 ]; then
	NUMERO_MASSIMO_DI_RISULTATI=100
    fi
    
    mv "${search_engine_db}" "${search_engine_db}.rotate"
    if [ ! -f "${search_engine_db}.rotate" ]; then
	printf '/ECHO [XDCC MANAGER]\t ERRORE NELLA ROTAZIONE DEI RISULTATI.\n'
    else
	search_engine_db_line=$(cat "${search_engine_db}.rotate" | wc -l)
	if [ ${search_engine_db_line:-0} -gt ${NUMERO_MASSIMO_DI_RISULTATI:-100} ]; then
	    search_engine_db_line_last=$((${search_engine_db_line:-0} - ${NUMERO_MASSIMO_DI_RISULTATI:-100}))
	    tail -n ${search_engine_db_line_last:-1} "${search_engine_db}.rotate" > "${search_engine_db}"
	    head -n ${NUMERO_MASSIMO_DI_RISULTATI:-100} "${search_engine_db}.rotate" >> "${search_engine_db}"
	    
	    rm -f "${search_engine_db}.rotate"
	    
	    printf '/ECHO [XDCC MANAGER]\t I risultati visualizzati (%d) superano quelli totali (%d) e sono stati "ruotati" per mostrare i successivi (%d).\n' ${NUMERO_MASSIMO_DI_RISULTATI:-100} ${search_engine_db_line:-0} ${search_engine_db_line_last:-0}
	else
	    mv "${search_engine_db}.rotate" "${search_engine_db}"
	fi
    fi
    
    IFS_OLD=${IFS}
    IFS=$'\n'
    item_printed=1
    for item in $(head -n ${NUMERO_MASSIMO_DI_RISULTATI:-100} "${search_engine_db}"); do
	item_number=$(echo "${item}" | awk -F'\t' '{print $1}')
	item_network=$(echo "${item}" | awk -F'\t' '{print $2}')
	item_network_cut=$(echo "${item_network}" | cut -b-16)
	item_channel=$(echo "${item}" | awk -F'\t' '{print $3}')
	item_channel_cut=$(echo "${item_channel}" | cut -b-16)
	item_botname=$(echo "${item}" | awk -F'\t' '{print $4}')
	item_botname_cut=$(echo "${item_botname}" | cut -b-16)
	item_filename=$(echo "${item}" | awk -F'\t' '{print $5}')
	item_size=$(echo "${item}" | awk -F'\t' '{print $6}')
	item_command=$(echo "${item}" | awk -F'\t' '{print $7}')
	if [ "${item_command}" == "UNKNOWN" ] || [ "${item_command}" == "" ]; then
	    item_command="/msg ${item_botname} xdcc send #${item_ID}"
	fi
	
	if [ "${ELENCA_RISULTATI_SENZA_FORMATTAZIONE}" == "N" ]; then
	    printf "/ECHO [%%B %s%%O ]\t%%C3,1%%B%3d) %%C4,1 %16s%%C5,1 %16s%%C6,1 %16s%%C7,1 %6s%%C8,1 %s%%O\n"  "http://xdcc_${item_number}" ${item_number} "${item_network_cut}" "${item_channel_cut}" "${item_botname_cut}" "${item_size}" "${item_filename}"
	else
	    printf "/ECHO [%%B %s%%O ]\t%%C3,1%%B%3d) %%C4,1 %16s%%C5,1 %16s%%C6,1 %16s%%C7,1 %6s%%C8,1 %s%%O\n"  "http://xdcc_${item_number}" ${item_number} "${item_network}" "${item_channel}" "${item_botname}" "${item_size}" "${item_filename}"
	fi
	
	if [ ${item_printed} == ${NUMERO_MASSIMO_DI_RISULTATI} ]; then
	    echo "/ECHO %C4,1ATTENZIONE: Numero massimo di risultati (${NUMERO_MASSIMO_DI_RISULTATI}/${search_engine_db_line:-ERROR}) visualizzabili raggiunto."
	fi
	
	item_printed=$((${item_printed} + 1))
    done
    IFS=${IFS_OLD}
    
    debug_print "<" 'VIEW_LAST_SEARCH'
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# Controllo: Verifica se deve eseguire una ricerca.
if [ "$(echo "${command}" | grep -i "^[sS]$")" != "" ]; then
    load_config
    
    debug_print "x" 'SEARCH'
    
    parameters="$(echo "${parameters}" | sed 's@[^a-zA-Z 0-9]@ @g')"
    if [ "${parameters}" == "" ]; then
	echo "/ECHO %C4,1Sintassi errata, manca il parametro."
	print_help
	
	debug_print "<" 'SEARCH'
	exit 1;
    fi
    
    if [ -f "${search_query}" ]; then
	printf '/ECHO %%C3,1%%B[XDCC MANAGER]\t %%C4,1ATTENZIONE: E'\'' in corso un'\''altra ricerca. Se non termina entro '"${TIMEOUT_RICERCA}"' secondi, usare il seguente comando per terminarla:\n'
	printf '/ECHO %%B/EXEC rm -vf %s\n' "${search_query}"
	
	debug_print "<" 'SEARCH'
	exit 1;
    fi

    printf '/budus seth_internal buduscript_script__xdcc_keywords %s\n' "${parameters}"
    debug_print "*" "SEARCH - parameters = ${parameters}"
    
    add_item_to_db "${search_pattern_db}" "${parameters}"
    cat<<EOF
/MENU ADD "XDCC/Ripeti Ricerca/${parameters}" "budus macro xdcc s ${parameters}"
EOF
    
    active_plugin_list=$(find "${script_path}" -maxdepth 1 -iname 'budus_xdcc_plugin_*.sh')
    flag_active_plugin_list=0
    for plugin in ${active_plugin_list}; do
	check_plugin SKIP_TYPE
	if [ ${flag_check_plugin} == 1 ] && [ -f ${plugin%.sh} ]; then
	    flag_active_plugin_list=1
	fi
    done
    if [ ${flag_active_plugin_list} == 1 ]; then
	RANDOM_NUMBER=${RANDOM}
	printf '%s\n' "${parameters}" > "${search_string_tempfile}"
	if [ ${database:-X} != CHECK ]; then
	    echo "/EXEC xterm -e ${0} \"${database}\" \"${dcc_database}\" \"${server}\" FORK_PROCESS ${RANDOM_NUMBER}"
	    
	    echo "/TIMER -refnum 2255 8 budus pipe_script_silent ${0} \"${database}\" \"${dcc_database}\" \"${server}\" FORK_CHECK 0"
	else
	    ${0} "${database}" "${dcc_database}" "${server}" FORK_PROCESS ${RANDOM_NUMBER}
	    
	    ${0} "${database}" "${dcc_database}" "${server}" FORK_CHECK 0
	fi
    else
	echo "/ECHO %C8,1%BATTENZIONE:%O%C9,1%B Non e' attivo nessun plugin di ricerca. E' necessario attivarne almeno uno conforme allo standard ${standard_version} .%C3,1 Vedi menu:%C5,1 XDCC/Gestione Motori di Ricerca"
    fi
    
    debug_print "<" 'SEARCH'
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# [DOWNLOAD]
# Controllo: Verifica se deve eseguire un Download.
if [ "$(echo "${command}" | grep -i "^[dD]$")" != "" ]; then
    load_config
    
    debug_print "x" 'DOWNLOAD'
    
    PARAMETER_1="$(echo "${SUB_COMMAND}" | grep -oF 'BUDUS_QUEUE_MANUAL')"
    ID=$(printf '%s\n' "${SUB_COMMAND}" | sed 's@ BUDUS_QUEUE_MANUAL@@' | grep '^[0-9]*$')
    
    debug_print "*" "ID = ${ID} / PARAMETER_1 = ${PARAMETER_1}"
    
    if [ "${ID}" != "" ]; then
	if [ "${PARAMETER_1}" != "BUDUS_QUEUE_MANUAL" ]; then
	    printf '/ECHO %%B%%C5,1[XDCC MANAGER]\t DOWNLOAD:%%O ID %%B%s%%O in stato di elaborazione.\n' "${ID:-INTERNAL_ERROR}"
	    
	    list_item_in_db "${transfer_db}" "TRASFERIMENTO"
	    list_item_in_db "${request_db}" "RICHIESTA"
	    list_item_in_db "${waiting_db}" "ELABORAZIONE"
	    list_item_in_db "${download_queue_db}" "CODA"
	fi
	
	if [ -f "${search_engine_db}" ]; then
	    item_code="X$(date +%s)"
	    
	    debug_print "*" "item_code = ${item_code}"
	    
	    item_from_db=$(cat "${search_engine_db}" | grep "^${ID}	")
	    
	    if [ "${item_from_db}" != "" ]; then
		ITEM="	${item_code}	${item_from_db}"
		
		flag_static_find_item_in_db=0
		find_item_in_db "${download_queue_db}" "	${item_from_db}" "NO_ERROR"
		
		debug_print "*" "flag_static_find_item_in_db = ${flag_static_find_item_in_db}"
		
		if [ ${flag_static_find_item_in_db:-0} == 0 ]; then
		    find_item_in_db "${waiting_db}" "	${item_from_db}" "NO_ERROR"
		    [ "${find_item_in_db_result}" != "" ] && \
			item_code_err=$(echo "${find_item_in_db_result}" | tail -n1 | awk '{print $1}')
		    
		    find_item_in_db "${request_db}" "	${item_from_db}" "NO_ERROR"
		    [ "${find_item_in_db_result}" != "" ] && \
			item_code_err=$(echo "${find_item_in_db_result}" | tail -n1 | awk '{print $1}')
		    
		    find_item_in_db "${transfer_db}" "	${item_from_db}" "NO_ERROR"
		    [ "${find_item_in_db_result}" != "" ] && \
			item_code_err=$(echo "${find_item_in_db_result}" | tail -n1 | awk '{print $1}')
		    
		    if [ ${flag_static_find_item_in_db:-0} == 0 ]; then
			add_item_to_db "${download_queue_db}" "${ITEM}"
			add_item_to_menu "QUEUE"
			
			get_data_from_item
			printf '/ECHO %%B%%C11,1[XDCC MANAGER]\t %13s:%%O %%C3%%B%s%%O => %%C7%%B%s%%O [%%C4%%B%s%%O:%%C5%%B%s%%O:%%C6%%B%s%%O].\n' "CODA" "${item_code}" "${item_filename}" "${item_network}" "${item_channel}" "${item_botserv}"
			
			check_download_queue
		    else
			printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O ID (%%B%s%%O) in stato di attivita'\''.\n' "${ID:-INTERNAL_ERROR}"
			[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
			printf '/ECHO %%B%%C3,1[XDCC MANAGER]\t SUGGERIMENTO:%%O Tramite il menu%%B XDCC%%O verificare lo stato di avanzamento dell'\''ITEM con codice%%B %s%%O .\n' "${item_code_err:-INTERNAL_ERROR}"
		    fi
		else
		    item_code_err=$(echo "${find_item_in_db_result}" | tail -n1 | awk '{print $1}')
		    
		    printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O ID (%%B%s%%O) gia'\'' presente nella Coda dei Download.\n' "${ID:-INTERNAL_ERROR}"
		    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
		    printf '/ECHO %%B%%C3,1[XDCC MANAGER]\t SUGGERIMENTO:%%O Tramite il menu%%B XDCC%%O verificare lo stato di avanzamento dell'\''ITEM con codice%%B %s%%O .\n' "${item_code_err:-INTERNAL_ERROR}"
		fi
	    else
		max_ID=$(cat "${search_engine_db}" | tail -n1 | awk '{print $1}')
		
		printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O ID inserito (%%B%s%%O) non valido.\n' "${ID:-INTERNAL_ERROR}"
		[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
		printf '/ECHO %%B%%C3,1[XDCC MANAGER]\t SUGGERIMENTO:%%O Devi inserire un numero che sia compreso tra%%B 1%%O e %%B %s%%O, compresi, come valore di ID .\n' "${max_ID:-INTERNAL_ERROR}"
		printf '/ECHO %%B%%C6,1[XDCC MANAGER]\t ESEMPIO:%%O /budus macro xdcc d %s\n' "${max_ID:-INTERNAL_ERROR}"
	    fi
	else
	    printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O Database non trovato.\n'
	    printf '/ECHO %%B%%C3,1[XDCC MANAGER]\t SUGGERIMENTO:%%O Devi eseguire una ricerca, vedi menu: %%BXDCC -> Cerca... .\n'
	fi
    else
	item_code=$(printf '%s\n' "${SUB_COMMAND/ -/}" | grep '^[XT][0-9]\{10\}$')
	
	if [ "${item_code}" != "" ]; then
	    current_db="${repeat_db}"
	    
	    flag_static_find_item_in_db=0
	    find_item_in_db_by_code "${current_db}" "${item_code}" "NO_ERROR"
	    
	    if [ ${flag_static_find_item_in_db:-0} == 0 ]; then
		current_db="${failed_db}"
		find_item_in_db_by_code "${failed_db}" "${item_code}" "NO_ERROR"
	    fi
	    
	    if [ ${flag_static_find_item_in_db:-0} == 1 ]; then
		ITEM="${find_item_in_db_result}"
		ITEM=$(echo "${ITEM}" | sed 's@^	T@	X@')
		
		remove_item_from_db "${current_db}" "${ITEM}"
		remove_item_from_menu "REPEAT" "${ITEM}"
		add_item_to_db "${download_queue_db}" "${ITEM}"
		add_item_to_menu "QUEUE"
		
		get_data_from_item
		printf '/ECHO %%B%%C11,1[XDCC MANAGER]\t %13s:%%O %%C3%%B%s%%O => %%C7%%B%s%%O [%%C4%%B%s%%O:%%C5%%B%s%%O:%%C6%%B%s%%O].\n' "CODA" "${item_code}" "${item_filename}" "${item_network}" "${item_channel}" "${item_botserv}"
		
		check_download_queue
	    else
		printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O ID%%B %s%%O non valido, probabilmente scaduto.\n' "${item_code}"
		[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
	    fi
	else
	    printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O ID non valido, deve essere numerico.\n'
	    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
	fi
    fi
    
    debug_print "<" 'DOWNLOAD'
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# [DOWNLOAD MANUALE]
# Controllo: Verifica se deve eseguire un Download.
if [ "${command}" == "MANUAL_DOWNLOAD" ]; then
    load_config
    
    debug_print "x" 'MANUAL DOWNLOAD'
    
    if [ "${PARAMETER_3}" == "" ]; then
	filelist_path="${PARAMETER_2}"
	
	debug_print "*" "filelist_path = $filelist_path"
	
	printf '/budus macro xdcc DOWNLOAD_MANAGER FILELIST_DOWNLOAD %s\n' "${filelist_path}"
    else
	item_ID=1
	
	if [ "${PARAMETER_5}" == "" ]; then
	    item_network="${server}"
	    item_channel="${SUB_COMMAND}"
	    item_botserv="${PARAMETER_2}"
	    item_command="${PARAMETER_3}"
	    item_filename="${PARAMETER_4}"
	else
	    item_network="${PARAMETER_2}"
	    item_channel="${PARAMETER_3}"
	    item_botserv="${PARAMETER_4}"
	    item_command="${PARAMETER_5}"
	    item_filename="${PARAMETER_6}"
	fi
	
	debug_print "*" "item_network = $item_network / item_channel = $item_channel / item_botserv = $item_botserv / item_command = $item_command / item_filename = $item_filename"
	
	line="network = $item_network / channel = $item_channel / botserv = $item_botserv / ID = $item_command / filename = $item_filename"
	make_search_db_from_parameters

	debug_print "*" "flag_syntax_error = ${flag_syntax_error:-0}"
	
	if [ ${flag_syntax_error:-0} == 0 ]; then
	    printf '/ECHO Sto per aggiungere in coda 1 elemento, attendere ....\n'
	    printf '/budus InsertCommandInQueueTimed(0) 8 /budus macro xdcc d %s\n' "1"
	fi
    fi
    
    debug_print "<" 'MANUAL DOWNLOAD'
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# Controllo: Verifica se lo script e' stato invocato per effettuare il
# download tramite un LINK; in base al link capisce per quale ID deve
# effettuare il download e procede di conseguenza.
if [ "$(echo "${command}" | grep -i "^http://xdcc_")" != "" ]; then
    load_config
    
    debug_print "x" 'LINK'
    
    ID=$(echo "${command}" | sed 's@^http://xdcc_@@')
    
    debug_print "*" "ID = $ID"
    
    if [ "$(echo "${ID}" | grep '^[0-9]*$')" != "" ]; then
	printf '/budus macro xdcc d %s\n' "${ID}"
    elif [ "$(echo "${ID}" | grep '^[XT][0-9]\{10\}$')" != "" ]; then
	printf '/budus macro xdcc d %s\n' "${ID}"
    elif [ "$(echo "${ID}" | grep '^CANCEL_')" != "" ]; then
	ID=$(echo "${command}" | sed 's@^http://xdcc_CANCEL_@@')
	
	debug_print "*" "ID = $ID"
	
	if [ "$(echo "${ID}" | grep '^[XT][0-9]\{10\}$')" != "" ]; then
	    printf '/budus macro xdcc c %s\n' "${ID}"
	else
	    printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O URL (%%B%s%%O) malformato.\n' "${command}"
	    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
	fi
    elif [ "$(echo "${ID}" | grep '^SEARCH_')" != "" ]; then
	ID=$(echo "${command}" | sed 's@^http://xdcc_SEARCH_@@')
	
	debug_print "*" "ID = $ID"
	
	if [ "$(echo "${ID}" | grep '^[XT][0-9]\{10\}$')" != "" ]; then
	    flag_static_find_item_in_db=0
	    find_item_in_db_by_code "${failed_db}" "${ID}" "NO_ERROR"
	    
	    debug_print "*" "flag_static_find_item_in_db = ${flag_static_find_item_in_db}"
	    
	    if [ ${flag_static_find_item_in_db:-0} != 0 ]; then
		ITEM="${find_item_in_db_result}"
		get_data_from_item
		
		printf '/budus macro xdcc s %s\n' "${item_filename}"
	    else
		printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O Codice (%%B%s%%O) scaduto; non puo'\'' essere associato ad una ricerca. Eseguire la ricerca manualmente.\n' "${ID}"
		[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
	    fi
	else
	    printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O URL (%%B%s%%O) malformato.\n' "${command}"
	    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
	fi
    else
	printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O URL (%%B%s%%O) malformato.\n' "${command}"
	[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
    fi
    
    debug_print "<" 'LINK'
    exit 0;
else
    if [ "$(echo "${command}" | grep -i "^http://")" != "" ]; then
	printf "/ECHO %%B%%C4,1ERRORE:\t%%O%%C4,1 Questo tipo di url non e' gestito da XDCC Manager.\n"
    fi
fi

#####################################################################
#____________________________________________________________________
# [FORCE]
# Controllo: Verifica se deve eseguire un Download.
if [ "$(echo "${command}" | grep -i "^[fF]$")" != "" ]; then
    load_config
    
    debug_print "x" "FORCE"

    ID=$(printf '%s\n' "${SUB_COMMAND/ -/}" | grep '^[XT][0-9]\{10\}$')
    debug_print "*" "item_code = ${SUB_COMMAND}"
    
    if [ "${ID}" != "" ]; then
	printf '/ECHO %%B%%C5,1[XDCC MANAGER]\t DOWNLOAD:%%O ID %%B%s%%O in stato di elaborazione.\n' "${ID:-INTERNAL_ERROR}"
	
	list_item_in_db "${transfer_db}" "TRASFERIMENTO"
	list_item_in_db "${request_db}" "RICHIESTA"
	list_item_in_db "${waiting_db}" "ELABORAZIONE"
	list_item_in_db "${download_queue_db}" "CODA"
	
	debug_print "*" "flag_static_find_item_in_db = ${flag_static_find_item_in_db}"
	
	flag_static_find_item_in_db=0
	find_item_in_db_by_code "${download_queue_db}" "${ID}" "NO_ERROR"
	if [ ${flag_static_find_item_in_db:-0} == 0 ]; then
	    find_item_in_db_by_code "${waiting_db}" "${ID}" "NO_ERROR"
	    if [ ${flag_static_find_item_in_db:-0} == 0 ]; then
		find_item_in_db_by_code "${request_db}" "${ID}" "NO_ERROR"
		if [ ${flag_static_find_item_in_db:-0} == 0 ]; then
		    find_item_in_db_by_code "${transfer_db}" "${ID}" "NO_ERROR"
		    if [ ${flag_static_find_item_in_db:-0} == 0 ]; then
			printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O ID %%B%s%%O non presente in Coda dei Download.\n' "${ID}"
			[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
			
			debug_print "<" "FORCE"
			exit 0;
		    else
			printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O ID %%B%s%%O in stato di trasferimento, non forzabile in questo stato.\n' "${ID}"
			[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
			
			debug_print "<" "FORCE"
			exit 0;
		    fi
		else
		    printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O ID %%B%s%%O in stato di elaborazione, non forzabile in questo stato.\n' "${ID}"
		    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
		    
		    debug_print "<" "FORCE"
		    exit 0;
		fi
	    else
		printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O ID %%B%s%%O in stato di elaborazione, non forzabile in questo stato.\n' "${ID}"
		[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
		
		debug_print "<" "FORCE"
		exit 0;
	    fi
	else
	    ITEM="${find_item_in_db_result}"
	    remove_item_from_db "${download_queue_db}" "${ITEM}"
	    remove_item_from_menu "QUEUE" "${ITEM}"
	fi
	
	item_code="${ID}"
	download_item
    else
	printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O ID inserito (%%B%s%%O) non valido.\n' "${SUB_COMMAND:-NULL}"
	[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
    fi
    
    debug_print "<" "FORCE"
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# [CANCEL]
# Controllo: Verifica se deve eseguire un Download.
if [ "$(echo "${command}" | grep -i "^[cC]$")" != "" ]; then
    load_config
    
    debug_print "x" "CANCEL"

    ID=$(printf '%s\n' "${SUB_COMMAND/ -/}" | grep '^[XT][0-9]\{10\}$')
    debug_print "*" "ID = ${SUB_COMMAND}"
    
    if [ "${ID}" != "" ]; then
	cancel_download "${ID}"
	
	[ ${USA_CODA_DEI_DOWNLOAD:-N} == "Y" ] && \
	    printf '/TIMER -refnum 2255 4 budus macro xdcc DOWNLOAD_MANAGER check_download_queue\n'
    else
	printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O ID inserito (%%B%s%%O) non valido.\n' "${SUB_COMMAND:-NULL}"
	[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
    fi
    
    debug_print "<" "CANCEL"
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# [LIST]
if [ "$(echo "${command}" | grep -i "^[lL]$")" != "" ]; then
    load_config
    
    debug_print "x" 'LIST'

    printf '/ECHO %%B%%C5,1[XDCC MANAGER]\t %%O Stato corrente della Coda dei Download.\n'
    
    list_item_in_db "${transfer_db}" "TRASFERIMENTO"
    list_item_in_db "${request_db}" "RICHIESTA"
    list_item_in_db "${waiting_db}" "ELABORAZIONE"
    list_item_in_db "${download_queue_db}" "CODA"
    
    printf '/ECHO %%B%%C5,1[XDCC MANAGER]\t %%O ********************************************************************************\n'
    
    if [ $(wc -l ${script_path}/xdcc_queue_lock | cut -f1 -d' ') -gt 0 ]; then
	printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Coda dei Download bloccata.\n'
    fi
    
    debug_print "<" 'LIST'
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# [ABORTED]
if [ "$(echo "${command}" | grep -i "^[aA]$")" != "" ]; then
    load_config
    
    debug_print "x" 'ABORTED'
    
    printf '/ECHO %%B%%C5,1[XDCC MANAGER]\t %%O Elenco download abortiti.\n'
    
    list_item_in_db "${failed_db}" "ABORTITO" "SEARCH" "REPEAT"
    
    printf '/ECHO %%B%%C5,1[XDCC MANAGER]\t %%O ********************************************************************************\n'
    
    debug_print "<" 'ABORTED'
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# [DELETE ABORTED]
if [ "$(echo "${command}" | grep -i "^[aA][xX]$")" != "" ]; then
    load_config
    
    debug_print "x" 'DELETE ABORTED'
    
    printf '/ECHO %%B%%C5,1[XDCC MANAGER]\t %%O Elenco download abortiti eliminato.\n'
    
    rm -f "${failed_db}"
    
    debug_print "<" 'DELETE ABORTED'
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# [ABORT_ALL_DOWNLOAD]
if [ "$(echo "${command}" | grep -i "^ABORT_ALL_DOWNLOAD")" != "" ]; then
    load_config
    
    debug_print "x" "ABORT_ALL_DOWNLOAD"
    
    [ ! -f "${download_queue_db}" ] && touch "${download_queue_db}"
    [ ! -f "${waiting_db}" ] && touch "${waiting_db}"
    [ ! -f "${request_db}" ] && touch "${request_db}"
    [ ! -f "${transfer_db}" ] && touch "${transfer_db}"
    
    debug_print "*" "SUB_COMMAND = ${SUB_COMMAND}"

    if [ "${SUB_COMMAND}" == "ONLY_QUEUE" ]; then
	items_db_to_delete=$(cat "${download_queue_db}" \
	    | awk -F'\t' '{print $2}' \
	    | sort \
	    | uniq)
    else
	items_db_to_delete=$(cat "${download_queue_db}" "${waiting_db}" "${request_db}" "${transfer_db}" \
	    | awk -F'\t' '{print $2}' \
	    | sort \
	    | uniq)
    fi
    
    debug_print "*" "items_db_to_delete = ${items_db_to_delete}"
    
    if [ "${items_db_to_delete}" != "" ]; then
	for item_to_delete in ${items_db_to_delete}; do
	    cancel_download ${item_to_delete} "-"
	done
	
	printf '/ECHO %%B%%C5,1[XDCC MANAGER]\t %%O Eliminati tutti i download in coda e annullati tutti quelli in elaborazione.\n'
    else
	printf '/ECHO %%B%%C8,1[XDCC MANAGER]\t %%O Non risultano download in coda o in elaborazione da annullare.\n'
    fi
    
    debug_print "<" "ABORT_ALL_DOWNLOAD"
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# [LIST_QUEUE_STATUS]
if [ "$(echo "${command}" | grep -i "^LIST_QUEUE_STATUS")" != "" ]; then
    load_config
    
    debug_print "x" "LIST_QUEUE_STATUS"
    
    printf '/ECHO %%B%%C5,1[XDCC MANAGER]\t %%O Stato salvato della Coda dei Download.\n'
    
    list_item_in_db "${download_queue_db}.saved" "CODA" "no_link_type"
    list_item_in_db "${waiting_db}.saved" "ELABORAZIONE" "no_link_type"
    list_item_in_db "${request_db}.saved" "RICHIESTA" "no_link_type"
    list_item_in_db "${transfer_db}.saved" "TRASFERIMENTO" "no_link_type"
    list_item_in_db "${repeat_db}.saved" "CRONOLOGIA" "no_link_type"
    list_item_in_db "${failed_db}.saved" "FALLIMENTI" "no_link_type"
    [ -f "${search_pattern_db}.saved" ] && printf '/ECHO %%B%%C5,1[XDCC MANAGER]\t %%O Elenco Parole Chiave salvate:\n'
    [ -f "${search_pattern_db}.saved" ] && cat "${search_pattern_db}.saved" | sort | uniq | sed 's@^@/ECHO *%C9,1%B @'
    
    printf '/ECHO %%B%%C5,1[XDCC MANAGER]\t %%O ********************************************************************************\n'
    
    debug_print "<" "LIST_QUEUE_STATUS"
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# [SAVE_QUEUE_STATUS]
if [ "$(echo "${command}" | grep -i "^SAVE_QUEUE_STATUS")" != "" ]; then
    load_config
    
    debug_print "x" "SAVE_QUEUE_STATUS"
    
    printf '/budus sendsess $focus_tab /ECHO %%B%%C3,1[XDCC MANAGER]\t SALVATAGGIO STATO DOWNLOAD:\n'
    
    save_db "${download_queue_db}.saved" "CODA"
    save_db "${waiting_db}.saved" "ELABORAZIONE"
    save_db "${request_db}.saved" "RICHIESTA"
    save_db "${transfer_db}.saved" "TRASFERIMENTO"
    save_db "${repeat_db}.saved" "CRONOLOGIA"
    save_db "${failed_db}.saved" "FALLIMENTI"
    save_db "${search_pattern_db}.saved" "RICERCHE"
    
    printf '/budus sendsess $focus_tab /ECHO %%B%%C3,1[XDCC MANAGER]\t SALVATAGGIO STATO DOWNLOAD ESEGUITO.\n'
    
    debug_print "<" "SAVE_QUEUE_STATUS"
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# [READ_QUEUE_STATUS]
if [ "$(echo "${command}" | grep -i "^READ_QUEUE_STATUS")" != "" ]; then
    load_config
    
    debug_print "x" "READ_QUEUE_STATUS"
    
    printf '/budus sendsess $focus_tab /ECHO %%B%%C3,1[XDCC MANAGER]\t RECUPERO STATO DOWNLOAD:\n'
    
    read_db "${download_queue_db}.saved" "CODA"
    read_db "${waiting_db}.saved" "ELABORAZIONE"
    read_db "${request_db}.saved" "RICHIESTA"
    read_db "${transfer_db}.saved" "TRASFERIMENTO"
    read_db "${repeat_db}.saved" "CRONOLOGIA"
    read_db "${failed_db}.saved" "FALLIMENTI"
    read_db "${search_pattern_db}.saved" "RICERCHE"
    
    printf '/budus sendsess $focus_tab /ECHO %%B%%C3,1[XDCC MANAGER]\t RECUPERO STATO DOWNLOAD ESEGUITO.\n'
    
    debug_print "<" "READ_QUEUE_STATUS"
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# [SESSION_MANAGER]
if [ "$(echo "${command}" | grep -i "^SESSION_MANAGER")" != "" ]; then
    load_config
    
    debug_print "x" 'SESSION_MANAGER'
    debug_print "*" "SUB_COMMAND = ${SUB_COMMAND}"
    
    case "${SUB_COMMAND}" in
	"NETWORK_NOT_CONNECTED")
	    item_network="${PARAMETER_1}"
	    
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Rilevati problemi per individuare la sessione appartenente al Network %%B %s%%O.\n' "${item_network}"
	    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' w
	    
	    debug_print "*" "NETWORK_NOT_CONNECTED [ ${item_network} ]"
	    ;;
	"SESSION_MISSING")
	    item_network="${PARAMETER_1}"
	    item_channel="${PARAMETER_2}"
	    
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Rilevati problemi per individuare la sessione appartenente al Network/Canale %%B %s/%s%%O.\n' "${item_network}" "${item_channel}"
	    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' w

	    debug_print "*" "SESSION_MISSING [ ${item_network}/${item_channel} ]"
	    ;;
	"SESSION_MISSING_0")
	    item_network="${PARAMETER_1}"
	    item_channel="${PARAMETER_2}"
	    
	    debug_print "*" "SESSION_MISSING_0 [ ${item_network}/${item_channel} ]"
	    ;;
	"SESSION_MISSING_1")
	    item_network="${PARAMETER_1}"
	    item_channel="${PARAMETER_2}"
	    
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Rilevati problemi per individuare la sessione appartenente al Network/Canale %%B %s/%s%%O.\n' "${item_network}" "${item_channel}"
	    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' w

	    debug_print "*" "SESSION_MISSING_1 [ ${item_network}/${item_channel} ]"
	    ;;
	*)
	    debug_print "*" "INTERNAL ERROR FOR SUB_COMMAND: ${SUB_COMMAND}"
	    ;;
    esac
    
    debug_print "<" 'SESSION_MANAGER'
    
    exit 0
fi

#####################################################################
#____________________________________________________________________
# [DOWNLOAD MANAGER]
if [ "$(echo "${command}" | grep -i "^DOWNLOAD_MANAGER")" != "" ]; then
    load_config
    
    debug_print "x" 'DOWNLOAD_MANAGER'
    debug_print "*" "SUB_COMMAND = ${SUB_COMMAND}"
    
    case "${SUB_COMMAND}" in
	"TIMER_CONNECT")
	    item_code="${PARAMETER_1}"
	    timer_call="${PARAMETER_2:-1}"
	    
	    debug_print "*" 'TIMER_CONNECT'
	    
	    [ "${item_code}" == "" ] && \
		printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE FATALE:%%O Controllo automatico della connessione fallito (NO ITEM CODE).\n' && \
		exit 1;
	    
	    flag_static_find_item_in_db=0
	    find_item_in_db_by_code "${waiting_db}" "${item_code}" "NO_ERROR"
	    if [ ${flag_static_find_item_in_db:-0} == 1 ]; then
		ITEM="${find_item_in_db_result}"
		get_data_from_item
		
		waiting_minutes_elapsed=$(($((${TIMEOUT_RICERCA} * ${timer_call})) / 60))
		debug_print "*" "waiting_minutes_elapsed = $waiting_minutes_elapsed"
		
		printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Il Download del file%%B %s%%O risulta ancora in stato di connessione dopo%%B %d%%O minuti; probabilmente sono presenti difficolta'\'' di collegamento al Network IRC.\n' "${item_filename}" "${waiting_minutes_elapsed}"
		[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' w
		if [ ${waiting_minutes_elapsed:-0} -gt 15 ]; then
		    printf '/budus sendsess $focus_tab /ECHO %%B%%C9,1[XDCC MANAGER]\t %%O Timeout raggiunto, annullato un download (%%B%s%%O) in automatico; provo con il successivo.\n' "${item_code}"
		    
		    remove_item_from_db "${connect_server_db}" "	${item_network}	"
		    cancel_download "${item_code}"
		    
		    [ ${USA_CODA_DEI_DOWNLOAD:-N} == "Y" ] && \
			printf '/TIMER -refnum 2255 4 budus macro xdcc DOWNLOAD_MANAGER check_download_queue\n'
		else
		    [ ${MANTIENI_DOWNLOAD_IN_CODA_ANCHE_DOPO_TIMEOUT:-N} == N ] && \
			printf '/budus sendsess $focus_tab /ECHO %%B%%C9,1[XDCC MANAGER]\t %%O Potrebbe essere opportuno cancellare il download ( %%Bhttp://xdcc_CANCEL_%s%%O ) e provare con un'\''altra fonte (prima, verificare se il BOTSERV ha comunicato qualcosa).\n' "${item_code}"
		    
		    timer_call=$((${timer_call} + 1))
		    printf '/TIMER -refnum 2255 %d budus macro xdcc DOWNLOAD_MANAGER TIMER_CONNECT %s %s\n' "${TIMEOUT_RICERCA:-600}" "${item_code}" "${timer_call}"
		fi
	    fi
	    ;;
	"TIMER_DCC_GET")
	    item_code="${PARAMETER_1}"
	    timer_call="${PARAMETER_2:-1}"
	    
	    debug_print "*" 'TIMER_DCC_GET'
	    
	    flag_static_find_item_in_db=0
	    find_item_in_db_by_code "${transfer_db}" "${item_code}" "NO_ERROR"
	    if [ ${flag_static_find_item_in_db:-0} == 1 ]; then
		ITEM="${find_item_in_db_result}"
		get_data_from_item
		
		[ -f "${dcc_database}" ] && is_download_waiting=$(grep -F '	QUEUED	RECV' "${dcc_database}")
		
		debug_print "*" "is_download_waiting = ${is_download_waiting}"
		
		if [ "${is_download_waiting}" == "" ]; then
		    [ -f "${dcc_database}" ] && is_download_waiting=$(grep -F '	CONNECTING	RECV' "${dcc_database}")
		    if [ "${is_download_waiting}" != "" ]; then
			flag_dcc_connecting_stall=1
		    fi
		    
		    debug_print "*" "is_download_waiting = ${is_download_waiting}"
		fi
		
		if [ "${is_download_waiting}" != "" ]; then
		    printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Il Download del file%%B %s%%O risulta ancora in stato di attesa dopo%%B %d%%O secondi dalla richiesta.\n' "${item_filename}" "${dcc_get_timer_sec}"
		    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' w
		    
		    is_download_waiting=$(echo "${is_download_waiting}" \
			| awk -F'\t' '{print "\t"$5"\t"$3"\t"}' \
			| grep -F "	${item_botserv}	")
		    
		    debug_print "*" "is_download_waiting = ${is_download_waiting}"
		    
		    if [ "$(echo "${is_download_waiting}" | grep -F "	${item_filename}	")" != "" ]; then
			if [ ${flag_dcc_connecting_stall:-0} == 0 ]; then
			    printf '/budus sendsess $focus_tab /ECHO %%B%%C9,1[XDCC MANAGER]\t %%OAccetto in automatico il file di %%B%s%%O.\n' "${item_botserv}"
			else
			    printf '/budus sendsess $focus_tab /ECHO %%B%%C9,1[XDCC MANAGER]\t %%OLa connessione con il BOT %%B%s%%O risulta in stallo, provo a sistemare la situazione ma, probabilmente, si deve intervenire manualmente.\n' "${item_botserv}"
			fi
			
			printf '/DCC GET %s\n' "${item_botserv:-ERROR}"
		    else
			dcc_filename=$(echo "${is_download_waiting}" | tail -n1 | awk -F'\t' '{print $3}')
			
			debug_print "*" "is_download_waiting = ${is_download_waiting}"
			
			if [ "${dcc_filename}" != "" ]; then
			    printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Non sono sicuro che il file %%B%s%%O sia associabile al Download con ID %%B%s%%O.\n' "${dcc_filename}" "${code_to_cancel}"
			    printf '/budus sendsess $focus_tab /ECHO %%B%%C9,1[XDCC MANAGER]\t %%OSi rende necessario gestire manualmente la connessione con %%B%s%%O tramite la finestra %%BTrasferimenti%%O.\n' "${item_botserv}"
			fi
		    fi
		    
		    printf '/budus sendsess $focus_tab /ECHO %%B%%C9,1[XDCC MANAGER]\t %%O Potrebbe essere opportuno cancellare il download ( %%Bhttp://xdcc_CANCEL_%s%%O ) e provare con un'\''altra fonte.\n' "${item_code}"
		fi
	    fi
	    ;;
	"TIMER_REQUEST")
	    item_code="${PARAMETER_1}"
	    timer_call="${PARAMETER_2:-1}"
	    
	    debug_print "*" 'TIMER_REQUEST'
	    
	    flag_static_find_item_in_db=0
	    find_item_in_db_by_code "${request_db}" "${item_code}" "NO_ERROR"
	    if [ ${flag_static_find_item_in_db:-0} == 1 ]; then
		ITEM="${find_item_in_db_result}"
		get_data_from_item
		
		waiting_minutes_elapsed=$(($((${TIMEOUT_RICERCA} * ${timer_call})) / 60))
		
		debug_print "*" "waiting_minutes_elapsed = ${waiting_minutes_elapsed}"
		
		printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Il Download del file%%B %s%%O risulta ancora in stato di richiesta dopo%%B %d%%O minuti.\n' "${item_filename}" "${waiting_minutes_elapsed}"
		[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' w
		if [ ${waiting_minutes_elapsed:-0} -gt 50 ]; then
		    if [ ${MANTIENI_DOWNLOAD_IN_CODA_ANCHE_DOPO_TIMEOUT:-N} == N ]; then
			printf '/budus sendsess $focus_tab /ECHO %%B%%C9,1[XDCC MANAGER]\t %%O Annullo il download (%%B%s%%O) in automatico, rimettendolo in coda, e provo con quello successivo.\n' "${item_code}"
			
			cancel_download "${item_code}"
			add_item_to_db "${download_queue_db}" "${ITEM}"
			add_item_to_menu "QUEUE"
			
			[ ${USA_CODA_DEI_DOWNLOAD:-N} == "Y" ] && \
			    printf '/TIMER -refnum 2255 4 budus macro xdcc DOWNLOAD_MANAGER check_download_queue\n'
		    else
			if [ ${USA_CODA_DEI_DOWNLOAD:-N} == "Y" ]; then
			    remove_item_from_db "${request_db}" "	${item_code}	"
			    remove_item_from_menu "REQUEST" "	${item_code}	"
			    
			    printf '/event listh %s:BUDUS_XDCC_DOWNLOAD: -\n' "${item_code}"
			    printf '/event listh %s:BUDUS_XDCC_START_CHECK_MD5SUM: -\n' "${item_code}"
			    printf '/event listh spcl_BUDUS_XDCC_%s -\n' "${item_code}"
			    
			    new_item_code=$(echo "${item_code}" | sed 's@^X@T@')
			    ITEM=$(echo "${ITEM}" | sed 's@	'"${item_code}"'	@	'"${new_item_code}"'	@')
			    
			    add_item_to_db "${request_db}" "${ITEM}"
			    add_item_to_menu "REQUEST"
			    
			    make_download_buduscript_sentinel "${new_item_code}" "EXIT"
			    
			    flag_static_find_item_in_db=0
			    find_item_in_db_by_code "${download_queue_db}" "X" "NO_ERROR"
			    if [ ${flag_static_find_item_in_db:-0} == 0 ]; then
				printf '/budus sendsess $focus_tab /ECHO %%B%%C9,1[XDCC MANAGER]\t %%O Timeout raggiunto per il download %%B%s%%O; lo lascio in coda.\n' "${item_code}"
				
				if [ "${FORZA_PERIODICAMENTE_DOWNLOAD_IN_STATO_DI_TIMEOUT}" == "Y" ]; then
				    printf '/TIMER -refnum 2256 %s budus macro xdcc DOWNLOAD_MANAGER check_download_queue\n' '1800'
				fi
			    else
				printf '/budus sendsess $focus_tab /ECHO %%B%%C9,1[XDCC MANAGER]\t %%O Timeout raggiunto per il download %%B%s%%O; lo lascio in coda ma procedo con quello successivo.\n' "${item_code}"
				
				printf '/TIMER -refnum 2255 4 budus macro xdcc DOWNLOAD_MANAGER check_download_queue 1\n'
			    fi
			else
			    printf '/budus sendsess $focus_tab /ECHO %%B%%C9,1[XDCC MANAGER]\t %%O Timeout raggiunto per il download %%B%s%%O; lo lascio in coda come da configurazione.\n' "${item_code}"
			    
			    remove_item_from_db "${request_db}" "	${item_code}	"
			    remove_item_from_menu "REQUEST" "	${item_code}	"
			    
			    new_item_code=$(echo "${item_code}" | sed 's@^X@T@')
			    ITEM=$(echo "${ITEM}" | sed 's@	'"${item_code}"'	@	'"${new_item_code}"'	@')
			    
			    add_item_to_db "${request_db}" "${ITEM}"
			    add_item_to_menu "REQUEST"
			fi
		    fi
		else
		    printf '/budus sendsess $focus_tab /ECHO %%B%%C9,1[XDCC MANAGER]\t %%O Potrebbe essere opportuno cancellare il download ( %%Bhttp://xdcc_CANCEL_%s%%O ) e provare con un'\''altra fonte.\n' "${item_code}"
		    
		    timer_call=$((${timer_call} + 1))
		    printf '/TIMER -refnum 2255 %d budus macro xdcc DOWNLOAD_MANAGER TIMER_REQUEST %s %s\n' "${TIMEOUT_RICERCA:-600}" "${item_code}" "${timer_call}"
		    
		    debug_print "*" "timer_call = ${timer_call}"
		fi
	    fi
	    ;;
	"JSERVER")
	    event_network="${PARAMETER_1}"
	    event_server="${PARAMETER_2}"
	    
	    debug_print "*" 'JSERVER'
	    
	    find_network_item_on_waiting=$(search_server_for_network_connection_in_db "${event_network}" "${waiting_db}" -)
	    if [ $? == 0 ]; then
		find_network_item_on_waiting=$(search_server_for_network_connection_in_db "${event_server}" "${waiting_db}" -)
		if [ $? == 0 ]; then
		    find_network_item_on_waiting=""
		else
		    event_network="${event_server}"
		fi
	    fi
	    
	    if [ "${find_network_item_on_waiting}" != "" ]; then
		flag_static_find_item_in_db=0
		find_item_in_db "${waiting_db}" "	${event_network}	"
		if [ ${flag_static_find_item_in_db:-0} == 0 ]; then
		    exit 1
		fi
		
		ITEM="${find_item_in_db_result}"
		remove_item_from_db "${waiting_db}" "${ITEM}"
		remove_item_from_menu "WAITING" "${ITEM}"
		
		download_item
	    else
		debug_print "*" 'JSERVER [CHECK REQUEST]'
		
		find_network_item_on_request=$(search_server_for_network_connection_in_db "${event_network}" "${request_db}" -)
		if [ $? == 0 ]; then
		    find_network_item_on_request=$(search_server_for_network_connection_in_db "${event_server}" "${request_db}" -)
		    if [ $? == 0 ]; then
			find_network_item_on_request=""
		    else
			event_network="${event_server}"
		    fi
		fi
		if [ "${find_network_item_on_request}" != "" ]; then
		    flag_static_find_item_in_db=0
		    find_item_in_db "${request_db}" "	${event_network}	"
		    if [ ${flag_static_find_item_in_db:-0} == 0 ]; then
			exit 1
		    fi
		    
		    debug_print "*" 'JSERVER [CHECK REQUEST] : ERROR'
		    
		    ITEM="${find_item_in_db_result}"
		    
		    printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Si e'\'' verificata una situazione anomala; risulta in stato di richiesta un ITEM che fa riferimento al Network/Canale appena connesso. Si consiglia di intervenire manualmente, ad esempio, scollegandosi da Network il cui nome sia molto simile a quello della risorsa in download.\n'
		    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' w
		    
		    remove_item_from_db "${request_db}" "${ITEM}"
		    remove_item_from_menu "REQUEST" "${ITEM}"
		    
		    add_item_to_db "${download_queue_db}" "${ITEM}"
		    add_item_to_menu "QUEUE"
		    
		    [ ${USA_CODA_DEI_DOWNLOAD:-N} == "Y" ] && \
			printf '/TIMER -refnum 2255 4 budus macro xdcc DOWNLOAD_MANAGER check_download_queue\n'
		fi
	    fi
	    ;;
	"JCHANNEL")
	    event_network="${PARAMETER_1}"
	    event_server="${PARAMETER_2}"
	    event_channel="${PARAMETER_3}"
	    
	    debug_print "*" 'JCHANNEL'
	    
	    find_network_item_on_waiting=$(search_server_for_network_connection_in_db "${event_network}" "${waiting_db}" -)
	    if [ $? == 0 ]; then
		find_network_item_on_waiting=$(search_server_for_network_connection_in_db "${event_server}" "${waiting_db}" -)
		if [ $? == 0 ]; then
		    find_network_item_on_waiting=""
		else
		    event_network="${event_server}"
		fi
	    fi
	    if [ "${find_network_item_on_waiting}" != "" ]; then
		flag_static_find_item_in_db=0
		find_item_in_db "${waiting_db}" "	${event_network}	"
		if [ ${flag_static_find_item_in_db:-0} == 0 ]; then
		    exit 1
		fi
		
		flag_static_find_item_in_db=0
		find_item_in_db "${waiting_db}" "	${event_network}	${event_channel}	"
		if [ ${flag_static_find_item_in_db:-0} == 0 ]; then
		    exit 1
		fi
		
		ITEM="${find_item_in_db_result}"
		remove_item_from_db "${waiting_db}" "${ITEM}"
		remove_item_from_menu "WAITING" "${ITEM}"
		
		download_item
	    else
		debug_print "*" 'JCHANNEL [CHECK REQUEST]'
		
		find_network_item_on_request=$(search_server_for_network_connection_in_db "${event_network}" "${request_db}" -)
		if [ $? == 0 ]; then
		    find_network_item_on_request=$(search_server_for_network_connection_in_db "${event_server}" "${request_db}" -)
		    if [ $? == 0 ]; then
			find_network_item_on_request=""
		    else
			event_network="${event_server}"
		    fi
		fi
		if [ "${find_network_item_on_request}" != "" ]; then
		    flag_static_find_item_in_db=0
		    find_item_in_db "${request_db}" "	${event_network}	"
		    if [ ${flag_static_find_item_in_db:-0} == 0 ]; then
			exit 1
		    fi
		    
		    flag_static_find_item_in_db=0
		    find_item_in_db "${request_db}" "	${event_network}	${event_channel}	"
		    if [ ${flag_static_find_item_in_db:-0} == 0 ]; then
			exit 1
		    fi
		    
		    debug_print "*" 'JCHANNEL [CHECK REQUEST] : ERROR'
		    
		    ITEM="${find_item_in_db_result}"
		    
		    printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Si e'\'' verificata una situazione anomala; risulta in stato di richiesta un ITEM che fa riferimento al Network/Canale appena connesso. Si consiglia di intervenire manualmente, ad esempio, scollegandosi da Network il cui nome sia molto simile a quello della risorsa in download.\n'
		    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' w
		    
		    remove_item_from_db "${request_db}" "${ITEM}"
		    remove_item_from_menu "REQUEST" "${ITEM}"
		    
		    add_item_to_db "${download_queue_db}" "${ITEM}"
		    add_item_to_menu "QUEUE"
		    
		    [ ${USA_CODA_DEI_DOWNLOAD:-N} == "Y" ] && \
			printf '/TIMER -refnum 2255 4 budus macro xdcc DOWNLOAD_MANAGER check_download_queue\n'
		fi
	    fi
	    ;;
	"REDIRECT")
	    event_network="${PARAMETER_1}"
	    event_server="${PARAMETER_2}"
	    event_channel="${PARAMETER_3}"
	    event_data="${PARAMETER_4}"
	    
	    if [ "${event_channel}" == '$channel' ]; then
		if [ "${event_data}" != "" ]; then
		    event_channel="${event_data}"
		else
		    event_channel=$(echo "${event_channel}" | sed 's@$channel@*SCONOSCIUTO*@')
		fi
	    fi
	    
	    debug_print "*" 'REDIRECT'
	    
	    find_network_item_on_waiting=$(search_server_for_network_connection_in_db "${event_network}" "${waiting_db}" -)
	    if [ $? == 0 ]; then
		find_network_item_on_waiting=$(search_server_for_network_connection_in_db "${event_server}" "${waiting_db}" -)
		if [ $? == 0 ]; then
		    find_network_item_on_waiting=""
		else
		    event_network="${event_server}"
		fi
	    fi
	    if [ "${find_network_item_on_waiting}" != "" ]; then
		flag_static_find_item_in_db=0
		find_item_in_db "${waiting_db}" "	${event_network}	"
		if [ ${flag_static_find_item_in_db:-0} == 0 ]; then
		    exit 1
		fi
		
		remove_item_from_db "${connect_server_db}" "	${event_network}	"
		
		printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Individuata azione di redirezione al/dal canale %%B%s%%O (network %%B%s%%O/%%B%s%%O), che risulta diverso dal previsto.\n' "${event_channel:-INTERNAL_ERROR}" "${event_network:-INTERNAL_ERROR}" "${event_server:-INTERNAL_ERROR}"
		[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' w
		printf '/budus sendsess $focus_tab /ECHO %%B%%C3,1[XDCC MANAGER]\t SUGGERIMENTO:%%O Risultano ITEM in fase di elaborazione che fanno riferimento al medesimo canale; potrebbe essere necessario intervenire manualmente, eliminandoli e procedendo manualmente con i comandi di download.\n'
		printf '/budus sendsess $focus_tab /ECHO %%B%%C3,1[XDCC MANAGER]\t %%O Chiedere la lista dei download in elaborazione (%%BXDCC -> Elenca Stato Coda dei Download%%O) e controllare tutti gli elementi che fanno riferimento a %%B%s%%O.\n' "${event_network:-INTERNAL_ERROR}"
	    fi
	    ;;
	"spcl_dcc_send_offer")
	    item_code="${PARAMETER_1}"
	    
	    dcc_nickname="${PARAMETER_2}"
	    dcc_filename="${PARAMETER_3}"
	    dcc_temp_path="${PARAMETER_4}"
	    dcc_download_path="${PARAMETER_5}"
	    
	    debug_print "*" 'spcl_dcc_send_offer'
	    
	    accept_connection
	    ;;
	"spcl_dcc_offer")
	    item_code="${PARAMETER_1}"
	    
	    dcc_nickname="${PARAMETER_2}"
	    dcc_filename="${PARAMETER_3}"
	    dcc_temp_path="${PARAMETER_4}"
	    dcc_download_path="${PARAMETER_5}"
	    
	    debug_print "*" 'spcl_dcc_offer'
	    
	    accept_connection
	    ;;
	"spcl_dcc_recv_connect")
	    item_code="${PARAMETER_1}"
	    
	    dcc_nickname="${PARAMETER_2}"
	    dcc_filename="${PARAMETER_3}"
	    
	    debug_print "*" 'spcl_dcc_recv_connect'
	    
	    check_dcc_transfer
	    ;;
	"spcl_dcc_recv_complete")
	    item_code="${PARAMETER_1}"
	    
	    dcc_nickname="${PARAMETER_2}"
	    dcc_filename_path="${PARAMETER_3}"
	    dcc_filename=$(echo "${dcc_filename_path}" | sed 's@.*/@@')
	    
	    debug_print "*" 'spcl_dcc_recv_complete'
	    
	    check_end_download
	    check_download_queue
	    ;;
	"spcl_dcc_recv_failed")
	    item_code="${PARAMETER_1}"
	    
	    dcc_nickname="${PARAMETER_2}"
	    dcc_filename_path="${PARAMETER_3}"
	    dcc_filename=$(echo "${dcc_filename_path}" | sed 's@.*/@@')
	    
	    debug_print "*" 'spcl_dcc_recv_failed'
	    
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C4,1[XDCC MANAGER]\t DOWNLOAD FALLITO   :%%O [%%B%s%%O:%%B%s%%O] => %%B%s\n' "${item_code}" "${dcc_nickname}" "${dcc_filename}"
	    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
	    
	    failed_download_manager
	    ;;
	"spcl_dcc_conection_failed")
	    item_code="${PARAMETER_1}"

	    dcc_nickname="${PARAMETER_2}"
	    dcc_type="${PARAMETER_3}"
	    dcc_strerror="${PARAMETER_4}"
	    
	    debug_print "*" 'spcl_dcc_conection_failed'
	    
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C4,1[XDCC MANAGER]\t DOWNLOAD FALLITO   :%%O [%%B%s%%O:%%B%s%%O] => %%B%s\n' "${item_code}" "${dcc_nickname}" "${dcc_strerror}"
	    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
	    
	    failed_download_manager "${dcc_strerror}"
	    ;;
	"spcl_dcc_recv_abort")
	    item_code="${PARAMETER_1}"
	    
	    dcc_nickname="${PARAMETER_2}"
	    dcc_filename_path="${PARAMETER_3}"
	    dcc_filename=$(echo "${dcc_filename_path}" | sed 's@.*/@@')
	    
	    debug_print "*" 'spcl_dcc_recv_abort'
	    
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C4,1[XDCC MANAGER]\t DOWNLOAD ABORTITO  :%%O [%%B%s%%O:%%B%s%%O] => %%B%s\n' "${item_code}" "${dcc_nickname}" "${dcc_filename}"
	    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
	    
	    failed_download_manager
	    ;;
	"spcl_dcc_stall")
	    item_code="${PARAMETER_1}"
	    
	    dcc_nickname="${PARAMETER_2}"
	    dcc_filename_path="${PARAMETER_3}"
	    dcc_filename=$(echo "${dcc_filename_path}" | sed 's@.*/@@')
	    
	    debug_print "*" 'spcl_dcc_stall'
	    
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C4,1[XDCC MANAGER]\t DOWNLOAD STALLO    :%%O [%%B%s%%O:%%B%s%%O] => %%B%s\n' "${item_code}" "${dcc_nickname}" "${dcc_filename}"
	    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' w
	    
	    failed_download_manager
	    ;;
	"check_download_queue")
	    debug_print "*" 'check_download_queue'
	    
	    check_download_queue "${PARAMETER_1}"
	    ;;
	"BOTSERV_MANUAL_REQUEST")
	    item_network="${PARAMETER_1}"
	    item_channel="${PARAMETER_2}"
	    item_ID=$(echo "${PARAMETER_3}" | grep '^[0-9]*$')
	    
	    if [ "${item_ID}" != "" ]; then
		printf '/GETSTR "FILENAME" "budus macro xdcc DOWNLOAD_MANAGER BOTSERV_FILENAME_REQUEST %s %s %s -" "Inserire il nome del file da associare all`ID %s:"\n' "${item_network:-NULL}" "${item_channel:-NULL}" "${item_ID:-NULL}" "${item_ID:-NULL}"
	    else
		printf '/ECHO %%C4,1[XDCC MANAGER]\t %%BERRORE: ID (%s) INVALIDO.%%C8,1 Deve essere composto da soli numeri.\n' "${PARAMETER_3}"
	    fi
	    ;;
	"BOTSERV_FILENAME_REQUEST")
	    item_network="${PARAMETER_1}"
	    item_channel="${PARAMETER_2}"
	    item_ID="${PARAMETER_3}"
	    item_filename="${PARAMETER_5}"
	    
	    if [ "${item_filename}" != "" ]; then
		printf '/budus cmd /ECHO %%C5,1[XDCC MANAGER]\t Selezionati exec( s,budus macro xdcc DOWNLOAD_MANAGER BOTSERV_NICKNAME_REQUEST %s %s $execnick %s %s ) BOTSERV.\n' "${item_network:-NULL}" "${item_channel:-NULL}" "${item_ID:-NULL}" "${item_filename:-NULL}"
	    else
		printf '/ECHO %%C4,1[XDCC MANAGER]\t %%BERRORE: NOME FILE INVALIDO.%%C8,1 La procedura deve necessariamente associare un nome di file valido all`ID %s.\n' "${item_ID:-NULL}"
	    fi
	    ;;
	"BOTSERV_NICKNAME_REQUEST")
	    item_network="${PARAMETER_1}"
	    item_channel="${PARAMETER_2}"
	    item_botserv="${PARAMETER_3}"
	    item_ID="${PARAMETER_4}"
	    item_filename="${PARAMETER_5}"
	    item_size="?"
	    item_command="/msg ${item_botserv} xdcc send #${item_ID}"
	    
	    printf '/ECHO %%C3,1[XDCC MANAGER]\t %%BRICHIESTA DOWNLOAD MANUALE:%%C8,01 %s%%O:%%C7,01%s%%O:%%C6,01%s%%O => ID:%%C5,01%s%%O (%%C4,01%s%%O)\n' "${item_network:-NULL}" "${item_channel:-NULL}" "${item_botserv:-NULL}" "${item_ID:-NULL}" "${item_filename:-NULL}"
	    
	    printf '%s\t%s\t%s\t%s\t%s\t%s\t%s\t\n' "${item_ID:-NULL}" "${item_network:-NULL}" "${item_channel:-NULL}" "${item_botserv:-NULL}" "${item_filename:-NULL}" "${item_size:-NULL}" "${item_command:-NULL}" > "${search_engine_db}"
	    
	    printf '/budus macro xdcc d %s\n' "${item_ID:-NULL}"
	    ;;
	"FILELIST_DOWNLOAD")
	    filelist_path="${PARAMETER_1}"
	    
	    FILELIST_DOWNLOAD_lock_file="${db_default_path}"
	    
	    if [ "${filelist_path:-NULL}" != "NULL" ]; then
		touch "${FILELIST_DOWNLOAD_lock_file}"
		
		if [ -f "${filelist_path:-NULL}" ]; then
		    printf '/ECHO %%C3,1[XDCC MANAGER]\t %%BDOWNLOAD TRAMITE ELENCO:%%C8,01 %s%%O\n' "${filelist_path:-NULL}"
		    
		    IFS_OLD="${IFS}"
		    IFS=$'\n'
		    filelist_line_count=0
		    filelist_line_ok=0
		    
		    for line in $(cat "${filelist_path:-NULL}"); do
			filelist_line_count=$((${filelist_line_count} + 1))
			
			item_ID=${filelist_line_count}
			item_network="$(echo "${line}" | awk -F'\t' '{print $1}')"
			item_channel="$(echo "${line}" | awk -F'\t' '{print $2}')"
			item_botserv="$(echo "${line}" | awk -F'\t' '{print $3}')"
			item_command="$(echo "${line}" | awk -F'\t' '{print $4}')"
			item_size="$(echo "${line}" | awk -F'\t' '{print $5}')"
			item_filename="$(echo "${line}" | awk -F'\t' '{print $6}')"
			if [ "${item_filename}" == "" ]; then
			    item_filename="${item_size}"
			    item_size="MISSING"
			fi
			
			make_search_db_from_parameters
		    done

		    if [ ${filelist_line_ok:-0} -gt 0 ]; then
			for line in $(cat "${search_engine_db}"); do
			    item_ID="$(echo "${line}" | awk -F'\t' '{print $1}')"
			    
			    printf '/budus InsertCommandInQueueTimed(0) 8 /budus macro xdcc d %s BUDUS_QUEUE_MANUAL\n' "${item_ID:-NULL}"
			done
			
			printf '/ECHO Sto per aggiungere in coda %d elementi, attendere ....\n' ${filelist_line_ok:-0}
		    elif [ ${flag_syntax_error:-0} == 1 ]; then
			rm -f "${FILELIST_DOWNLOAD_lock_file}"
		    fi
		    
		    IFS="${IFS_OLD}"
		else
		    printf '/ECHO %%C8,1[XDCC MANAGER]\t %%BDOWNLOAD TRAMITE ELENCO:%%O File ( %s ) non trovato !\n/ECHO Devi selezionare un file testuale il cui nome non deve contenere spazi.\n' "${filelist_path:-NULL}"
		fi
	    else
		if [ -f "${FILELIST_DOWNLOAD_lock_file}" ]; then
		    rm -f "${FILELIST_DOWNLOAD_lock_file}"
		else
		    printf '/ECHO %%C8,1[XDCC MANAGER]\t %%BDOWNLOAD TRAMITE ELENCO:%%O Devi selezionare un file testuale (il nome non deve contenere spazi) contenente, per ogni riga, rispettivamente e separate da carattere di tabulazione (premendo il tasto TAB "|<- ->|"), le seguenti colonne: %%B%%C8,01Network%%O%%C8,01, %%BCanale%%O%%C8,01, %%BNickname%%O (BOTSERV), %%B%%C8,01ID Risorsa%%O (detto anche "Numero di Pack"), %%B%%C8,01Dimensione%%O (facoltativa) e %%B%%C8,01Nome del File%%O.\n'
		    printf '/ECHO %%C3,1[XDCC MANAGER]\t %%BESEMPI:%%O\n'
		    printf '/ECHO %%C3,1[XDCC MANAGER]\t irc.mionetwork.org%%O|<- ->|%%C3,1#mychan%%O|<- ->|%%C3,1MyBOTServ%%O|<- ->|%%C3,1#69%%O|<- ->|%%C3,0110Mb%%O|<- ->|%%C3,1miofile.zip\n'
		    printf '/ECHO %%C3,1[XDCC MANAGER]\t irc.mionetwork.org%%O|<- ->|%%C3,1#mychan%%O|<- ->|%%C3,1MyBOTServ%%O|<- ->|%%C3,1#69%%O|<- ->|%%C3,1miofile.zip\n'
		    printf '/ECHO %%C3,1[XDCC MANAGER]\t irc.mionetwork.org%%O|<- ->|%%C3,1#mychan%%O|<- ->|%%C3,1MyBOTServ%%O|<- ->|%%C3,1/MSG MyBOServ XDCC SEND #69%%O|<- ->|%%C3,1miofile.zip\n'
		    printf '/ECHO %%C9,1[XDCC MANAGER]\t %%B   N.B.:%%O Al posto dell'\''ID puo'\'' essere specificato il comando di download, se richiesto qualcosa di alternativo alla classica sintassi:%%B /MSG <nickname> XDCC SEND #ID\n'
		fi
	    fi
	    ;;
	*)
	    debug_print "*" "INTERNAL ERROR"
	    ;;
    esac
    
    debug_print "<" 'DOWNLOAD_MANAGER'
    
    exit 0
fi

#####################################################################
#____________________________________________________________________
if [ "$(echo "${command}" | grep -i "^MESSAGE")" != "" ]; then
    load_config
    
    debug_print "x" 'MESSAGE'
    
    [ "${ESEGUI_VERIFICA_MD5SUM_SUI_FILE_SCARICATI}" == "N" ] && exit 0
    is_md5sum_installed=$(md5sum --version 2> /dev/null)
    
    if [ "${is_md5sum_installed}" == "" ]; then
	printf '/ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O Il controllo MD5SUM risulta attivo ma il software necessario per eseguire il controllo non e'\'' installato nel sistema.\n'
	[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
	printf '/ECHO %%B%%C3,1[XDCC MANAGER]\t SUGGERIMENTO:%%O Installare il software %%Bmd5sum%%O .\n'
	
	exit 0;
    fi
    
    item_code="${SUB_COMMAND}"
    dcc_completed_dir="${PARAMETER_1}"
    item_botserv="${PARAMETER_2}"
    message_data="${PARAMETER_3}"
    
    debug_print "x" "item_code = $item_code / dcc_completed_dir = $dcc_completed_dir / message_data = $message_data"
    
    find_md5sum_code=$(echo "${message_data}" | grep -o '[0-9a-z]\{32\}')
    if [ "${find_md5sum_code}" != "" ]; then
	printf '/budus sendsess $focus_tab /ECHO %%B%%C5,1[XDCC MANAGER]\t %%ORicevuto Codice MD5SUM (%%B%s%%O) per il Download %%B%s%%O.\n' "${find_md5sum_code}" "${item_code}"
	printf '/budus sendsess $focus_tab /ECHO  E'\'' stato messo nella Coda dei Controlli; saranno eseguiti quando la Coda dei Download sara'\'' vuota.\n'
	
	debug_print "*" "find_md5sum_code = $find_md5sum_code"
	
	flag_static_find_item_in_db=0
	find_item_in_db_by_code "${transfer_db}" "${item_code}" "NO_ERROR"
	if [ ${flag_static_find_item_in_db:-0} == 1 ]; then
	    item_to_check="	${dcc_completed_dir}	${find_md5sum_code}${find_item_in_db_result}"
	    add_item_to_db "${md5sum_db}" "${item_to_check}"
	else
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O Impossibile recuperare informazioni sul trasferimento %%B%s%%O.\n' "${item_code:-INTERNAL_ERROR}"
	    [ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' e
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Se il problema persiste, si consiglia di contattare UDA'\''Software.\n'
	fi
    else
	is_annoying_message=$(echo "${message_data}" | grep -iF 'limit' | grep -iF 'band' | grep -iF -e 'pack' -e 'pacc')
	is_pending_message=$(echo "${message_data}" | grep -iF 'dcc pending')
	
	if [ "${MESSAGGI_BOTSERV_SOLO_NELLA_FINESTRA_RELATIVA:-N}" == "N" ]; then
	    if [ "${is_annoying_message}" != "" ]; then
		printf '/ECHO %%B%%C8,1[XDCC MANAGER]\t %%OSe e'\'' stato comunicato un errore, potrebbe essere necessario eliminare/ripetere il Download manualmente, tramite il menu XDCC.\n'
	    elif [ "${is_pending_message}" != "" ]; then
		printf '/budus sendsess $focus_tab /ECHO %%B%%C6,1[XDCC MANAGER]\t %%ORicevuto messaggio (%%B%s%%O) per il Download %%B%s%%O dal BOTSERV %%B%s%%O.\n' "${message_data}" "${item_code}" "${item_botserv}"
		[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' m
		
		flag_static_find_item_in_db=0
		find_item_in_db_by_code "${request_db}" "${item_code}" "NO_ERROR"
		if [ ${flag_static_find_item_in_db:-0} == 1 ]; then
		    printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t %%OProbabilmente il BOTSERV chiede di accettare una connessione che, per problemi ignoti, non risulta partita; provo a correggere il problema in automatico, ma consiglio di controllare (in genere si tratta di BOTSERV difettosi).\n'
		    
		    printf '/DCC GET %s\n' "${item_botserv:-ERROR}"
		    printf '/DCC\n'
		else
		    printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t %%OProbabilmente il BOTSERV chiede di accettare una connessione che, per problemi ignoti, non risulta partita tuttavia, non risultando in coda (in stato di richiesta), evito di elaborarla. Intervenire manualmente, se necessario.\n'
		fi
	    else
		printf '/budus sendsess $focus_tab /ECHO %%B%%C6,1[XDCC MANAGER]\t %%ORicevuto messaggio (%%B%s%%O) per il Download %%B%s%%O dal BOTSERV %%B%s%%O.\n' "${message_data}" "${item_code}" "${item_botserv}"
		[ ${EMETTI_AVVISI_ACUSTICI_DI_AVVISO:-N} == Y ] && printf '/budus PlaySound() %c\n' m
		printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t %%OSe e'\'' stato comunicato un errore, potrebbe essere necessario eliminare/ripetere il Download manualmente, tramite il menu XDCC.\n'
	    fi
	else
	    if [ "${is_annoying_message}" != "" ]; then
		printf '/ECHO %%B%%C8,1[XDCC MANAGER]\t %%OSe e'\'' stato comunicato un errore, potrebbe essere necessario eliminare/ripetere il Download manualmente, tramite il menu XDCC.\n'
	    elif [ "${is_pending_message}" != "" ]; then
		printf '/ECHO %%B%%C6,1[XDCC MANAGER]\t %%ORicevuto messaggio (%%B%s%%O) per il Download %%B%s%%O dal BOTSERV %%B%s%%O.\n' "${message_data}" "${item_code}" "${item_botserv}"
		
		flag_static_find_item_in_db=0
		find_item_in_db_by_code "${request_db}" "${item_code}" "NO_ERROR"
		if [ ${flag_static_find_item_in_db:-0} == 1 ]; then
		    printf '/ECHO %%B%%C8,1[XDCC MANAGER]\t %%OProbabilmente il BOTSERV chiede di accettare una connessione che, per problemi ignoti, non risulta partita; provo a correggere il problema in automatico, ma consiglio di controllare (in genere si tratta di BOTSERV difettosi).\n'
		    
		    printf '/DCC GET %s\n' "${item_botserv:-ERROR}"
		    printf '/DCC\n'
		else
		    printf '/ECHO %%B%%C8,1[XDCC MANAGER]\t %%OProbabilmente il BOTSERV chiede di accettare una connessione che, per problemi ignoti, non risulta partita tuttavia, non risultando in coda (in stato di richiesta), evito di elaborarla. Intervenire manualmente, se necessario.\n'
		fi
	    else
		printf '/ECHO %%B%%C6,1[XDCC MANAGER]\t %%ORicevuto messaggio (%%B%s%%O) per il Download %%B%s%%O dal BOTSERV %%B%s%%O.\n' "${message_data}" "${item_code}" "${item_botserv}"
		printf '/ECHO %%B%%C8,1[XDCC MANAGER]\t %%OSe e'\'' stato comunicato un errore, potrebbe essere necessario eliminare/ripetere il Download manualmente, tramite il menu XDCC.\n'
	    fi
	fi
    fi
    
    debug_print "<" 'MESSAGE'
    
    exit 0
fi

#####################################################################
#____________________________________________________________________
if [ "$(echo "${command}" | grep -i "^FORK_CHECK_MD5SUM")" != "" ]; then
    IFS_OLD=${IFS}
    IFS=$'\n'
    
    [ -f "${temp_md5sum_output}" ] && rm -vf "${temp_md5sum_output}"
    touch "${temp_md5sum_output}.tmp"
    
    clear
    cat<<EOF
********************************************************************************
*                                                                              *
*                                  ATTENZIONE                                  *
*                                                                              *
* NON CHIUDERE QUESTA FINESTRA PRIMA CHE L'ELABORAZIONE SIA CONCLUSA.          *
* LA FINESTRA SI CHIUDERA' AUTOMATICAMENTE.                                    *
*                                                                              *
* NON LANCIARE ALTRI COMANDI BUDUSCRIPT FINO A QUANDO QUESTA FINESTRA NON SI   *
* E' CHIUSA, PER EVITARE MALFUNZIONAMENTI.                                     *
*                                                                              *
********************************************************************************
EOF
    sleep 3
    printf 'Controllo dei codici MD5SUM dei files scaricati da XChat tramite XDCC MANAGER.\n\n'
    
    md5sum_item=$(get_first_item_from_db "${md5sum_db}" "NO_ERROR")
    
    if [ "${md5sum_item}" != "" ]; then
	[ -f "${cache_md5sum_db}" ] && flag_cache_md5sum_db="Y"
	
	while [ "${md5sum_item}" != "" ]; do
	    xchat_dcc_completed_dir=$(echo "${md5sum_item}" | awk -F'\t' '{print $2}')
	    check_md5sum_code=$(echo "${md5sum_item}" | awk -F'\t' '{print $3}')
	    
	    md5sum_item_code=$(echo "${md5sum_item}" | awk -F'\t' '{print $4}')
	    md5sum_item_network=$(echo "${md5sum_item}" | awk -F'\t' '{print $6}')
	    md5sum_item_channel=$(echo "${md5sum_item}" | awk -F'\t' '{print $7}')
	    md5sum_item_botname=$(echo "${md5sum_item}" | awk -F'\t' '{print $8}')
	    md5sum_item_filename=$(echo "${md5sum_item}" | awk -F'\t' '{print $9}')
	    
	    printf '* Immagazzinamento della directory %s .\n' "${xchat_dcc_completed_dir}"
	    
	    xdcc_downloaded_file_list=$(find "${xchat_dcc_completed_dir}" -type f -printf '%TY%Tm%Td%TH%TM%TS\t%s\t%p\t%f\t\n')
	    
	    for xdcc_downloaded_file_data in ${xdcc_downloaded_file_list}; do
		xdcc_downloaded_file_name=$(echo "${xdcc_downloaded_file_data}" | awk -F'\t' '{print $4}')
		xdcc_downloaded_file_md5sum_code=""
		
		if [ "${flag_cache_md5sum_db:-N}" == "Y" ]; then
		    xdcc_downloaded_file_data_cache=$(grep -F "${xdcc_downloaded_file_data}" "${cache_md5sum_db}")
		    if [ "${xdcc_downloaded_file_data_cache}" != "" ]; then
			flag_xdcc_downloaded_file_md5sum_code_cached=1
			xdcc_downloaded_file_md5sum_code=$(echo "${xdcc_downloaded_file_data_cache}" | awk -F'\t' '{print $5}')
			printf '** Ricavo il codice del file %s della cache [%s].\n' "${xdcc_downloaded_file_name}" "${xdcc_downloaded_file_md5sum_code}"
		    fi
		fi
		
		if [ "${xdcc_downloaded_file_md5sum_code}" == "" ]; then
		    printf '** Calcolo il codice del file %s .\n' "${xdcc_downloaded_file_name}"
		    
		    xdcc_downloaded_file_path=$(echo "${xdcc_downloaded_file_data}" | awk -F'\t' '{print $3}')
		    xdcc_downloaded_file_md5sum_code=$(md5sum "${xdcc_downloaded_file_path}" | cut -f1 -d' ')
		fi
		
		if [ ${flag_xdcc_downloaded_file_md5sum_code_cached:-0} == 0 ]; then
		    flag_cache_md5sum_db="Y"
		    printf '%s\t%s\n' "${xdcc_downloaded_file_data}" "${xdcc_downloaded_file_md5sum_code:-ERROR}" >> "${cache_md5sum_db}"
		fi
		
		if [ ${check_md5sum_code:-X} == ${xdcc_downloaded_file_md5sum_code:-Y} ]; then
		    flag_md5sum_code_verified=1
		    if [ ${md5sum_item_filename:-X} == ${xdcc_downloaded_file_name:-Y} ]; then
			printf '** Codice MD5SUM [ %s ] associabile.\n*** Download con ID %s associato al file %s verificato.\n' "${check_md5sum_code:-INTERNAL_ERROR}" "${md5sum_item_code:-INTERNAL_ERROR}" "${md5sum_item_filename:-INTERNAL_ERROR}"
			printf '/budus sendsess $focus_tab /ECHO %%B%%C3,1[XDCC MANAGER]\t%%O MD5SUM OK     : ID %s -> %s:%s:%s = %s\n' "${md5sum_item_code:-INTERNAL_ERROR}" "${md5sum_item_network:-INTERNAL_ERROR}" "${md5sum_item_channel:-INTERNAL_ERROR}" "${md5sum_item_botname:-INTERNAL_ERROR}" "${xdcc_downloaded_file_name:-INTERNAL_ERROR}" >> "${temp_md5sum_output}.tmp"
		    else
			printf '** Codice MD5SUM [ %s ] associabile.\n*** Download con ID %s associato al file %s verificato.\n' "${check_md5sum_code:-INTERNAL_ERROR}" "${md5sum_item_code:-INTERNAL_ERROR}" "${md5sum_item_filename:-INTERNAL_ERROR}"
			printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t%%O MD5SUM INCERTO : ID %s -> %s:%s:%s = %s != %s\n' "${md5sum_item_code:-INTERNAL_ERROR}" "${md5sum_item_network:-INTERNAL_ERROR}" "${md5sum_item_channel:-INTERNAL_ERROR}" "${md5sum_item_botname:-INTERNAL_ERROR}" "${xdcc_downloaded_file_name:-INTERNAL_ERROR}" "${md5sum_item_filename:-INTERNAL_ERROR}" >> "${temp_md5sum_output}.tmp"
		    fi
		fi
	    done
	    
	    if [ ${flag_md5sum_code_verified:-0} == 0 ]; then
		printf '** Codice MD5SUM [ %s ] non associabile a nessun file scaricato.\n*** Download con ID %s fallito.\n' "${check_md5sum_code:-INTERNAL_ERROR}" "${md5sum_item_code:-INTERNAL_ERROR}"
		printf '/budus sendsess $focus_tab /ECHO %%B%%C4,1[XDCC MANAGER]\t%%O MD5SUM FALLITO : ID %s -> %s:%s:%s = %s\n' "${md5sum_item_code:-INTERNAL_ERROR}" "${md5sum_item_network:-INTERNAL_ERROR}" "${md5sum_item_channel:-INTERNAL_ERROR}" "${md5sum_item_botname:-INTERNAL_ERROR}" "${md5sum_item_filename:-INTERNAL_ERROR}" >> "${temp_md5sum_output}.tmp"
	    fi
	    flag_md5sum_code_verified=0
	    
	    md5sum_item=$(get_first_item_from_db "${md5sum_db}" "NO_ERROR")
	done
    else
	printf '/budus sendsess $focus_tab /ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O Problema nella gestione del Database relativo all'\''MD5SUM.\n' "${database:-INTERNAL_ERROR}"
	printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Se il problema persiste, si consiglia di contattare UDA'\''Software.\n'
    fi
    
    sleep 8
    [ -f "${temp_md5sum_output}.tmp" ] && mv -f "${temp_md5sum_output}.tmp" "${temp_md5sum_output}"
    
    IFS=${IFS_OLD}
    
    exit 0
fi

#####################################################################
#____________________________________________________________________
# Controllo: Verifica se il controllo md5sum e' terminato.
if [ "${command}" == "CHECK_MD5SUM" ]; then
    debug_print "x" 'CHECK_MD5SUM'
    
    if [ -f "${temp_md5sum_output}" ] && [ -f "${temp_md5sum_output}.tmp" ]; then
	printf '/budus sendsess $focus_tab /ECHO %%C4,1[XDCC MANAGER]\t%%O Controllo MD5SUM non partito, probabile esecuzione di processi multipli, tento un reset della situazione.\n' "${download_code}"
	
	echo "/EXEC xterm -e ${0} \"${database}\" \"${dcc_database}\" \"${server}\" FORK_CHECK_MD5SUM"
	echo "/TIMER -refnum 2255 16 budus pipe_script_silent ${0} \"${database}\" \"${dcc_database}\" \"${server}\" CHECK_MD5SUM"
	
	debug_print "<" 'CHECK_MD5SUM :: 1'
	
	exit 1;
    fi
    
    if [ -f "${temp_md5sum_queue}" ] || [ -f "${temp_md5sum_output}.tmp" ]; then
	${0} "${database}" "${dcc_database}" "${server}" CHECK_MD5SUM
    else
	cat "${temp_md5sum_output}"
	rm -f "${temp_md5sum_output}"
    fi
    
    debug_print "<" 'CHECK_MD5SUM'
    
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# Controllo: Pulisce la lista delle ricerche effettuate.
if [ "${command}" == "CLEAN_REPEAT_DB" ]; then
    debug_print "x" 'CLEAN_REPEAT_DB'
    
    if [ ! -f "${repeat_db}" ]; then
	printf '/budus sendsess $focus_tab /ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O Impossibile svuotare la cronologia.\n'
    else
	current_repeat_db=$(cat "${repeat_db}")
	
	IFS_OLD=${IFS}
	IFS=$'\n'
	for ITEM in ${current_repeat_db}; do
	    get_data_from_item
	    printf '/ECHO %%B%%C11,1[XDCC MANAGER]\t %13s:%%O %%C3%%B%s%%O => %%C7%%B%s%%O [%%C4%%B%s%%O:%%C5%%B%s%%O:%%C6%%B%s%%O].\n' "RIMOSSO" "${item_code}" "${item_filename}" "${item_network}" "${item_channel}" "${item_botserv}"
	    
	    remove_item_from_db "${repeat_db}" "${ITEM}"
	    remove_item_from_menu "REPEAT" "${ITEM}"
	    
	    flag_deleted_search_pattern=1
	done
	IFS=${IFS_OLD}
	
	[ ${flag_deleted_search_pattern:-0} == 1 ] && \
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t Cronologia pulita.\n' || \
	    printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Cronologia vuota.\n'
    fi
    
    debug_print "<" 'CLEAN_REPEAT_DB'
    
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# Controllo: Pulisce la lista delle ricerche effettuate.
if [ "${command}" == "CLEAN_SEARCH_DB" ]; then
    debug_print "x" 'CLEAN_SEARCH_DB'
    
    if [ -f "${search_pattern_db}" ]; then
	debug_print "*" 'LOAD SEARCH PATTERN DB'
	
	IFS_OLD=${IFS}
	IFS=$'\n'
	for search_pattern in $(cat "${search_pattern_db}"); do
	    flag_deleted_search_pattern=1
	    
	    debug_print "*" "${search_pattern}"
	    
	    cat<<EOF
/MENU DEL "XDCC/Ripeti Ricerca/${search_pattern}"
/ECHO DELETED: XDCC -> Ripeti Ricerca -> ${search_pattern}
EOF
	done
	IFS=${IFS_OLD}
    fi
    
    [ ${flag_deleted_search_pattern:-0} == 1 ] && \
	rm "${search_pattern_db}" && \
	printf '/budus sendsess $focus_tab /ECHO %%B%%C8,1[XDCC MANAGER]\t AVVERTIMENTO:%%O Lista Risorse Cercate eliminata.\n' || \
	printf '/budus sendsess $focus_tab /ECHO %%B%%C4,1[XDCC MANAGER]\t ERRORE:%%O Impossibile svuotare Lista delle risorse cercate.\n'
    
    debug_print "<" 'CLEAN_SEARCH_DB'
    
    exit 0;
fi

#####################################################################
#____________________________________________________________________
# Stampa la guida.
[ "${database}" != "LIBRARY" ] && print_help